<?xml version="1.0" encoding="UTF-8"?>
<!--?xml-stylesheet type="text/xsl" href="K:\R9-1-1\web\stylesheets\refLetter.xslt"?-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:btr="http://www.show.scot.nhs.uk/isd/BackToReferrer" xmlns:gen="http://www.show.scot.nhs.uk/isd/General" xmlns:msxsl="urn:schemas-microsoft-com:xslt" xmlns:user="http://www.sci.scot.nhs.uk" exclude-result-prefixes="user msxsl">
	<xsl:output method="html" version="1.0" encoding="iso-8859-1" indent="yes"/>
	<xsl:variable name="default_blank" select="'-'"/>
	<msxsl:script language="JScript" implements-prefix="user"><![CDATA[
		
		function GetMonth(strMonthNumber)
		{
			var strMonth;
			
			switch (strMonthNumber) {
				case "01" :
					strMonth = "Jan";
					break;
				case "02" :
					strMonth = "Feb";
					break;
				case "03" :
					strMonth = "Mar";
					break;
				case "04" :
					strMonth = "Apr";
					break;
				case "05" :
					strMonth = "May";
					break;
				case "06" :
					strMonth = "Jun";
					break;
				case "07" :
					strMonth = "Jul";
					break;
				case "08" :
					strMonth = "Aug";
					break;
				case "09" :
					strMonth = "Sep";
					break;
				case "10" :
					strMonth = "Oct";
					break;
				case "11" :
					strMonth = "Nov";
					break;
				case "12" :
					strMonth = "Dec";
					break; 
				default :
					strMonth = "   ";
			} 
			return(strMonth);
		}
		
		function FormatText(strTextToFormat)
		{
			var strOut = HTMLEncode(strTextToFormat);
			return FormatLineBreaks(strOut);
		}

		function HTMLEncode(strTextToCode)
		{
			var strOut = strTextToCode.replace(/</g,'&lt;');
			strOut = strOut.replace(/>/g,'&gt;');
			strOut = strOut.replace(/£/g,'&pound;');
			return strOut;
		}
		
		function FormatLineBreaks(strTextToFormat)
		{
			var strOut = strTextToFormat.replace(/\r\n/g,'<br/>');
			strOut = strOut.replace(/\r/g, '<br/>');
			strOut = strOut.replace(/\n/g, '<br/>');
			return strOut;
		}
		
		function IsDate(strValue)
		{
			return(!isNaN(new Date(strValue)));  
		}
		
		function UnambiguousDate(strAmbiguousDate)
		{
			 var dteDate;
			 var strDay, strMonth, strYear, strDate;
			
			 // Garaunteed formats
			 strDate = new String(strAmbiguousDate);
			 strYear = strDate.substring(0,4);  
			 strMonth = strDate.substring(5,7);
			 strDay = strDate.substring(8,10);
			
			 if (IsDate(new Date(strYear,strMonth,strDay)))
			 {
				 return(strDay + "-" + GetMonth(strMonth) + "-" + strYear);
			 }
		}
		
		function IsNumeric(str)
		{
			for (var i=0; i < str.length; i++)
			{
				var ch = str.substring(i, i+1)
				if( ch < "0" || ch>"9" || str.length == null)
				{
					return (false);
				}     
			}
			return (true);
		}
		
		function IsTime(strTimeToCheck)
		{
			var strHour;
			var strMinute;
			var strSecond;
			var lFirstColon;
			var lSecondColon;
			var arrMask = new Array(4);
			var lCount;
			var bValidated;
			var strTime;
			var bIsTime;
			var lValMask;
			
			bIsTime = true;		
			strTime = new String(strTimeToCheck);
			
			arrMask[0] = new String( "9:99");
			arrMask[1] = new String("99:99");
			arrMask[2] = new String("9:99:99");
			arrMask[3] = new String("99:99:99");
			bValidated = false;
			
			for(lCount = 0; lCount < 4;  lCount++)
			{
				  // the mask needs to be the same size as the time
				 if(arrMask[lCount].length == strTime.length)
				 {
					// check the mask
					bValidated = ValidateMask(arrMask[lCount],  strTime);
					if(bValidated)
					{
						lValMask = arrMask[lCount];
						break;
					}
				 }
			}
			
			if(bValidated)
			{
				//based on the mask check that the hours, minutes and seconds are okay (00:00:00-23:59:59)
				
				//get the colons
				lFirstColon = arrMask[lCount].indexOf(":");
				
				if ((lCount == 2) || (lCount == 3))
					lSecondColon = arrMask[lCount].indexOf(":", lFirstColon + 1);
				else
					lSecondColon = 0;
				
				//get the hours
				strHour = strTime.substr(0,lFirstColon);
				bIsTime = ValidateTimeLimit(strHour, 23);
				
				// get the minutes
				strMinute = strTime.substr(lFirstColon + 1, 2);
				bIsTime = ValidateTimeLimit(strMinute, 59);
				
				if(lSecondColon)
				{
					// get the seconds
					strSecond = strTime.substr(lSecondColon + 1, 2);	
					bIsTime = ValidateTimeLimit(strSecond, 59);
				}
			}	
			else
			{
				bIsTime = false;
			}
			return(bIsTime);
		}
		
		function ValidateTimeLimit(strTimeElement, lConstraint)
		{	
		   var bValidateTimeLimit; 
			
		   bValidateTimeLimit = true;
		   if (IsNumeric(strTimeElement))
		   {
			  if (!(strTimeElement <= lConstraint))
				 bValidateTimeLimit = false;
		   }		
		   else
			  bValidateTimeLimit = false;
			
		   return(bValidateTimeLimit);
		}
		
		function ValidateMask(strValidateMask, strValidateTime)
		{
			var bValidated;
			var strMask;
			var strTime
			
			strMask = new String(strValidateMask);
			strTime = new String(strValidateTime);
			
			bValidated = true;
			for(var lCount = 1; lCount < strTime.length + 1; lCount++)
			{  
				if((strMask.substr(lCount, 1) == "9"))  
				{  
					 if(!(IsNumeric(strTime.substr(lCount, 1))))
					 {
						bValidated = false;
						break;
					 }
				}	
				else
				{
					 if (strMask.substr(lCount, 1) == ":")
					 {  
						if(!(strMask.substr(lCount, 1) == strTime.substr(lCount, 1)))
						{
						   bValidated = false;
						   break;
						}
					 }  
				}
			}					
			return(bValidated);
		}
		
		function UnambiguousDateShortTime(p_dteDate, p_strDefault)
		{
			var strTempDate, strTempTime;
			var lSpace;
			var strUnambiguousDateShortTime;
			var strDate = new String(p_dteDate);
			var strDefault = new String(p_strDefault);
			var dteTempDate = new Date(p_dteDate);
			
			strUnambiguousDateShortTime = strDefault;
			
			strDate.replace( "T", " ");
			
			if(strDate.lenth)
			{
				if (IsDate(strDate))
					strUnambiguousDateShortTime = UnambiguousDate(strDate, strDefault) + " " + dteTempDate.getDay() + "-" + dteTempDate.getMonth() + dteTempDate.getYear();
				else
				{
					 lSpace = strDate.indexOf(" ");
					 strTempDate = strDate.substr(0,strDate.indexOf(" "));
					 strTempTime = strDate.substr(strDate.indexOf(" ") + 1);
					 
					 if(IsDate(strTempDate)) 
					 {
						if(IsTime(strTempTime))
						   strUnambiguousDateShortTime = UnambiguousDate(strTempDate, strDefault) + " " 
						   +   dteTempDate.getDay() + "-" + dteTempDate.getMonth() + dteTempDate.getYear();
						else
							strUnambiguousDateShortTime = UnambiguousDate(strTempDate, strDefault) + " " + strTempTime;
					}
				}
			} 	    
			return(strUnambiguousDateShortTime);  
		}
		
	]]></msxsl:script>
	<xsl:template match="btr:BackToReferrerDocument">
		<div style="width:98%;font-family: Tahoma, Arial, Verdana, Geneva, Helvetica, sans-serif;font-size: 12px;">
			<xsl:apply-templates select="btr:MessageDataBtr/btr:PatientDemographics" mode="PatientBanner"/>
			<table style="vertical-align: top;font-size: 12px;">
					<tr>
						<td style="width: 33%;vertical-align: top;">
							<xsl:apply-templates select="btr:MessageDataBtr/btr:PatientAdministrationBtr/btr:ReferredBackTo/gen:HcpName" mode="FullName"/><br/>
							<xsl:apply-templates select="btr:MessageDataBtr/btr:PatientAdministrationBtr/btr:ReferredBackTo/gen:EmployingOrganisation/gen:OrganisationName"/><br/>
							<xsl:apply-templates select="btr:MessageDataBtr/btr:PatientAdministrationBtr/btr:ReferredBackTo/gen:EmployingOrganisation/gen:OrganisationAddress"/>
						</td>
						<td style="width: 43%;text-align: center;vertical-align: top;"><h1 style="margin: 0px;font-size: 18px;">Referral Feedback Letter</h1><h2 style="margin-top: 0px;font-size: 16px;color: #000066;">Medical In Confidence</h2></td>
					</tr>
			</table>
			<p>Dear <xsl:apply-templates select="btr:MessageDataBtr/btr:PatientAdministrationBtr/btr:ReferredBackTo/gen:HcpName" mode="AbbreviatedName"/>,</p>
			<p>You recently referred the above patient to the <xsl:value-of select="//btr:MessageDataBtr/btr:PatientAdministrationBtr/btr:OriginalReferralDetails/btr:ReferredToService"/>.</p>
			<xsl:apply-templates select="btr:MessageDataBtr/btr:PatientAdministrationBtr/btr:ReferredBackReason/btr:PrimaryReason"/>
			<xsl:apply-templates select="btr:MessageDataBtr/btr:PatientAdministrationBtr/btr:ReferredBackReason/btr:ClinicalReasons"/>
			<xsl:apply-templates select="btr:MessageDataBtr/btr:PatientAdministrationBtr/btr:ReferredBackReason/btr:TreatmentRecommendations"/>
			<xsl:apply-templates select="btr:MessageDataBtr/btr:PatientAdministrationBtr/btr:ReferredBackReason/btr:PossibleAlternativeService"/>
			<xsl:apply-templates select="btr:MessageDataBtr/btr:PatientAdministrationBtr/btr:ReferredBackReason/btr:FurtherInformationRequired"/>
			<xsl:apply-templates select="btr:MessageDataBtr/btr:PatientAdministrationBtr/btr:ReferredBackReason/btr:GenericReasons/btr:GenericReasonInstance"/>
			<p>If you would like to discuss this decision then please contact me on the details below</p>
			<xsl:apply-templates select="btr:MessageDataBtr/btr:PatientAdministrationBtr/btr:ReferredBackBy"/>
		</div>
	</xsl:template>
<!-- Output the patient banner -->
	<xsl:template match="btr:PatientDemographics" mode="PatientBanner">
		<table style="width:100%;vertical-align: top;border: 1px solid black;margin-bottom: 40px;font-size: 12px;">
				<tr style="background-color: #E0E0E0;">
					<td style="width: 40%;font-weight: bold;font-size: 1.1em;"><xsl:apply-templates select="gen:PatientName[gen:NameType='Current Name']" mode="PatientBanner"/></td>
					<td style="width: 15%"><i>Sex: </i><xsl:apply-templates select="gen:Sex"/></td>
					<td style="width: 20%"><i>DoB: </i><xsl:apply-templates select="gen:DateOfBirth"/></td>
					<td style="width: 25%;text-align: right;"><i>CHI: </i><xsl:value-of select="gen:PatientId[gen:IdScheme='CHI']/gen:IdValue"/></td>
				</tr>
				<tr>
					<td style="vertical-align: top;"><xsl:apply-templates select="gen:PatientAddress[gen:AddressType='Current Residence']"/></td>
					<td style="vertical-align: top;" colspan="2"><xsl:for-each select="gen:PatientTelecom"><xsl:apply-templates select="."/></xsl:for-each></td>
					<td style="text-align: right;vertical-align: top;">Unique Care Pathway Number<br/><xsl:value-of select="//btr:DocumentData/gen:UniqueCarePathwayNumber"/></td>
				</tr>
		</table>
	</xsl:template>
	<xsl:template match="gen:PatientName" mode="PatientBanner">
		<xsl:if test="gen:StructuredName">
			<xsl:value-of select="gen:StructuredName/gen:FamilyName"/><xsl:text>, </xsl:text><xsl:value-of select="gen:StructuredName/gen:GivenName"/><xsl:if test="gen:StructuredName/gen:Title"><xsl:text> (</xsl:text><xsl:value-of select="gen:StructuredName/gen:Title"/>)</xsl:if>
		</xsl:if>
		<xsl:if test="gen:UnstructuredName">
			<xsl:value-of select="gen:UnstructuredName"/>
		</xsl:if>
	</xsl:template>
	<!-- Output the patient sex -->
	<xsl:template match="gen:Sex">
		<xsl:choose>
			<xsl:when test="starts-with(., 'M')">Male</xsl:when>
			<xsl:when test="starts-with(.,'F')">Female</xsl:when>
			<xsl:otherwise>Not Specified</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!-- Output the patient's Date of Birth -->
	<xsl:template match="gen:DateOfBirth">
		<xsl:call-template name="format_text">
			<xsl:with-param name="date"><xsl:value-of select="."/></xsl:with-param>
		</xsl:call-template>
	</xsl:template>
	<!-- Output the Referred Back By Details -->
	<xsl:template match="btr:ReferredBackBy">
		<xsl:if test="btr:ReferredBackByGp">
			<xsl:apply-templates select="btr:ReferredBackByGp/gen:HcpName" mode="FullName"/><br/>
			<xsl:apply-templates select="btr:ReferredBackByGp/gen:EmployingOrganisation/gen:OrganisationName"/><br/>
			<xsl:apply-templates select="btr:ReferredBackByGp/gen:EmployingOrganisation/gen:OrganisationAddress"/>
			<xsl:for-each select="btr:ReferredBackByGp/gen:HcpTelecom"><xsl:apply-templates select="."/></xsl:for-each>
		</xsl:if>
		<xsl:if test="btr:ReferredBackByParty">
			<xsl:apply-templates select="btr:ReferredBackByParty/btr:ReferredBackByHcp/gen:HcpName" mode="FullName"/><br/>
			<xsl:apply-templates select="btr:ReferredBackByParty/btr:ReferredBackByOrg/gen:OrganisationName"/><br/>
			<xsl:apply-templates select="btr:ReferredBackByParty/btr:ReferredBackByOrg/gen:OrganisationAddress"/>
			<xsl:for-each select="btr:ReferredBackByParty/btr:ReferredBackByOrg/gen:OrganisationTelecom"><xsl:apply-templates select="."/></xsl:for-each>
		</xsl:if>
	</xsl:template>
	<!-- Output the primary reason -->
	<xsl:template match="btr:PrimaryReason">
		<xsl:if test="text()='Clinically Unsuitable'">
			<p>We are unable to accept this referral at this time as from the information provided in the referral letter your patient does not appear likely to beneft from this service at this time.</p>
		</xsl:if>
		<xsl:if test="text()='Further Information Required'">
			<p>We are unable to accept this referral at this time as we require further information about your patient and their management before we can decide how best to meet your patient's need(s) e.g. test, clinical appointment, procedure.</p>
		</xsl:if>
		<xsl:if test="text()='Referrer to Treat / Manage'">
			<p>We are unable to accept this referral at this time as your patient would appear to be likely to benefit from further treatment in primary care (as outlined in the relevant treatment pathway).</p>
		</xsl:if>
		<xsl:if test="text()='Alternative Service Recommended'">
			<p>We are unable to accept this referral as we believe that there is a more appropriate service that should see / treat your patient. Please see below for additional details.</p>
		</xsl:if>
	</xsl:template>
	<xsl:template match="btr:ClinicalReasons">
		<hr/>
		<p>Your patient does not meet the access criteria for this serice for the following reasons
		<xsl:if test="btr:UnsuitableBMI | btr:UnsuitableBP | btr:UnsuitableAge | btr:OtherReason">
			<ul>
				<xsl:if test="btr:UnsuitableBMI='true'">
					<li>The patient's BMI is unsuitable</li>
				</xsl:if>
				<xsl:if test="btr:UnsuitableBP='true'">
					<li>The patient's Blood Pressure is unsuitable</li>
				</xsl:if>
				<xsl:if test="btr:UnsuitableAge='true'">
					<li>The patient's Age makes them unsuitable</li>
				</xsl:if>
				<xsl:if test="btr:OtherReason='true'">
					<li>Other clinical reasons (see below) make them unsuitabe</li>
				</xsl:if>
			</ul>
		</xsl:if>
		</p>
		<p><xsl:call-template name="format_text">
				<xsl:with-param name="text"><xsl:value-of select="btr:UnsuitableComments"/></xsl:with-param>
			</xsl:call-template>
			</p>
	</xsl:template>
	<xsl:template match="btr:TreatmentRecommendations">
		<hr/>
		<p>We would recommend that the following treatment / management is appropriate at this point.<br/>
		<xsl:call-template name="format_text">
			<xsl:with-param name="text"><xsl:value-of select="text()"/></xsl:with-param>
		</xsl:call-template>	
		</p>
	</xsl:template>
	<xsl:template match="btr:PossibleAlternativeService">
		<hr/>
		<p>A useful alternative service may be the 	
		<xsl:call-template name="format_text">
			<xsl:with-param name="text"><xsl:value-of select="text()"/></xsl:with-param>
		</xsl:call-template>
		</p>
	</xsl:template>
	<xsl:template match="btr:FurtherInformationRequired">
		<hr/>
		<p>Your patient may be suitable for this service but the following information is required in order to know what do do next
		e.g. arrange an investigation, appoint to clinic, or a procedure.</p>
		<p>
		<xsl:call-template name="format_text">
			<xsl:with-param name="text"><xsl:value-of select="text()"/></xsl:with-param>
		</xsl:call-template>
		</p>
	</xsl:template>
	<xsl:template match="btr:GenericReasonInstance">
		<xsl:if test="gen:NameValuePair">
			<xsl:value-of select="gen:NameValuePair/gen:NameValueName/gen:NameId"/><xsl:text> : </xsl:text>
			<xsl:choose>
				<xsl:when test="gen:NameValuePair/gen:NameValueValue/gen:GenericDateValue">
					<xsl:call-template name="format_text">
						<xsl:with-param name="date"><xsl:value-of select="gen:NameValuePair/gen:NameValueValue/gen:GenericDateValue"/></xsl:with-param>
					</xsl:call-template>
				</xsl:when>
				<xsl:when test="gen:NameValuePair/gen:NameValueValue/gen:GenericStringValue">
					<xsl:call-template name="format_text">
						<xsl:with-param name="text"><xsl:value-of select="gen:NameValuePair/gen:NameValueValue/gen:GenericStringValue"/></xsl:with-param>
					</xsl:call-template>
				</xsl:when>
			</xsl:choose>
			<br/>
		</xsl:if>
	</xsl:template>
	<!-- Output the organisation name -->
	<xsl:template match="gen:OrganisationName">
		<xsl:value-of select="."/>
	</xsl:template>
	<!-- Output an address -->
	<xsl:template match="gen:PatientAddress | gen:OrganisationAddress">
		<xsl:if test="gen:StructuredAddress">
			<xsl:if test="gen:StructuredAddress/gen:PropertyNumber">
				<xsl:value-of select="gen:StructuredAddress/gen:PropertyNumber"/><xsl:text> </xsl:text>
			</xsl:if>
			<xsl:for-each select="gen:StructuredAddress/gen:AddressLine">
				<xsl:value-of select="."/><br/>
			</xsl:for-each>
		</xsl:if>
		<xsl:if test="gen:UnstructuredAddress">
			<xsl:value-of select="gen:UnstructuredAddress"/><br/>
		</xsl:if>
		<xsl:if test="gen:PostCode">
			<xsl:value-of select="gen:PostCode"/><br/>
		</xsl:if>
		<xsl:if test="gen:NonValidatedPostCode">
			<xsl:value-of select="gen:NonValidatedPostCode"/><br/>
		</xsl:if>
	</xsl:template>
	<!-- Output a telecom detail -->
	<xsl:template match="gen:PatientTelecom | gen:HcpTelecom | gen:OrganisationTelecom">
		<xsl:choose>
			<xsl:when test="gen:TelecomMode"><xsl:value-of select="gen:TelecomMode"/><xsl:text>: </xsl:text></xsl:when>
			<xsl:when test="gen:TelecomType"><xsl:value-of select="gen:TelecomType"/><xsl:text>: </xsl:text></xsl:when>
		</xsl:choose>
		<xsl:if test="gen:StructuredTelecom">
			<xsl:if test="gen:StructuredTelecom/gen:TelecomCountry">
				(+<xsl:value-of select="gen:StructuredTelecom/gen:TelecomCountry"/>)
			</xsl:if>
			<xsl:value-of select="gen:StructuredTelecom/gen:TelecomArea"/> <xsl:value-of select="gen:StructuredTelecom/gen:TelecomNumber"/>
			<xsl:if test="gen:StructuredTelecom/gen:TelecomExt">
				Extn <xsl:value-of select="gen:StructuredTelecom/gen:TelecomExt"/>
			</xsl:if>
		</xsl:if>
		<xsl:if test="gen:UnstructuredTelecom"><xsl:value-of select="gen:UnstructuredTelecom"/></xsl:if><br/>
	</xsl:template>
	<!-- Output the name in standard title givenname familyname format -->
	<xsl:template match="gen:HcpName" mode="FullName">
		<xsl:if test="gen:StructuredName">
			<xsl:if test="gen:StructuredName/gen:Title"><xsl:value-of select="gen:StructuredName/gen:Title"/><xsl:text> </xsl:text></xsl:if>
			<xsl:value-of select="gen:StructuredName/gen:GivenName"/><xsl:text> </xsl:text><xsl:value-of select="gen:StructuredName/gen:FamilyName"/>
		</xsl:if>
		<xsl:if test="gen:UnstructuredName">
			<xsl:value-of select="gen:UnstructuredName"/>
		</xsl:if>
	</xsl:template>
	<!-- Output the name in standard title familyname format -->
	<xsl:template match="gen:HcpName" mode="AbbreviatedName">
		<xsl:if test="gen:StructuredName">
			<xsl:if test="gen:StructuredName/gen:Title"><xsl:value-of select="gen:StructuredName/gen:Title"/><xsl:text> </xsl:text></xsl:if>
			<xsl:value-of select="gen:StructuredName/gen:FamilyName"/>
		</xsl:if>
		<xsl:if test="gen:UnstructuredName">
			<xsl:value-of select="gen:UnstructuredName"/>
		</xsl:if>
	</xsl:template>
	<!-- *********************** FUNCTIONS  ************************ -->
	<xsl:template name="format_text">
		<xsl:param name="text"/>
		<xsl:param name="date"/>
		<xsl:param name="datetime"/>
		<xsl:param name="default" select="$default_blank"/>
		<xsl:choose>
			<xsl:when test="normalize-space($date)">
				<xsl:value-of select="user:UnambiguousDate(string($date))"/>
			</xsl:when>
			<xsl:when test="normalize-space($datetime)">
				<xsl:value-of select="$datetime"/>
			</xsl:when>
			<xsl:when test="normalize-space($text)">
				<xsl:value-of disable-output-escaping="yes" select="user:FormatText(string($text))"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$default"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="boolean_to_text">
		<xsl:param name="text"/>
		<xsl:param name="textIfFalse"/>
		<xsl:param name="textIfTrue"/>
		<xsl:variable name="textToLower" select="normalize-space(translate($text, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz'))"/>
		<xsl:choose>
			<xsl:when test="$textToLower='false'">
				<xsl:value-of select="$textIfFalse"/>
			</xsl:when>
			<xsl:when test="$textToLower='true'">
				<xsl:value-of select="$textIfTrue"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$default_blank"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="boolean_to_yes_no">
		<xsl:param name="text"/>
		<xsl:call-template name="boolean_to_text">
			<xsl:with-param name="text" select="$text"/>
			<xsl:with-param name="textIfFalse">No</xsl:with-param>
			<xsl:with-param name="textIfTrue">Yes</xsl:with-param>
		</xsl:call-template>
	</xsl:template>
</xsl:stylesheet>
