<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:cd="http://www.show.scot.nhs.uk/isd/ClinicalDialogue" xmlns:gen="http://www.show.scot.nhs.uk/isd/General" xmlns:msxsl="urn:schemas-microsoft-com:xslt" xmlns:user="http://www.sci.scot.nhs.uk" exclude-result-prefixes="user msxsl">
	<xsl:output method="html"/>
	<msxsl:script language="javascript" implements-prefix="user"><![CDATA[
			
			function GetMonth(strMonthNumber)
		{
			var strMonth;
			
			switch (strMonthNumber) {
				case "01" :
					strMonth = "Jan";
					break;
				case "02" :
					strMonth = "Feb";
					break;
				case "03" :
					strMonth = "Mar";
					break;
				case "04" :
					strMonth = "Apr";
					break;
				case "05" :
					strMonth = "May";
					break;
				case "06" :
					strMonth = "Jun";
					break;
				case "07" :
					strMonth = "Jul";
					break;
				case "08" :
					strMonth = "Aug";
					break;
				case "09" :
					strMonth = "Sep";
					break;
				case "10" :
					strMonth = "Oct";
					break;
				case "11" :
					strMonth = "Nov";
					break;
				case "12" :
					strMonth = "Dec";
					break; 
				default :
					strMonth = "   ";
			} 
			return(strMonth);
		}
		
		function FormatText(strTextToFormat)
		{
			var strOut = HTMLEncode(strTextToFormat);
			
			strOut = FormatLineBreaks(strOut);
			return strOut;
		}
		
		function HTMLEncode(strTextToEncode)
		{
			var strOut = strTextToEncode;
			
			strOut = strOut.replace(/</g,'&lt;');
			strOut = strOut.replace(/>/g,'&gt;');
			strOut = strOut.replace(/£/g,'&pound;');
			
			return strOut;
		}
		
		function FormatLineBreaks(strTextToFormat)
		{
			var CrLf = String.fromCharCode(13, 10);
			var Cr = String.fromCharCode(13);
			var Lf = String.fromCharCode(10);
			var NewLine = String.fromCharCode(10);
			
			var strOut = new String();
			var strText = new String(strTextToFormat);
			strOut = strText.replace(NewLine, '<br/>');
			var aCharArray = new Array(NewLine, CrLf, Cr, Lf) 
			
			for( var i = 0; i < 4; i++)
			{
				while(strOut.match(aCharArray[i]))
				{
					strOut = strOut.replace(aCharArray[i], '<br/>');
				}
			}		
			return(strOut); 	    
		}
		
		function IsDate(strValue)
		{
			return(!isNaN(new Date(strValue)));  
		}
		
		function UnambiguousDate(strAmbiguousDate)
		{
			 var dteDate;
			 var strDay, strMonth, strYear, strDate;
			
			 // Garaunteed formats
			 strDate = new String(strAmbiguousDate);
			 strYear = strDate.substring(0,4);  
			 strMonth = strDate.substring(5,7);
			 strDay = strDate.substring(8,10);
			
			 if (IsDate(new Date(strYear,strMonth,strDay)))
			 {
				 return(strDay + "-" + GetMonth(strMonth) + "-" + strYear);
			 }
		}
		
		function IsNumeric(str)
		{
			for (var i=0; i < str.length; i++)
			{
				var ch = str.substring(i, i+1)
				if( ch < "0" || ch>"9" || str.length == null)
				{
					return (false);
				}     
			}
			return (true);
		}
		
		function IsTime(strTimeToCheck)
		{
			var strHour;
			var strMinute;
			var strSecond;
			var lFirstColon;
			var lSecondColon;
			var arrMask = new Array(4);
			var lCount;
			var bValidated;
			var strTime;
			var bIsTime;
			var lValMask;
			
			bIsTime = true;		
			strTime = new String(strTimeToCheck);
			
			arrMask[0] = new String( "9:99");
			arrMask[1] = new String("99:99");
			arrMask[2] = new String("9:99:99");
			arrMask[3] = new String("99:99:99");
			bValidated = false;
			
			for(lCount = 0; lCount < 4;  lCount++)
			{
				  // the mask needs to be the same size as the time
				 if(arrMask[lCount].length == strTime.length)
				 {
					// check the mask
					bValidated = ValidateMask(arrMask[lCount],  strTime);
					if(bValidated)
					{
						lValMask = arrMask[lCount];
						break;
					}
				 }
			}
			
			if(bValidated)
			{
				//based on the mask check that the hours, minutes and seconds are okay (00:00:00-23:59:59)
				
				//get the colons
				lFirstColon = arrMask[lCount].indexOf(":");
				
				if ((lCount == 2) || (lCount == 3))
					lSecondColon = arrMask[lCount].indexOf(":", lFirstColon + 1);
				else
					lSecondColon = 0;
				
				//get the hours
				strHour = strTime.substr(0,lFirstColon);
				bIsTime = ValidateTimeLimit(strHour, 23);
				
				// get the minutes
				strMinute = strTime.substr(lFirstColon + 1, 2);
				bIsTime = ValidateTimeLimit(strMinute, 59);
				
				if(lSecondColon)
				{
					// get the seconds
					strSecond = strTime.substr(lSecondColon + 1, 2);	
					bIsTime = ValidateTimeLimit(strSecond, 59);
				}
			}	
			else
			{
				bIsTime = false;
			}
			return(bIsTime);
		}
		
		function ValidateTimeLimit(strTimeElement, lConstraint)
		{	
		   var bValidateTimeLimit; 
			
		   bValidateTimeLimit = true;
		   if (IsNumeric(strTimeElement))
		   {
			  if (!(strTimeElement <= lConstraint))
				 bValidateTimeLimit = false;
		   }		
		   else
			  bValidateTimeLimit = false;
			
		   return(bValidateTimeLimit);
		}
		
		function ValidateMask(strValidateMask, strValidateTime)
		{
			var bValidated;
			var strMask;
			var strTime
			
			strMask = new String(strValidateMask);
			strTime = new String(strValidateTime);
			
			bValidated = true;
			for(var lCount = 1; lCount < strTime.length + 1; lCount++)
			{  
				if((strMask.substr(lCount, 1) == "9"))  
				{  
					 if(!(IsNumeric(strTime.substr(lCount, 1))))
					 {
						bValidated = false;
						break;
					 }
				}	
				else
				{
					 if (strMask.substr(lCount, 1) == ":")
					 {  
						if(!(strMask.substr(lCount, 1) == strTime.substr(lCount, 1)))
						{
						   bValidated = false;
						   break;
						}
					 }  
				}
			}					
			return(bValidated);
		}
		
		function UnambiguousDateShortTime(p_dteDate, p_strDefault)
		{
			var strTempDate, strTempTime;
			var lSpace;
			var strUnambiguousDateShortTime;
			var strDate = new String(p_dteDate);
			var strDefault = new String(p_strDefault);
			var dteTempDate = new Date(p_dteDate);
			
			strUnambiguousDateShortTime = strDefault;
			
			strDate.replace( "T", " ");
			
			if(strDate.lenth)
			{
				if (IsDate(strDate))
					strUnambiguousDateShortTime = UnambiguousDate(strDate, strDefault) + " " + dteTempDate.getDay() + "-" + dteTempDate.getMonth() + dteTempDate.getYear();
				else
				{
					 lSpace = strDate.indexOf(" ");
					 strTempDate = strDate.substr(0,strDate.indexOf(" "));
					 strTempTime = strDate.substr(strDate.indexOf(" ") + 1);
					 
					 if(IsDate(strTempDate)) 
					 {
						if(IsTime(strTempTime))
						   strUnambiguousDateShortTime = UnambiguousDate(strTempDate, strDefault) + " " 
						   +   dteTempDate.getDay() + "-" + dteTempDate.getMonth() + dteTempDate.getYear();
						else
							strUnambiguousDateShortTime = UnambiguousDate(strTempDate, strDefault) + " " + strTempTime;
					}
				}
			} 	    
			return(strUnambiguousDateShortTime);  
		}
			
		]]></msxsl:script>
	<xsl:variable name="default_blank" select="'-'"/>
	<xsl:template match="cd:ClinicalDialogueDocument">
		<style>
			body
			{
				font-family: Tahoma, Arial, Helvetica, sans-serif;
				font-size: 11px;
				margin-top : 15px;
				margin-left : 15px;
				background-color: white;
			}
			
			p
			{
				margin-bottom : 2px;
				margin-top : 2px;
			}
			
			h1
			{
				font-size: 16 px;
				font-weight: bold;
				color : black;
				margin-bottom : 4px;
				margin-top : 4px;
				font-family : Verdana, Geneva, Arial, Helvetica, sans-serif;
			}
			
			h2
			{
				font-size: 14 px;
				margin-bottom : 3px;
				margin-top : 3px;
				font-family : Verdana, Geneva, Arial, Helvetica, sans-serif;
				font-weight: normal;
			}
			
			h3
			{
				font-size: 10px ;
				font-family : Verdana, Geneva, Arial, Helvetica, sans-serif;
				margin-bottom : 2px;
				margin-top : 2px;
				font-weight : bold;
			}
			
			h4
			{
				font-size: 11 px ;
				font-family : Verdana, Geneva, Arial, Helvetica, sans-serif;
				margin-bottom : 2px;
				margin-top : 8px;
				text-indent : 32px;
				font-weight : normal;
				text-decoration : underline;
			}
			
			h5
			{
				font-size: 11 px ;
				font-family : Verdana, Geneva, Arial, Helvetica, sans-serif;
				margin-bottom : 2px;
				margin-top : 8px;
				text-indent : 48px;
				font-weight : normal;
			}
			
			h6
			{
				font-size: 10 px ;
				font-family : Verdana, Geneva, Arial, Helvetica, sans-serif;
				margin-bottom : 2px;
				margin-top : 8px;
				text-indent : 60px;
				font-weight : bold;
			}
			
			break
			{
				page-break-before : always;
			}
			
			a
			{
				text-decoration: underline;
				color: Navy;
			}
			
			a:hover
			{
				text-decoration: none;
				color : Red;
			}
			
			table
			{
				font-size: 11 px ;
			}
			
			.hashed
			{
				background-color: lightgrey;
				font-weight:bold;
			}
			
			.essential
			{
				font-weight:bold;
				color:red;
			}
			
			.urgency
			{
				font-size:20 px;
				color:navy;
			}
			
			.sensitivity
			{
				font-size:20 px;
				color:navy;
			}
			
			.barcode
			{
				font-family: SCIBC;
				font-size:20 px;
			}
			
			.barcodeText
			{
				font-family: Tahoma, Arial, Helvetica, sans-serif;
				font-size: 9px;
			}
		</style>
		<xsl:apply-templates select="cd:MessageData"/>
	</xsl:template>
	<xsl:template match="cd:MessageData">
		<xsl:apply-templates select="cd:ConversationData"/>
		<xsl:apply-templates select="cd:PatientDemographics"/>
		<xsl:apply-templates select="cd:ClinicalInformation"/>
	</xsl:template>
	<xsl:template match="cd:ClinicalInformation">
	<br/>
		<div>
			<p>
				<b>CURRENT AND RECENT MEDICATION</b>
			</p>
			<table width="100%" border="0">
				<thead>
					<tr>
						<td align="left">
							<u>Drug Name</u>
						</td>
						<td align="left">
							<u>BNF</u>
						</td>
						<td align="left">
							<u>Formulation</u>
						</td>
						<td align="left">
							<u>Dosage</u>
						</td>
						<td align="left">
							<u>Frequency</u>
						</td>
						<td align="left">
							<u>Started</u>
						</td>
						<td align="left">
							<u>Last Issued</u>
						</td>
					</tr>
				</thead>
				<tbody>
					<xsl:apply-templates select="cd:CurrentClinicalData/cd:CurrentMedication"/>
					<xsl:apply-templates select="cd:BackgroundData/cd:MedicalHistory/gen:PastMedication/gen:MedicationOnRecord"/>
				</tbody>
			</table>
		<br/>
		</div>
		<xsl:apply-templates select="cd:CurrentClinicalData/cd:Examinations"/>
		<xsl:apply-templates select="cd:CurrentClinicalData/cd:Investigations"/>
		<xsl:apply-templates select="cd:CurrentClinicalData/cd:GenericCurrentClinicalInformation"/>
		<xsl:apply-templates mode="alerts_section" select="cd:Alerts"/>
		<xsl:apply-templates select="cd:BackgroundData/cd:PatientMeasurements"/>
		<xsl:apply-templates select="cd:BackgroundData/cd:MedicalHistory"/>
		<br/>
		<p>
			<b>FAMILY CONDITIONS</b>
		</p>
		<table border="0" cellspacing="2px" valign="top" style="padding-top:0;paddingbottom:0;padding-left:0;padding-right:4px">
			<tr align="left">
				<td>
					<u>Code</u>
				</td>
				<td>&#160;&#160;</td>
				<td>
					<u>Code Scheme</u>
				</td>
				<td>&#160;&#160;</td>
				<td>
					<u>Code Scheme Version</u>
				</td>
				<td>&#160;&#160;</td>
				<td>
					<u>Description</u>
				</td>
				<td>&#160;&#160;</td>
				<xsl:if test="normalize-space(cd:BackgroundData/cd:FamilyHistory/gen:FamilyCondition/gen:Laterality[not('')])">
					<td>
						<u>Laterality</u>
					</td>
					<td>&#160;&#160;</td>
				</xsl:if>
				<td>
					<u>Modifier</u>
				</td>
				<td>&#160;&#160;</td>
				<td>
					<u>Extension</u>
				</td>
				<td>&#160;&#160;</td>
				<td>
					<u>Relation to patient</u>
				</td>
				<td>&#160;&#160;</td>
				<xsl:if test="normalize-space(cd:BackgroundData/cd:FamilyHistory/gen:FamilyCondition/gen:DateOfOnset[not('')])">
					<td>
						<u>Date of onset</u>
					</td>
				</xsl:if>
			</tr>
			<xsl:apply-templates select="cd:BackgroundData/cd:FamilyHistory"/>
		</table>
		<p>&#160;</p>
		<xsl:apply-templates select="cd:BackgroundData/cd:SocialCircumstances"/>
	</xsl:template>
	<xsl:template match="cd:ConversationData">
		<div>
			<th>
				<b>From: </b>
			</th>
			<xsl:choose>
				<xsl:when test="cd:CurrentDialogue/cd:HcpFrom/gen:HcpName/gen:UnstructuredName">
					<xsl:value-of select="cd:CurrentDialogue/cd:HcpFrom/gen:HcpName/gen:UnstructuredName"/>
					<xsl:text> </xsl:text>
					<xsl:value-of select="cd:CurrentDialogue/cd:HcpFrom/gen:EmployingOrganisation/gen:OrganisationName"/>
				</xsl:when>
				<xsl:when test="cd:CurrentDialogue/cd:HcpFrom/gen:HcpName/gen:StructuredName">
					<xsl:value-of select="cd:CurrentDialogue/cd:HcpFrom/gen:HcpName/gen:StructuredName/gen:GivenName"/>
					<xsl:text> </xsl:text>
					<xsl:value-of select="cd:CurrentDialogue/cd:HcpFrom/gen:HcpName/gen:StructuredName/gen:FamilyName"/>
					<xsl:text> </xsl:text>
					<xsl:value-of select="cd:CurrentDialogue/cd:HcpFrom/gen:EmployingOrganisation/gen:OrganisationName"/>
				</xsl:when>
			</xsl:choose>
		</div>
		<div>
			<th>
				<b>Sent: </b>
			</th>
			<xsl:call-template name="formatDate">
				<xsl:with-param name="d">
					<xsl:value-of select="../../cd:DocumentData/gen:DocumentAttestationDate"/>
				</xsl:with-param>
			</xsl:call-template>
			<xsl:text> </xsl:text>
			<xsl:value-of select="../../cd:DocumentData/gen:DocumentAttestationTime"/>
		</div>
		<div>
			<th>
				<b>To: </b>
			</th>
			<xsl:value-of select="cd:CurrentDialogue/cd:HcpTo/gen:EmployingOrganisation/gen:OrganisationName"/>
			<xsl:text> </xsl:text>
			<xsl:value-of select="cd:CurrentDialogue/cd:HcpTo/gen:HcpSpecialty/gen:SpecialtyName"/>
		</div>
		<div>
			<th>
				<b>Subject: </b>
			</th>
			<xsl:call-template name="format_text">
				<xsl:with-param name="text" select="cd:CurrentDialogue/cd:DialogueText/cd:Section/cd:SectionHeading" />
			</xsl:call-template>
		</div>
		<div/>
		<div>____________________________________________________________________________________________________________________________</div>
		<div>
			<xsl:call-template name="format_text">
				<xsl:with-param name="text" select="cd:CurrentDialogue/cd:DialogueText/cd:Section/cd:SectionText" />
			</xsl:call-template>
		</div>
		<xsl:if test="normalize-space(cd:PreviousDialogues)">
			<div>____________________________________________________________________________________________________________________________</div>
			<xsl:call-template name="format_text">
				<xsl:with-param name="text">
					<xsl:value-of select="cd:PreviousDialogues/cd:DialogueData"/>
				</xsl:with-param>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>
	<xsl:template match="cd:PatientDemographics">
		<br/>
		<div/>
		<table border="0" width="100%">
			<tbody>
				<tr>
					<td width="50%" colspan="3" style="border-style:none;" valign="top">
						<h3>PATIENT DETAILS</h3>
					</td>
					<td width="45%" height="25" valign="bottom" style="padding-bottom:0;border-style:none;">
						Patient's address
					</td>
				</tr>
				<tr>
					<td width="15%" style="border-style:none;">Title</td>
					<td width="35%">
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="gen:PatientName[gen:NameType='Current Name']/gen:StructuredName/gen:Title"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
					<td width="5%" style="border-style:none;" rowspan="7"/>
					<td width="45%" rowspan="4" valign="top">
						<xsl:apply-templates select="gen:PatientAddress"/>
					</td>
				</tr>
				<tr>
					<td style="border-style:none;">Forename(s)</td>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="gen:PatientName[gen:NameType='Current Name']/gen:StructuredName/gen:GivenName"/>
								<xsl:for-each select="gen:PatientName[gen:NameType='Current Name']/gen:StructuredName/gen:MiddleName">
									<xsl:text/>
									<xsl:value-of select="."/>
								</xsl:for-each>
							</xsl:with-param>
						</xsl:call-template>
					</td>
				</tr>
				<tr>
					<td style="border-style:none;">Surname</td>
					<td>
						<xsl:choose>
							<xsl:when test="gen:PatientName[gen:NameType='Current Name']/gen:UnstructuredName">
								<xsl:value-of select="gen:UnstructuredName"/>
							</xsl:when>
							<xsl:when test="gen:PatientName[gen:NameType='Current Name']/gen:StructuredName/gen:FamilyName">
								<xsl:value-of select="gen:PatientName[gen:NameType='Current Name']/gen:StructuredName/gen:FamilyName"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="$default_blank"/>
							</xsl:otherwise>
						</xsl:choose>
					</td>
				</tr>
				<tr>
					<td style="border-style:none;">Sex</td>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:apply-templates select="gen:Sex"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
				</tr>
				<tr>
					<td style="border-style:none;">Date of birth</td>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="date">
								<xsl:value-of select="gen:DateOfBirth"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
				</tr>
				<tr>
					<td valign="top" style="border-style:none;">CHI no.</td>
					<td valign="top">
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="gen:PatientId[gen:IdScheme='CHI']/gen:IdValue"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
				</tr>
			</tbody>
		</table>
	<br/>
	</xsl:template>
	<xsl:template match="gen:PatientAddress | gen:OrganisationAddress">
		<xsl:choose>
			<xsl:when test="gen:UnstructuredAddress">
				<p>
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:value-of select="gen:UnstructuredAddress"/>
						</xsl:with-param>
					</xsl:call-template>
				</p>
			</xsl:when>
			<xsl:otherwise>
				<p>
					<xsl:value-of select="gen:StructuredAddress/gen:PropertyNumber"/>
				</p>
				<xsl:for-each select="gen:StructuredAddress/gen:AddressLine">
					<p>
						<xsl:value-of select="."/>
					</p>
				</xsl:for-each>
			</xsl:otherwise>
		</xsl:choose>
		<p>
			<xsl:value-of select="gen:PostCode"/>
		</p>
	</xsl:template>
	<xsl:template match="cd:SocialCircumstances">
	<br/>
		<div>
			<table>
				<tbody>
					<p>
						<b>BACKGROUND DATA</b>
					</p>
					<tr>
						<th>
							<table>
								<tbody>
									<tr>
										<th>Housing</th>
										<td>
											<xsl:call-template name="format_text">
												<xsl:with-param name="text">
													<xsl:value-of select="gen:Housing"/>
												</xsl:with-param>
											</xsl:call-template>
										</td>
									</tr>
									<tr>
										<th>Employment</th>
										<td>
											<xsl:call-template name="format_text">
												<xsl:with-param name="text">
													<xsl:value-of select="gen:Employment"/>
												</xsl:with-param>
											</xsl:call-template>
										</td>
									</tr>
									<tr>
										<th>Religion</th>
										<td>
											<xsl:call-template name="format_text">
												<xsl:with-param name="text">
													<xsl:for-each select="gen:Religion">
														<xsl:text/>
														<xsl:value-of select="."/>
													</xsl:for-each>
												</xsl:with-param>
											</xsl:call-template>
										</td>
									</tr>
									<tr>
										<th>Ethnic Origin</th>
										<td>
											<xsl:call-template name="format_text">
												<xsl:with-param name="text">
													<xsl:value-of select="gen:EthnicOrigin"/>
												</xsl:with-param>
											</xsl:call-template>
										</td>
									</tr>
									<tr>
										<th>Language</th>
										<td>
											<xsl:call-template name="format_text">
												<xsl:with-param name="text">
													<xsl:value-of select="gen:Language"/>
												</xsl:with-param>
											</xsl:call-template>
										</td>
									</tr>
								</tbody>
							</table>
						</th>
					</tr>
				</tbody>
			</table>
		</div>
	<br/>
	</xsl:template>
	<xsl:template match="cd:CurrentMedication | gen:MedicationOnRecord">
		<tr>
			<td align="left">
				<xsl:value-of select="gen:DrugName/gen:DrugCode/gen:DrugIdentifier"/>
			</td>
			<td align="left">
				<xsl:value-of select="gen:DrugName/gen:DrugCode/gen:DrugCodeValue"/>
			</td>
			<td align="left">
				<xsl:value-of select="gen:DrugName/gen:DrugCode/gen:Formulation"/>
			</td>
			<td align="left">
				<xsl:value-of select="gen:StructuredDosage/gen:DoseDescription"/>
			</td>
			<td align="left">
				<xsl:value-of select="gen:StructuredDosage/gen:Frequency"/>
			</td>
			<td align="left">
				<xsl:call-template name="formatDate">
					<xsl:with-param name="d" select="gen:StructuredDosage/gen:MedicationStartDate"/>
				</xsl:call-template>
			</td>
			<td align="left">
				<xsl:call-template name="formatDate">
					<xsl:with-param name="d" select="gen:StructuredDosage/gen:LastPrescribedDate"/>
				</xsl:call-template>
			</td>
		</tr>
	</xsl:template>
	<xsl:template match="cd:MedicalHistory">
		<div>
			<xsl:if test="normalize-space(gen:PastCondition/gen:ConditionDisclosed)">
			<br/>
				<p>
					<b>PRE-EXISTING CONDITIONS</b>
				</p>
				<table border="0" cellspacing="2px" valign="top" style="padding-top:0;paddingbottom:0;padding-left:0;padding-right:4px">
					<tr align="left">
						<td>
							<u>Code</u>
						</td>
						<td>&#160;&#160;</td>
						<td>
							<u>Code Scheme</u>
						</td>
						<td>&#160;&#160;</td>
						<td>
							<u>Code Scheme Version</u>
						</td>
						<td>&#160;&#160;</td>
						<td>
							<u>Description</u>
						</td>
						<td>&#160;&#160;</td>
						<td>
							<u>Laterality</u>
						</td>
						<td>&#160;&#160;</td>
						<td>
							<u>Modifier</u>
						</td>
						<td>&#160;&#160;</td>
						<td>
							<u>Extension</u>
						</td>
						<td>&#160;&#160;</td>
						<td>
							<u>Date of onset</u>
						</td>
					</tr>
					<xsl:apply-templates select="gen:PastCondition/gen:ConditionDisclosed"/>
				</table>
			<br/>
			</xsl:if>
			<xsl:if test="normalize-space(gen:PastProcedure)">
			<br/>
				<p>
					<b>PAST PROCEDURES</b>
				</p>
				<table border="0" cellspacing="2px" valign="top" style="padding-top:0;paddingbottom:0;padding-left:0;padding-right:4px">
					<tr align="left">
						<td>
							<u>Code</u>
						</td>
						<td>&#160;&#160;</td>
						<td>
							<u>Code Scheme</u>
						</td>
						<td>&#160;&#160;</td>
						<td>
							<u>Code Scheme Version</u>
						</td>
						<td>&#160;&#160;</td>
						<td>
							<u>Description</u>
						</td>
						<td>&#160;&#160;</td>
						<td>
							<u>Laterality</u>
						</td>
						<td>&#160;&#160;</td>
						<td>
							<u>Modifier</u>
						</td>
						<td>&#160;&#160;</td>
						<td>
							<u>Date performed</u>
						</td>
					</tr>
					<xsl:apply-templates select="gen:PastProcedure/gen:ProcedureDisclosed"/>
				</table>
			<br/>
			</xsl:if>
		</div>
	</xsl:template>
	<xsl:template match="cd:FamilyHistory">
		<div>
			<xsl:if test="normalize-space(gen:FamilyCondition/gen:ConditionName/gen:ClinicalCircumstanceDescription) or normalize-space(gen:FamilyCondition/gen:ConditionName/gen:ClinicalInformation)">
				<tr>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="gen:FamilyCondition/gen:ConditionName/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeValue"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="gen:FamilyCondition/gen:ConditionName/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeId"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="gen:FamilyCondition/gen:ConditionName/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeVersion"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:choose>
									<xsl:when test="gen:FamilyCondition/gen:ConditionName/gen:ClinicalInformation">
										<xsl:value-of select="gen:FamilyCondition/gen:ConditionName/gen:ClinicalInformation/gen:ClinicalCodeDescription"/>
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="gen:FamilyCondition/gen:ConditionName/gen:ClinicalCircumstanceDescription"/>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:with-param>
						</xsl:call-template>
					</td>
					<td>&#160;&#160;</td>
					<xsl:if test="normalize-space(./gen:FamilyCondition/gen:Laterality[not('')])">
						<td valign="top">
							<xsl:call-template name="format_text">
								<xsl:with-param name="text">
									<xsl:value-of select="gen:FamilyCondition/gen:Laterality"/>
								</xsl:with-param>
							</xsl:call-template>
						</td>
						<td>&#160;&#160;</td>
					</xsl:if>
					<td valign="top">
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="gen:FamilyCondition/gen:Modifier"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
					<td>&#160;&#160;</td>
					<td valign="top">
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="gen:FamilyCondition/gen:Comment"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
					<td>&#160;&#160;</td>
					<td valign="top">
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="gen:RelationToPatient"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
					<td>&#160;&#160;</td>
					<xsl:if test="normalize-space(./gen:FamilyCondition/gen:DateOfOnset[not('')])">
						<td valign="top">
							<xsl:call-template name="format_text">
								<xsl:with-param name="date">
									<xsl:value-of select="gen:FamilyCondition/gen:DateOfOnset"/>
								</xsl:with-param>
							</xsl:call-template>
						</td>
					</xsl:if>
				</tr>
			</xsl:if>
		</div>
	</xsl:template>
	<xsl:template match="gen:ConditionDisclosed">
		<div>
			<xsl:if test="normalize-space(gen:ConditionName/gen:ClinicalCircumstanceDescription) or normalize-space(gen:ConditionName/gen:ClinicalInformation)">
				<tr>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="gen:ConditionName/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeValue"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="gen:ConditionName/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeId"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="gen:ConditionName/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeVersion"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:choose>
									<xsl:when test="gen:ConditionName/gen:ClinicalInformation">
										<xsl:value-of select="gen:ConditionName/gen:ClinicalInformation/gen:ClinicalCodeDescription"/>
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="gen:ConditionName/gen:ClinicalCircumstanceDescription"/>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:with-param>
						</xsl:call-template>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="gen:Laterality"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="gen:Modifier"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="gen:Comment"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="date">
								<xsl:value-of select="gen:DateOfOnset"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
				</tr>
			</xsl:if>
		</div>
	</xsl:template>
	<xsl:template match="gen:ProcedureDisclosed">
		<div>
			<xsl:if test="normalize-space(gen:Procedure/gen:ProcedureName/gen:ClinicalCircumstanceDescription) or normalize-space(gen:Procedure/gen:ProcedureName/gen:ClinicalInformation)">
				<tr>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="gen:Procedure/gen:ProcedureName/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeValue"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="gen:Procedure/gen:ProcedureName/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeId"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="gen:Procedure/gen:ProcedureName/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeVersion"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:choose>
									<xsl:when test="gen:Procedure/gen:ProcedureName/gen:ClinicalInformation">
										<xsl:value-of select="gen:Procedure/gen:ProcedureName/gen:ClinicalInformation/gen:ClinicalCodeDescription"/>
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="gen:Procedure/gen:ProcedureName/gen:ClinicalCircumstanceDescription"/>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:with-param>
						</xsl:call-template>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="gen:Procedure/gen:Laterality"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="gen:Procedure/gen:Modifier"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="date">
								<xsl:value-of select="gen:DatePerformed"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
				</tr>
			</xsl:if>
		</div>
	</xsl:template>
	<xsl:template match="cd:PatientMeasurements">
		<xsl:apply-templates select="./cd:BloodPressures"/>
		<xsl:apply-templates select="./cd:BodyMeasurements"/>
		<xsl:apply-templates select="./cd:PregnancyHistory"/>
	</xsl:template>
	<xsl:template match="cd:BloodPressures">
		<xsl:if test="./cd:BloodPressure">
			<table>
				<tbody>
					<tr>
						<td colspan="4">
							<b>BLOOD PRESSURE HISTORY</b>
						</td>
					</tr>
					<tr>
						<td>
							<u>Diastolic</u>
						</td>
						<td>
							<u>Systolic</u>
						</td>
						<td>
							<u>Date Recorded</u>
						</td>
						<td>
							<u>Time Recorded</u>
						</td>
					</tr>
					<xsl:for-each select="./cd:BloodPressure">
						<tr>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="./cd:Diastolic"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="./cd:Systolic"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="date">
										<xsl:value-of select="./cd:RecordedDate"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="./cd:RecordedTime"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
						</tr>
					</xsl:for-each>
				</tbody>
			</table>
		</xsl:if>
	</xsl:template>
	<xsl:template match="cd:BodyMeasurements">
		<xsl:if test="./cd:BodyMeasurement">
			<table>
				<tbody>
					<tr>
						<td colspan="5">
							<b>BODY MEASUREMENT HISTORY</b>
						</td>
					</tr>
					<tr>
						<td>
							<u>Body Mass Index</u>
						</td>
						<td>
							<u>Height</u>
						</td>
						<td>
							<u>Weight</u>
						</td>
						<td>
							<u>Date Recorded</u>
						</td>
						<td>
							<u>Time Recorded</u>
						</td>
					</tr>
					<xsl:for-each select="./cd:BodyMeasurement">
						<tr>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="./cd:BodyMassIndex"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="./cd:Height"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="./cd:Weight"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="date">
										<xsl:value-of select="./cd:RecordedDate"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="./cd:RecordedTime"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
						</tr>
					</xsl:for-each>
				</tbody>
			</table>
		</xsl:if>
	</xsl:template>
	<xsl:template match="cd:PregnancyHistory">
		<xsl:if test="./cd:Pregnancies">
			<table>
				<tbody>
					<tr>
						<td colspan="4">
							<b>PREGNANCY HISTORY</b>
						</td>
					</tr>
					<tr>
						<td>
							<u>Diastolic</u>
						</td>
						<td>
							<u>Systolic</u>
						</td>
						<td>
							<u>Date Recorded</u>
						</td>
						<td>
							<u>Time Recorded</u>
						</td>
					</tr>
					<xsl:for-each select="./cd:Pregnancies">
						<tr>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="./cd:Gravida"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="./cd:Parity"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="date">
										<xsl:value-of select="./cd:RecordedDate"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="./cd:RecordedTime"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
						</tr>
					</xsl:for-each>
				</tbody>
			</table>
		</xsl:if>
	</xsl:template>
	<xsl:template match="cd:Examinations | cd:Investigations">
		<xsl:for-each select="gen:TestPerformed">
			<tr>
				<td valign="top">
					<xsl:value-of select="gen:TestName/gen:ClinicalCircumstanceDescription"/>:</td>
				<td>
					<xsl:choose>
						<xsl:when test="../gen:TestMeasurement/gen:MeasurementDescription">
							<xsl:call-template name="format_text">
								<xsl:with-param name="text">
									<xsl:value-of select="../gen:TestMeasurement/gen:MeasurementDescription"/>
								</xsl:with-param>
							</xsl:call-template>
						</xsl:when>
						<xsl:when test="./gen:TestMeasurement/gen:MeasurementNumeric">
							<xsl:value-of select="../gen:TestMeasurement/gen:MeasurementNumeric/gen:Result/gen:QuantityValue"/>
							<xsl:text/>
							<xsl:value-of select="../gen:TestMeasurement/gen:MeasurementNumeric/gen:Result/gen:QuantityUnit"/>
						</xsl:when>
					</xsl:choose>
				</td>
				<td>
					<xsl:call-template name="format_text">
						<xsl:with-param name="datetime">
							<xsl:value-of select="../gen:DateTimeReported "/>
						</xsl:with-param>
					</xsl:call-template>
				</td>
				<xsl:for-each select="../gen:Comment">
					<td>
						<xsl:value-of select="substring-after(text(), ':')"/>
					</td>
				</xsl:for-each>
			</tr>
		</xsl:for-each>
	</xsl:template>
	<xsl:template match="cd:GenericCurrentClinicalInformation">
		<table>
			<xsl:for-each select="./gen:GenericInformationInstance">
				<tr>
					<xsl:for-each select="./gen:GenericTableInformation">
						<tr>
							<td align="left" style="border-style:none;">
								<b>
									<xsl:value-of select="./gen:Title"/>
								</b>
							</td>
						</tr>
						<tr>
							<xsl:for-each select="./gen:Columns/gen:Column">
								<td align="left" style="border-style:none;">
									<u>
										<xsl:value-of select="./gen:ColumnTitle"/>
									</u>
								</td>
							</xsl:for-each>
						</tr>
						<xsl:for-each select="./gen:Rows/gen:Row">
							<tr>
								<xsl:for-each select="./gen:Cells/gen:Cell">
									<td align="left" style="border-style:none;">
										<xsl:if test="./gen:CellValue/gen:GenericStringValue">
											<xsl:value-of select="./gen:CellValue/gen:GenericStringValue"/>
										</xsl:if>
										<xsl:if test="./gen:CellValue/gen:GenericDateValue">
											<xsl:call-template name="format_text">
												<xsl:with-param name="date">
													<xsl:value-of select="./gen:CellValue/gen:GenericDateValue"/>
												</xsl:with-param>
											</xsl:call-template>
										</xsl:if>
									</td>
								</xsl:for-each>
							</tr>
						</xsl:for-each>
					</xsl:for-each>
					<tr/>
					<xsl:for-each select="./gen:NameValuePair">
						<tr>
							<td align="left" style="border-style:none;">
								<xsl:value-of select="./gen:NameValueName/gen:NameId"/>
							</td>
							<td align="left" style="border-style:none;">
								<xsl:if test="./gen:NameValueValue/gen:GenericStringValue">
									<xsl:value-of select="./gen:NameValueValue/gen:GenericStringValue"/>
								</xsl:if>
								<xsl:if test="./gen:NameValueValue/gen:GenericDateValue">
									<xsl:call-template name="format_text">
										<xsl:with-param name="date">
											<xsl:value-of select="./gen:NameValueValue/gen:GenericDateValue"/>
										</xsl:with-param>
									</xsl:call-template>
								</xsl:if>
							</td>
						</tr>
					</xsl:for-each>
				</tr>
			</xsl:for-each>
		</table>
	</xsl:template>
	<xsl:template mode="alerts_section" match="cd:Alerts">
	<br/>
		<tr>
			<td width="60%">
				<xsl:if test="normalize-space(gen:LifestyleRisk[not('')])">
					<xsl:apply-templates select="gen:LifestyleRisk"/>
				</xsl:if>
				<xsl:if test="normalize-space(gen:Allergy[not('')])">
				<br/>
					<p>
						<b>ALLERGIES</b>
					</p>
					<table border="0">
						<tr>
							<td>
								<u>Code</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Code Scheme</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Code Scheme Version</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Description</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Comment</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Modifier</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Start Date</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Recorded Date</u>
							</td>
						</tr>
						<xsl:apply-templates select="gen:Allergy"/>
					</table>
				<br/>
				</xsl:if>
				<xsl:if test="normalize-space(gen:Intolerance[not('')])">
				<br/>
					<p>
						<b>INTOLERANCES</b>
					</p>
					<table border="0">
						<tr>
							<td>
								<u>Code</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Code Scheme</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Code Scheme Version</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Description</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Comment</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Modifier</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Start Date</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Recorded Date</u>
							</td>
						</tr>
						<xsl:apply-templates select="gen:Intolerance"/>
					</table>
				<br/>
				</xsl:if>
				<xsl:if test="normalize-space(gen:Lifestyle[not('')])">
				<br/>
					<p>
						<b>LIFESTYLE FACTORS</b>
					</p>
					<table border="0">
						<xsl:apply-templates select="gen:Lifestyle"/>
					</table>
				<br/>
				</xsl:if>
				<xsl:if test="normalize-space(gen:RiskToOthers[not('')])">
				<br/>
					<p>
						<b>RISKS TO OTHERS</b>
					</p>
					<table border="0">
						<tr>
							<td>
								<u>Code</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Code Scheme</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Code Scheme Version</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Description</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Comment</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Modifier</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Start Date</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Recorded Date</u>
							</td>
						</tr>
						<xsl:apply-templates select="gen:RiskToOthers"/>
					</table>
				<br/>
				</xsl:if>
			</td>
			<td valign="top">
			<br/>
				<p>
					Number per day
					<br/>
					<xsl:apply-templates select="gen:LifestyleRisk/gen:SmokingConsumption"/>
				</p>
			<br/>
			</td>
			<td valign="top">
			<br/>
				<p>
				Units per day
				<br/>
					<xsl:apply-templates select="gen:LifestyleRisk/gen:AlcoholConsumption"/>
				</p>
			<br/>
			</td>
		</tr>
	<br/>
	</xsl:template>
	<xsl:template match="gen:LifestyleRisk">
	<br/>
		<p>
			<b>LIFESTYLE RISKS</b>
		</p>
		<table border="0">
			<xsl:if test="normalize-space(gen:NonTherapeuticDrug[not('')])">
				<tr>
					<td>Non-therapeutic drugs:</td>
					<td>
						<xsl:value-of select="gen:NonTherapeuticDrug"/>
					</td>
				</tr>
			</xsl:if>
			<xsl:if test="normalize-space(gen:ReligiousObservance[not('')])">
				<tr>
					<td>Religious observance:</td>
					<td>
						<xsl:value-of select="gen:ReligiousObservance"/>
					</td>
				</tr>
			</xsl:if>
			<xsl:choose>
				<xsl:when test="normalize-space(gen:ExerciseStatus[text() = 'N/A'])"/>
				<xsl:when test="normalize-space(gen:ExerciseStatus[not('')])">
					<tr>
						<td>Exercise status:</td>
						<td>
							<xsl:value-of select="gen:ExerciseStatus"/>
						</td>
					</tr>
				</xsl:when>
				<xsl:otherwise/>
			</xsl:choose>
			<xsl:if test="count(//gen:AlcoholConsumptionRecord) > 0">
				<tr>
					<th>Alcohol Consumption History</th>
				</tr>
				<tr>
					<td>
						<u>Code</u>
					</td>
					<td>
						<u>Code Scheme</u>
					</td>
					<td>
						<u>Code Scheme Version</u>
					</td>
					<td>
						<u>Description</u>
					</td>
					<td>
						<u>Comment</u>
					</td>
					<td>
						<u>Date Recorded</u>
					</td>
				</tr>
				<xsl:for-each select="/cd:ReferralDocument/cd:MessageDataRef/cd:ClinicalDataRef/cd:Alerts/gen:LifestyleRisk/gen:AlcoholConsumptionHistory/gen:AlcoholConsumptionRecord">
					<tr>
						<td>
							<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeValue"/>
						</td>
						<td>
							<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeId"/>
						</td>
						<td>
							<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeVersion"/>
						</td>
						<td>
							<xsl:choose>
								<xsl:when test="./gen:ClinicalWarning/gen:ClinicalInformation">
									<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCodeDescription"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalCircumstanceDescription"/>
								</xsl:otherwise>
							</xsl:choose>
						</td>
						<td>
							<xsl:value-of select="./gen:Comment"/>
						</td>
						<td>
							<xsl:call-template name="format_text">
								<xsl:with-param name="date">
									<xsl:value-of select="./gen:DateRecorded"/>
								</xsl:with-param>
							</xsl:call-template>
						</td>
					</tr>
				</xsl:for-each>
			</xsl:if>
			<xsl:if test="count(//gen:SmokingConsumptionRecord) > 0">
				<tr>
					<th>Smoking Consumption History</th>
				</tr>
				<tr>
					<td>
						<u>Code</u>
					</td>
					<td>
						<u>Code Scheme</u>
					</td>
					<td>
						<u>Code Scheme Version</u>
					</td>
					<td>
						<u>Description</u>
					</td>
					<td>
						<u>Comment</u>
					</td>
					<td>
						<u>Date Recorded</u>
					</td>
				</tr>
				<xsl:for-each select="/cd:ReferralDocument/cd:MessageDataRef/cd:ClinicalDataRef/cd:Alerts/gen:LifestyleRisk/gen:SmokingConsumptionHistory/gen:SmokingConsumptionRecord">
					<tr>
						<td>
							<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeValue"/>
						</td>
						<td>
							<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeId"/>
						</td>
						<td>
							<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeVersion"/>
						</td>
						<td>
							<xsl:choose>
								<xsl:when test="./gen:ClinicalWarning/gen:ClinicalInformation">
									<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCodeDescription"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalCircumstanceDescription"/>
								</xsl:otherwise>
							</xsl:choose>
						</td>
						<td>
							<xsl:value-of select="./gen:Comment"/>
						</td>
						<td>
							<xsl:call-template name="format_text">
								<xsl:with-param name="date">
									<xsl:value-of select="./gen:DateRecorded"/>
								</xsl:with-param>
							</xsl:call-template>
						</td>
					</tr>
				</xsl:for-each>
			</xsl:if>
			<xsl:if test="count(//gen:ExerciseStatusRecord) > 0">
				<tr>
					<th>Exercise Status History</th>
				</tr>
				<tr>
					<td>
						<u>Code</u>
					</td>
					<td>
						<u>Code Scheme</u>
					</td>
					<td>
						<u>Code Scheme Version</u>
					</td>
					<td>
						<u>Description</u>
					</td>
					<td>
						<u>Comment</u>
					</td>
					<td>
						<u>Date Recorded</u>
					</td>
				</tr>
				<xsl:for-each select="/cd:ReferralDocument/cd:MessageDataRef/cd:ClinicalDataRef/cd:Alerts/gen:LifestyleRisk/gen:ExerciseStatusHistory/gen:ExerciseStatusRecord">
					<tr>
						<td>
							<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeValue"/>
						</td>
						<td>
							<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeId"/>
						</td>
						<td>
							<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeVersion"/>
						</td>
						<td>
							<xsl:choose>
								<xsl:when test="./gen:ClinicalWarning/gen:ClinicalInformation">
									<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCodeDescription"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalCircumstanceDescription"/>
								</xsl:otherwise>
							</xsl:choose>
						</td>
						<td>
							<xsl:value-of select="./gen:Comment"/>
						</td>
						<td>
							<xsl:call-template name="format_text">
								<xsl:with-param name="date">
									<xsl:value-of select="./gen:DateRecorded"/>
								</xsl:with-param>
							</xsl:call-template>
						</td>
					</tr>
				</xsl:for-each>
			</xsl:if>
		</table>
	<br/>
	</xsl:template>
	<xsl:template match="gen:SmokingConsumption">
		<xsl:variable name="description" select="normalize-space(translate(., 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz'))"/>
		<xsl:choose>
			<xsl:when test="$description='trivial smoker'">
				1
			</xsl:when>
			<xsl:when test="$description='light smoker'">
				1-9
			</xsl:when>
			<xsl:when test="$description='moderate smoker'">
				10-19
			</xsl:when>
			<xsl:when test="$description='heavy smoker'">
				20-39
			</xsl:when>
			<xsl:when test="$description='very heavy smoker'">
				40+
			</xsl:when>
			<xsl:when test="$description='not known'">
				?
			</xsl:when>
			<xsl:otherwise>
				0
			</xsl:otherwise>
		</xsl:choose>
        &#160;(<xsl:value-of select="$description"/>)
	</xsl:template>
	<xsl:template match="gen:AlcoholConsumption">
		<xsl:variable name="description" select="normalize-space(translate(., 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz'))"/>
		<xsl:choose>
			<xsl:when test="$description='teetotaller'">
				0
			</xsl:when>
			<xsl:when test="$description='trivial drinker'">
				1
			</xsl:when>
			<xsl:when test="$description='light drinker'">
				1-2
			</xsl:when>
			<xsl:when test="$description='moderate drinker'">
				3-6
			</xsl:when>
			<xsl:when test="$description='heavy drinker'">
				7-9
			</xsl:when>
			<xsl:when test="$description='very heavy drinker'">
				9+
			</xsl:when>
			<xsl:when test="$description='not known'">
				?
			</xsl:when>
			<xsl:otherwise>
				0
			</xsl:otherwise>
		</xsl:choose>
        &#160;(<xsl:value-of select="$description"/>)
	</xsl:template>
	<xsl:template match="gen:Allergy | gen:Intolerance | gen:RiskToOthers ">
		<tr>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeValue"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>&#160;&#160;</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeId"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>&#160;&#160;</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeVersion"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>&#160;&#160;</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:choose>
							<xsl:when test="gen:ClinicalWarning/gen:ClinicalInformation">
								<xsl:value-of select="gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCodeDescription"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="gen:ClinicalWarning/gen:ClinicalCircumstanceDescription"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>&#160;&#160;</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:Comment"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>&#160;&#160;</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:Modifier"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>&#160;&#160;</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="date">
						<xsl:value-of select="gen:StartDate"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>&#160;&#160;</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="date">
						<xsl:value-of select="gen:DateRecorded"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
		</tr>
	</xsl:template>
	<xsl:template name="format_text">
		<xsl:param name="text"/>
		<xsl:param name="date"/>
		<xsl:param name="datetime"/>
		<xsl:param name="default" select="$default_blank"/>
		<xsl:choose>
			<xsl:when test="normalize-space($date)">
				<xsl:value-of select="user:UnambiguousDate(string($date))"/>
			</xsl:when>
			<xsl:when test="normalize-space($datetime)">
				<xsl:value-of select="$datetime"/>
			</xsl:when>
			<xsl:when test="normalize-space($text)">
				<xsl:value-of disable-output-escaping="yes" select="user:FormatText(string($text))"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$default"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="formatDate">
		<xsl:param name="d"/>
		<xsl:choose>
			<xsl:when test="$d">
				<xsl:value-of select="substring($d,9,2)"/>
				<xsl:text>-</xsl:text>
				<xsl:value-of select="substring($d,6,2)"/>
				<xsl:text>-</xsl:text>
				<xsl:value-of select="substring($d,1,4)"/>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- Format the sex -->
	<xsl:template name="formatSex">
		<xsl:param name="sex"/>
		<xsl:choose>
			<xsl:when test="$sex='F'">Female</xsl:when>
			<xsl:when test="$sex='M'">Male</xsl:when>
			<xsl:otherwise>Not specified</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!-- Format Y or N -->
	<xsl:template name="formatYorN">
		<xsl:param name="value"/>
		<xsl:choose>
			<xsl:when test="$value='Y'">Yes</xsl:when>
			<xsl:when test="$value='N'">No</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="displayValue">
					<xsl:with-param name="value" select="$value"/>
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!-- Format sensitivity -->
	<xsl:template name="formatSensitivity">
		<xsl:param name="value"/>
		<xsl:choose>
			<xsl:when test="$value='HS'">Highly Sensitive</xsl:when>
			<xsl:when test="$value='S'">Sensitive</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="displayValue">
					<xsl:with-param name="value" select="$value"/>
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!-- check for empty value and put a character if no value -->
	<xsl:template name="displayValue">
		<xsl:param name="value"/>
		<xsl:param name="formatLineBreaks"/>
		<xsl:variable name="defaultBlank" select="'-'"/>
		<xsl:choose>
			<xsl:when test="string-length($value) &lt; 1">
				<xsl:value-of select="$defaultBlank"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="$formatLineBreaks = 'true'">
						<xsl:value-of disable-output-escaping="yes" select="user:FormatLineBreaks(string($value))"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$value"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
