<?xml version="1.0" encoding="UTF-8"?>
<!--?xml-stylesheet type="text/xsl" href="K:\R9-1-1\web\stylesheets\refLetter.xslt"?-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:pbr="http://www.show.scot.nhs.uk/isd/PBR" xmlns:ref="http://www.show.scot.nhs.uk/isd/Referral" xmlns:gen="http://www.show.scot.nhs.uk/isd/General" xmlns:msxsl="urn:schemas-microsoft-com:xslt" xmlns:user="http://www.sci.scot.nhs.uk" exclude-result-prefixes="user msxsl">
	<xsl:output method="html" version="1.0" encoding="iso-8859-1" indent="yes"/>
	<xsl:variable name="default_blank" select="'-'"/>
	<msxsl:script language="JScript" implements-prefix="user"><![CDATA[
		
		function GetMonth(strMonthNumber)
		{
			var strMonth;
			
			switch (strMonthNumber) {
				case "01" :
					strMonth = "Jan";
					break;
				case "02" :
					strMonth = "Feb";
					break;
				case "03" :
					strMonth = "Mar";
					break;
				case "04" :
					strMonth = "Apr";
					break;
				case "05" :
					strMonth = "May";
					break;
				case "06" :
					strMonth = "Jun";
					break;
				case "07" :
					strMonth = "Jul";
					break;
				case "08" :
					strMonth = "Aug";
					break;
				case "09" :
					strMonth = "Sep";
					break;
				case "10" :
					strMonth = "Oct";
					break;
				case "11" :
					strMonth = "Nov";
					break;
				case "12" :
					strMonth = "Dec";
					break; 
				default :
					strMonth = "   ";
			} 
			return(strMonth);
		}
		
		function FormatLineBreaks(strTextToFormat)
		{
			var CrLf = String.fromCharCode(13, 10);
			var Cr = String.fromCharCode(13);
			var Lf = String.fromCharCode(10);
			var NewLine = String.fromCharCode(10);
			
			var strOut = new String();
			strOut = strTextToFormat.replace(/</g, '&lt;');
			strOut = strOut.replace(/>/g, '&gt;');
			var aCharArray = new Array(NewLine, CrLf, Cr, Lf) 
			
			for( var i = 0; i < 4; i++)
			{
				while(strOut.match(aCharArray[i]))
				{
					strOut = strOut.replace(aCharArray[i], '<br/>');
				}
			}		
			return(strOut); 	    
		}
		
		function IsDate(strValue)
		{
			return(!isNaN(new Date(strValue)));  
		}
		
		function UnambiguousDate(strAmbiguousDate)
		{
			 var dteDate;
			 var strDay, strMonth, strYear, strDate;
			
			 // Garaunteed formats
			 strDate = new String(strAmbiguousDate);
			 strYear = strDate.substring(0,4);  
			 strMonth = strDate.substring(5,7);
			 strDay = strDate.substring(8,10);
			
			 if (IsDate(new Date(strYear,strMonth,strDay)))
			 {
				 return(strDay + "-" + GetMonth(strMonth) + "-" + strYear);
			 }
		}
		
		function IsNumeric(str)
		{
			for (var i=0; i < str.length; i++)
			{
				var ch = str.substring(i, i+1)
				if( ch < "0" || ch>"9" || str.length == null)
				{
					return (false);
				}     
			}
			return (true);
		}
		
		function IsTime(strTimeToCheck)
		{
			var strHour;
			var strMinute;
			var strSecond;
			var lFirstColon;
			var lSecondColon;
			var arrMask = new Array(4);
			var lCount;
			var bValidated;
			var strTime;
			var bIsTime;
			var lValMask;
			
			bIsTime = true;		
			strTime = new String(strTimeToCheck);
			
			arrMask[0] = new String( "9:99");
			arrMask[1] = new String("99:99");
			arrMask[2] = new String("9:99:99");
			arrMask[3] = new String("99:99:99");
			bValidated = false;
			
			for(lCount = 0; lCount < 4;  lCount++)
			{
				  // the mask needs to be the same size as the time
				 if(arrMask[lCount].length == strTime.length)
				 {
					// check the mask
					bValidated = ValidateMask(arrMask[lCount],  strTime);
					if(bValidated)
					{
						lValMask = arrMask[lCount];
						break;
					}
				 }
			}
			
			if(bValidated)
			{
				//based on the mask check that the hours, minutes and seconds are okay (00:00:00-23:59:59)
				
				//get the colons
				lFirstColon = arrMask[lCount].indexOf(":");
				
				if ((lCount == 2) || (lCount == 3))
					lSecondColon = arrMask[lCount].indexOf(":", lFirstColon + 1);
				else
					lSecondColon = 0;
				
				//get the hours
				strHour = strTime.substr(0,lFirstColon);
				bIsTime = ValidateTimeLimit(strHour, 23);
				
				// get the minutes
				strMinute = strTime.substr(lFirstColon + 1, 2);
				bIsTime = ValidateTimeLimit(strMinute, 59);
				
				if(lSecondColon)
				{
					// get the seconds
					strSecond = strTime.substr(lSecondColon + 1, 2);	
					bIsTime = ValidateTimeLimit(strSecond, 59);
				}
			}	
			else
			{
				bIsTime = false;
			}
			return(bIsTime);
		}
		
		function ValidateTimeLimit(strTimeElement, lConstraint)
		{	
		   var bValidateTimeLimit; 
			
		   bValidateTimeLimit = true;
		   if (IsNumeric(strTimeElement))
		   {
			  if (!(strTimeElement <= lConstraint))
				 bValidateTimeLimit = false;
		   }		
		   else
			  bValidateTimeLimit = false;
			
		   return(bValidateTimeLimit);
		}
		
		function ValidateMask(strValidateMask, strValidateTime)
		{
			var bValidated;
			var strMask;
			var strTime
			
			strMask = new String(strValidateMask);
			strTime = new String(strValidateTime);
			
			bValidated = true;
			for(var lCount = 1; lCount < strTime.length + 1; lCount++)
			{  
				if((strMask.substr(lCount, 1) == "9"))  
				{  
					 if(!(IsNumeric(strTime.substr(lCount, 1))))
					 {
						bValidated = false;
						break;
					 }
				}	
				else
				{
					 if (strMask.substr(lCount, 1) == ":")
					 {  
						if(!(strMask.substr(lCount, 1) == strTime.substr(lCount, 1)))
						{
						   bValidated = false;
						   break;
						}
					 }  
				}
			}					
			return(bValidated);
		}
		
		function UnambiguousDateShortTime(p_dteDate, p_strDefault)
		{
			var strTempDate, strTempTime;
			var lSpace;
			var strUnambiguousDateShortTime;
			var strDate = new String(p_dteDate);
			var strDefault = new String(p_strDefault);
			var dteTempDate = new Date(p_dteDate);
			
			strUnambiguousDateShortTime = strDefault;
			
			strDate.replace( "T", " ");
			
			if(strDate.lenth)
			{
				if (IsDate(strDate))
					strUnambiguousDateShortTime = UnambiguousDate(strDate, strDefault) + " " + dteTempDate.getDay() + "-" + dteTempDate.getMonth() + dteTempDate.getYear();
				else
				{
					 lSpace = strDate.indexOf(" ");
					 strTempDate = strDate.substr(0,strDate.indexOf(" "));
					 strTempTime = strDate.substr(strDate.indexOf(" ") + 1);
					 
					 if(IsDate(strTempDate)) 
					 {
						if(IsTime(strTempTime))
						   strUnambiguousDateShortTime = UnambiguousDate(strTempDate, strDefault) + " " 
						   +   dteTempDate.getDay() + "-" + dteTempDate.getMonth() + dteTempDate.getYear();
						else
							strUnambiguousDateShortTime = UnambiguousDate(strTempDate, strDefault) + " " + strTempTime;
					}
				}
			} 	    
			return(strUnambiguousDateShortTime);  
		}
		
	]]></msxsl:script>
	<xsl:template match="ref:ReferralDocument">
		<style>
					body {
						font-family: Tahoma, Arial, Helvetica, sans-serif;
						font-size: 11px;
						margin-top : 15px;
						margin-left : 15px;
						background-color: white;
					}
				
					p {
						margin-bottom : 2px;
						margin-top : 2px;
					}
					
					h1 {
						font-size: 16 px;
						font-weight: bold;
						color : black;
						margin-bottom : 4px;
						margin-top : 4px;
						font-family : Verdana, Geneva, Arial, Helvetica, sans-serif;
					}
					
					h2 {
						font-size: 14 px;
						margin-bottom : 3px;
						margin-top : 3px;
						font-family : Verdana, Geneva, Arial, Helvetica, sans-serif;
						font-weight: normal;
					}
					
					h3 {
						font-size: 10px ;
						font-family : Verdana, Geneva, Arial, Helvetica, sans-serif;
						margin-bottom : 2px;
						margin-top : 2px;
						font-weight : bold;
					}
					
					h4 {
						font-size: 11 px ;
						font-family : Verdana, Geneva, Arial, Helvetica, sans-serif;
						margin-bottom : 2px;
						margin-top : 8px;
						text-indent : 32px;
						font-weight : normal;
						text-decoration : underline;
					}
					
					h5 {
						font-size: 11 px ;
						font-family : Verdana, Geneva, Arial, Helvetica, sans-serif;
						margin-bottom : 2px;
						margin-top : 8px;
						text-indent : 48px;
						font-weight : normal;
					}
					
					h6 {
						font-size: 10 px ;
						font-family : Verdana, Geneva, Arial, Helvetica, sans-serif;
						margin-bottom : 2px;
						margin-top : 8px;
						text-indent : 60px;
						font-weight : bold;
					}
					
					break {
						page-break-before : always;
					}
				
					a {
						text-decoration: underline;
						color: Navy;
					}
					
					a:hover {
						text-decoration: none;
						color : Red;
					}
					
					table {
						font-size: 11 px ;
					}
					
					.hashed {
						background-color: lightgrey;
						font-weight:bold;
					}
					
					.essential {
						font-weight:bold;
						color:red;
					}
					
					.urgency {
						font-size:20 px;
						color:navy;
					}
					
					.sensitivity{
						font-size:20 px;
						color:navy;
					}
					
					.barcode{
						font-family: SCIBC;
						font-size:20 px;
					}
					
					.barcodeText{
						font-family: Tahoma, Arial, Helvetica, sans-serif;
						font-size: 9px;
					}
					
					.boxedArea{
						border-style:solid;
						border-color:black;
						border-width:1px;
						vertical-align:top;
					}
			</style>
		<div style="width:98%;">
			<table border="1" width="100%" cellpadding="2" cellspacing="0" style="border-width:0;border-style:none;padding-left:1;">
				<tr>
					<td width="7%" valign="top" bordercolor="black" style="border-right-width:0; border-top-style:none;">
						<p>Hospital use only</p>
					</td>
					<td width="48%" valign="top" bordercolor="black" style="border-right-width:0; border-top-style:none;">
						<p>Clinic</p>
					</td>
					<td width="15%" valign="top" bordercolor="black" style="border-right-width:0; border-top-style:none;">
						<p>Day</p>
						<p>Date</p>
					</td>
					<td width="15%" valign="top" bordercolor="black" style="border-right-width:0; border-top-style:none;">
						<p>Time</p>
					</td>
					<td width="15%" valign="top" bordercolor="black" style="border-top-style:none;">
						<p>Hospital<br/>No.</p>
					</td>
				</tr>
			</table>
			<br/>
			<xsl:apply-templates select="ref:MessageDataRef"/>
		</div>
	</xsl:template>
	<xsl:template match="ref:MessageDataRef">
		<table border="1" width="100%" cellpadding="0" cellspacing="0" style="border-width:0;border-style:none;">
			<tr>
				<td width="25%" bordercolor="black">
					<p>
						<b>
							<center>Transport required?</center>
						</b>
					</p>
					<xsl:if test="ref:PatientAdministrationRef/ref:TransportDetails">
						<xsl:apply-templates select="ref:PatientAdministrationRef/ref:TransportDetails" mode="flag"/>
					</xsl:if>
				</td>
				<td width="50%" style="border-style:none;">
					<xsl:if test="../ref:DocumentData/gen:UniqueCarePathwayNumber">
						<center>
							<div class="barcode">
								*<xsl:value-of select="../ref:DocumentData/gen:UniqueCarePathwayNumber"/>*
							</div>
							<div class="barcodeText">
								Unique Care Pathway Number: <xsl:value-of select="../ref:DocumentData/gen:UniqueCarePathwayNumber"/>
							</div>
						</center>
					</xsl:if>
					<center>
						<h1>REFERRAL LETTER</h1>
					</center>
					<center>
						<h2>MEDICAL IN CONFIDENCE</h2>
					</center>
				</td>
				<td width="25%" bordercolor="black">
					<xsl:choose>
						<xsl:when test="../ref:DocumentData/gen:ConsentToShare">
							<xsl:attribute name="style">border-style:;</xsl:attribute>
							<p>
								<b>
									<center>
										<!-- Consent to share info -->
										<xsl:choose>
											<xsl:when test="../ref:DocumentData/gen:ConsentToShare='Y'">
												Consent to share 
											</xsl:when>
											<xsl:when test="../ref:DocumentData/gen:ConsentToShare='N'">
												No consent to share
											</xsl:when>
											<xsl:otherwise>
												Consent to share: '<xsl:value-of select="../ref:DocumentData/gen:ConsentToShare"/>'
											</xsl:otherwise>
										</xsl:choose>
									</center>
								</b>
							</p>
						</xsl:when>
						<xsl:otherwise>
							<xsl:attribute name="style">border-style:none;</xsl:attribute>&#160;
						</xsl:otherwise>
					</xsl:choose>
				</td>
			</tr>
		</table>
		<br/>
		<table border="1" width="100%" cellpadding="2" cellspacing="2" bordercolor="black" frame="box">
			<xsl:apply-templates select="ref:PatientAdministrationRef/ref:ReferralTo"/>
			<tr>
				<td width="100%" bordercolor="black" colspan="3">
					<table border="0" width="100%" cellpadding="0" cellspacing="0">
						<tr>
							<td width="27%">
								<p>
									<b>Urgency of referral</b>
								</p>
							</td>
							<td class="urgency" width="28%" align="center">
								<xsl:choose>
									<xsl:when test="ref:PatientAdministrationRef/ref:ReferralUrgencyValue='Soon'">
										<xsl:attribute name="style">font-style:italic;</xsl:attribute>
									</xsl:when>
									<xsl:when test="ref:PatientAdministrationRef/ref:ReferralUrgencyValue='Urgent'">
										<xsl:attribute name="style">font-weight:bold;</xsl:attribute>
									</xsl:when>
								</xsl:choose>
								<xsl:value-of select="ref:PatientAdministrationRef/ref:ReferralUrgencyValue"/>&#160;&#160;
				</td>
							<td width="45%">
					&#160;<xsl:value-of select="ref:PatientAdministrationRef/ref:ReferralUrgencyReason"/>
							</td>
						</tr>
						<!-- Sensitivity -->
						<xsl:if test="../ref:DocumentData/gen:Sensitivity">
							<tr>
								<td width="27%">
									<p>
										<b>Sensitivity of referral</b>
									</p>
								</td>
								<td class="sensitivity" width="28%" align="center">
									<xsl:choose>
										<xsl:when test="../ref:DocumentData/gen:Sensitivity='S'">
										Sensitive 
									</xsl:when>
										<xsl:when test="../ref:DocumentData/gen:Sensitivity='HS'">
											<xsl:attribute name="style">font-weight:bold;</xsl:attribute>
										Highly Sensitive
									</xsl:when>
										<xsl:otherwise>
											<xsl:value-of select="../ref:DocumentData/gen:Sensitivity"/>
										</xsl:otherwise>
									</xsl:choose>
								</td>
							</tr>
						</xsl:if>
					</table>
				</td>
			</tr>
			<xsl:if test="ref:PatientAdministrationRef/ref:GenericAdministrativeInformation/ref:GenericAdministrativeInformationInstance[@FrontPageInformation='true']">
				<xsl:apply-templates select="ref:PatientAdministrationRef/ref:GenericAdministrativeInformation"/>
			</xsl:if>
			<xsl:apply-templates select="ref:PatientAdministrationRef/ref:TransportDetails"/>
		</table>
		<br/>
		<table border="1" width="100%" cellpadding="2" cellspacing="2" bordercolor="black" frame="box">
			<xsl:apply-templates select="ref:PatientDemographics"/>
		</table>
		<br/>
		<table border="1" width="100%" cellpadding="2" cellspacing="2" bordercolor="black" frame="box">
			<tr>
				<td width="50%" colspan="4" style="border-style:none;" valign="top">
					<h3>REGISTERED GP DETAILS</h3>
				</td>
				<td width="5%" style="border-style:none;" rowspan="6"/>
				<td width="45%" height="25" class="essential" valign="bottom" style="border-style:none;">
					Practice address
				</td>
			</tr>
			<xsl:apply-templates select="ref:PatientDemographics/gen:RegisteredGp"/>
		</table>
		<br/>
		<xsl:choose>
			<xsl:when test="ref:PatientAdministrationRef/ref:Referrer/ref:ReferringGP">
				<table border="1" width="100%" cellpadding="2" cellspacing="2" bordercolor="black" frame="box">
					<tr>
						<td width="50%" colspan="4" style="border-style:none;" valign="top">
							<h3>REFERRING PRACTITIONER DETAILS</h3>
						</td>
						<td width="5%" style="border-style:none;" rowspan="6"/>
						<td width="45%" height="25" class="essential" valign="bottom" style="border-style:none;">
						Practice address
					</td>
					</tr>
					<xsl:apply-templates select="ref:PatientAdministrationRef/ref:Referrer/ref:ReferringGP"/>
				</table>
			</xsl:when>
			<xsl:when test="ref:PatientAdministrationRef/ref:Referrer/ref:ReferringParty">
				<table border="1" width="100%" cellpadding="2" cellspacing="2" bordercolor="black" frame="box">
					<tr>
						<td width="50%" colspan="4" style="border-style:none;" valign="top">
							<h3>REFERRING HCP DETAILS</h3>
						</td>
						<td width="5%" style="border-style:none;" rowspan="6"/>
						<td width="45%" height="25" class="essential" valign="bottom" style="border-style:none;">
							Organisation address
						</td>
					</tr>
					<xsl:apply-templates select="ref:PatientAdministrationRef/ref:Referrer/ref:ReferringParty"/>
				</table>
			</xsl:when>
		</xsl:choose>
		<br/>
		<h3 style="page-break-before:always;">CLINICAL INFORMATION</h3>
		<div style="border:1 solid black; width:100%;">
			<table border="0" width="100%" cellpadding="2px">
				<tr>
					<td>
						<xsl:apply-templates mode="top_section" select="ref:ClinicalDataRef/ref:CurrentClinicalDataRef"/>
					</td>
				</tr>
			</table>
			<p>_______________________________</p>
			<table border="0" width="100%" cellpadding="2px">
				<tr>
					<td>
						<xsl:apply-templates select="ref:PatientAdministrationRef/ref:ReferralReason"/>
					</td>
				</tr>
			</table>
			<p>_______________________________</p>
			<table border="0" width="100%" cellpadding="2px">
				<tr>
					<td>
						<p>
							<span class="essential">Patient Measurements</span>
						</p>
						<xsl:apply-templates select="ref:ClinicalDataRef/ref:BackgroundData/ref:PatientMeasurements"/>
					</td>
				</tr>
			</table>
			<p>_______________________________</p>
			<table border="0" width="100%" cellpadding="2px">
				<tr>
					<td>
						<p>
							<span class="essential">Past medical history</span>
						</p>
						<xsl:apply-templates select="ref:ClinicalDataRef/ref:BackgroundData/ref:MedicalHistory"/>
					</td>
				</tr>
			</table>
			<p>_______________________________</p>
			<table border="0" width="100%" cellpadding="2px">
				<tr>
					<td>
						<p>
							<span class="essential">Current and recent medication</span>
						</p>
						<table border="0" cellspacing="2px" valign="top" style="padding-top:0;paddingbottom:0;padding-left:10px;padding-right:4px;">
							<xsl:choose>
								<xsl:when test="normalize-space(concat(ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:CurrentMedication, ref:ClinicalDataRef/ref:BackgroundData/ref:MedicalHistory/gen:PastMedication/gen:MedicationOnRecord))">
									<xsl:if test="ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:CurrentMedication">
										<tr>
											<td>
												<b>Current Medication</b>
											</td>
										</tr>
										<tr align="left">
											<td>
												<u>Drug name</u>
											</td>
											<td>&#160;&#160;</td>
											<td>
												<u>BNF code</u>
											</td>
											<td>&#160;&#160;</td>
											<td>
												<u>Code Scheme</u>
											</td>
											<td>&#160;&#160;</td>
											<td>
												<u>Code Scheme Version</u>
											</td>
											<td>&#160;&#160;</td>
											<td>
												<u>Formulation</u>
											</td>
											<td>&#160;&#160;</td>
											<td>
												<u>Dosage</u>
											</td>
											<td>&#160;&#160;</td>
											<td>
												<u>Frequency</u>
											</td>
											<td>&#160;&#160;</td>
											<td>
												<u>Course started</u>
											</td>
											<td>&#160;&#160;</td>
											<td>
												<u>End Date</u>
											</td>
										</tr>
										<xsl:apply-templates select="ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:CurrentMedication"/>
									</xsl:if>
									<xsl:if test="ref:ClinicalDataRef/ref:BackgroundData/ref:MedicalHistory/gen:PastMedication/gen:MedicationOnRecord">
										<tr>
											<td>
												<b>Recently Prescribed Medication</b>
											</td>
										</tr>
										<tr align="left">
											<td>
												<u>Drug name</u>
											</td>
											<td>&#160;&#160;</td>
											<td>
												<u>BNF code</u>
											</td>
											<td>&#160;&#160;</td>
											<td>
												<u>Code Scheme</u>
											</td>
											<td>&#160;&#160;</td>
											<td>
												<u>Code Scheme Version</u>
											</td>
											<td>&#160;&#160;</td>
											<td>
												<u>Formulation</u>
											</td>
											<td>&#160;&#160;</td>
											<td>
												<u>Dosage</u>
											</td>
											<td>&#160;&#160;</td>
											<td>
												<u>Frequency</u>
											</td>
											<td>&#160;&#160;</td>
											<td>
												<u>Course started</u>
											</td>
											<td>&#160;&#160;</td>
											<td>
												<u>End Date</u>
											</td>
										</tr>
										<xsl:apply-templates select="ref:ClinicalDataRef/ref:BackgroundData/ref:MedicalHistory/gen:PastMedication/gen:MedicationOnRecord"/>
									</xsl:if>
								</xsl:when>
								<xsl:otherwise>
									<tr align="left">
										<td>No medications recorded</td>
									</tr>
								</xsl:otherwise>
							</xsl:choose>
						</table>
					</td>
				</tr>
			</table>
			<p>_______________________________</p>
			<table border="0" width="100%" cellpadding="2px">
				<tr>
					<td width="60%">
						<span class="essential">Clinical warnings</span>
					</td>
					<td width="20%">Smoking status</td>
					<td width="20%">Alcohol consumption</td>
				</tr>
				<xsl:apply-templates mode="alerts_section" select="ref:ClinicalDataRef/ref:Alerts"/>
			</table>
			<p>_______________________________</p>
			<table border="0" width="100%" cellpadding="2px">
				<tr>
					<td>
						<p>
							<span class="essential">Additional relevant information </span>
						</p>
						<xsl:if test="normalize-space(ref:PatientAdministrationRef/pbr:AdditionalInfo[not('')]) or normalize-space(ref:PatientAdministrationRef/ref:GenericAdministrativeInformation/ref:GenericAdministrativeInformationInstance[not('')])">
							<p>
								<b>Administrative information</b>
							</p>
							<table border="0">
								<xsl:apply-templates select="ref:PatientAdministrationRef/pbr:AdditionalInfo"/>
							</table>
							<table border="0">
								<xsl:for-each select="ref:PatientAdministrationRef/ref:GenericAdministrativeInformation/ref:GenericAdministrativeInformationInstance[not(@FrontPageInformation)]">
									<xsl:apply-templates select="."/>
								</xsl:for-each>
							</table>
							<p>&#160;</p>
						</xsl:if>
						<xsl:if test="normalize-space(ref:ClinicalDataRef/ref:BackgroundData/ref:FamilyHistory/gen:FamilyCondition)">
							<p>
								<b>Family conditions</b>
							</p>
							<table border="0" cellspacing="2px" valign="top" style="padding-top:0;paddingbottom:0;padding-left:0;padding-right:4px">
								<tr align="left">
									<td>
										<u>Code</u>
									</td>
									<td>&#160;&#160;</td>
									<td>
										<u>Code Scheme</u>
									</td>
									<td>&#160;&#160;</td>
									<td>
										<u>Code Scheme Version</u>
									</td>
									<td>&#160;&#160;</td>
									<td>
										<u>Description</u>
									</td>
									<td>&#160;&#160;</td>
									<xsl:if test="normalize-space(ref:ClinicalDataRef/ref:BackgroundData/ref:FamilyHistory/gen:FamilyCondition/gen:Laterality[not('')])">
										<td>
											<u>Laterality</u>
										</td>
										<td>&#160;&#160;</td>
									</xsl:if>
									<td>
										<u>Modifier</u>
									</td>
									<td>&#160;&#160;</td>
									<td>
										<u>Extension</u>
									</td>
									<td>&#160;&#160;</td>
									<td>
										<u>Relation to patient</u>
									</td>
									<td>&#160;&#160;</td>
									<xsl:if test="normalize-space(ref:ClinicalDataRef/ref:BackgroundData/ref:FamilyHistory/gen:FamilyCondition/gen:DateOfOnset[not('')])">
										<td>
											<u>Date of onset</u>
										</td>
									</xsl:if>
								</tr>
								<xsl:apply-templates select="ref:ClinicalDataRef/ref:BackgroundData/ref:FamilyHistory"/>
							</table>
							<p>&#160;</p>
						</xsl:if>
						<xsl:if test="normalize-space(ref:ClinicalDataRef/ref:BackgroundData/ref:SocialCircumstances[not('')])">
							<p>
								<b>Social circumstances</b>
							</p>
							<xsl:apply-templates select="ref:ClinicalDataRef/ref:BackgroundData/ref:SocialCircumstances"/>
							<p>&#160;</p>
						</xsl:if>
					</td>
				</tr>
			</table>
		</div>
		<!-- SEPARATOR TO SIGNATURE BOX -->
		<br/>
		<div style="width:100%;">
			<table border="0" style="border: 1 solid black;" align="right" cellspacing="8px" cellpadding="0">
				<tr>
					<td style="border-bottom: 1 solid black;padding= 0;" width="70%">
						<br/>
						<br/>
						<br/>
					</td>
					<td style="border-bottom: 1 solid black;padding=0;" width="30%">
						<br/>
						<br/>
						<br/>
					</td>
				</tr>
				<tr>
					<td>
						<span class="essential">Signature</span> of referring doctor (or other professional)</td>
					<td class="essential">Date</td>
				</tr>
			</table>
		</div>
		<!-- Referral To Treatment -->
		<xsl:if test="ref:PatientAdministrationRef/ref:ReferralToTreatmentPeriod">
			<h3 style="page-break-before:always;">REFERRAL TO TREATMENT (RTT) - ONWARD REFERRAL DATASET</h3>
			<div class="boxedArea">
				<xsl:apply-templates select="ref:PatientAdministrationRef/ref:ReferralToTreatmentPeriod"/>
			</div>
		</xsl:if>
		<xsl:if test="ref:PatientAdministrationRef/ref:ReferralToTreatmentData">
			<h3 style="page-break-before:always;">REFERRAL TO TREATMENT (RTT) - ONWARD REFERRAL DATASET</h3>
			<div class="boxedArea">
				<xsl:apply-templates select="ref:PatientAdministrationRef/ref:ReferralToTreatmentData"/>
			</div>
		</xsl:if>
	</xsl:template>
	<xsl:template match="ref:ReferralReason">
		<p>
			<span class="essential">Reason for referral</span>
		</p>
		<table>
			<xsl:choose>
				<xsl:when test="ref:StructuredReferralReason">
					<tr>
						<td>Care type requested:</td>
						<td>
							<xsl:call-template name="format_text">
								<xsl:with-param name="text">
									<xsl:value-of select="ref:StructuredReferralReason/ref:CareTypeRequested"/>
								</xsl:with-param>
							</xsl:call-template>
						</td>
					</tr>
					<tr>
						<td>Expected outcome:</td>
						<td>
							<xsl:call-template name="format_text">
								<xsl:with-param name="text">
									<xsl:value-of select="ref:StructuredReferralReason/ref:ExpectedOutcome"/>
								</xsl:with-param>
							</xsl:call-template>
						</td>
					</tr>
				</xsl:when>
				<xsl:when test="ref:UnstructuredReferralReason">
					<tr>
						<td colspan="2">
							<xsl:call-template name="format_text">
								<xsl:with-param name="text">
									<xsl:value-of select="."/>
								</xsl:with-param>
							</xsl:call-template>
						</td>
					</tr>
				</xsl:when>
			</xsl:choose>
			<xsl:if test="ref:Comment">
				<tr>
					<td>Comment:</td>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="ref:Comment"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
				</tr>
			</xsl:if>
		</table>
	</xsl:template>
	<!--************************** START OF CLINICAL DATA *********************************************************************************************-->
	<xsl:template match="ref:FamilyHistory">
		<xsl:if test="normalize-space(gen:FamilyCondition/gen:ConditionName/gen:ClinicalCircumstanceDescription) or normalize-space(gen:FamilyCondition/gen:ConditionName/gen:ClinicalInformation)">
			<tr>
				<td>
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:value-of select="gen:FamilyCondition/gen:ConditionName/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeValue"/>
						</xsl:with-param>
					</xsl:call-template>
				</td>
				<td>&#160;&#160;</td>
				<td>
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:value-of select="gen:FamilyCondition/gen:ConditionName/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeId"/>
						</xsl:with-param>
					</xsl:call-template>
				</td>
				<td>&#160;&#160;</td>
				<td>
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:value-of select="gen:FamilyCondition/gen:ConditionName/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeVersion"/>
						</xsl:with-param>
					</xsl:call-template>
				</td>
				<td>&#160;&#160;</td>
				<td>
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:choose>
								<xsl:when test="gen:FamilyCondition/gen:ConditionName/gen:ClinicalInformation">
									<xsl:value-of select="gen:FamilyCondition/gen:ConditionName/gen:ClinicalInformation/gen:ClinicalCodeDescription"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="gen:FamilyCondition/gen:ConditionName/gen:ClinicalCircumstanceDescription"/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:with-param>
					</xsl:call-template>
				</td>
				<td>&#160;&#160;</td>
				<xsl:if test="normalize-space(./gen:FamilyCondition/gen:Laterality[not('')])">
					<td valign="top">
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="gen:FamilyCondition/gen:Laterality"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
					<td>&#160;&#160;</td>
				</xsl:if>
				<td valign="top">
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:value-of select="gen:FamilyCondition/gen:Modifier"/>
						</xsl:with-param>
					</xsl:call-template>
				</td>
				<td>&#160;&#160;</td>
				<td valign="top">
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:value-of select="gen:FamilyCondition/gen:Comment"/>
						</xsl:with-param>
					</xsl:call-template>
				</td>
				<td>&#160;&#160;</td>
				<td valign="top">
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:value-of select="gen:RelationToPatient"/>
						</xsl:with-param>
					</xsl:call-template>
				</td>
				<td>&#160;&#160;</td>
				<xsl:if test="normalize-space(./gen:FamilyCondition/gen:DateOfOnset[not('')])">
					<td valign="top">
						<xsl:call-template name="format_text">
							<xsl:with-param name="date">
								<xsl:value-of select="gen:FamilyCondition/gen:DateOfOnset"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
				</xsl:if>
			</tr>
		</xsl:if>
	</xsl:template>
	<xsl:template match="ref:SocialCircumstances">
		<table border="0">
			<xsl:if test="normalize-space(gen:Housing[not('')])">
				<tr>
					<td>Housing:</td>
					<td>
						<xsl:value-of select="gen:Housing"/>
					</td>
				</tr>
			</xsl:if>
			<xsl:if test="normalize-space(gen:Employment[not('')])">
				<tr>
					<td>Employment:</td>
					<td>
						<xsl:value-of select="gen:Employment"/>
					</td>
				</tr>
			</xsl:if>
			<xsl:if test="normalize-space(gen:Religion[not('')])">
				<tr>
					<td>Religion:</td>
					<td>
						<xsl:value-of select="gen:Religion"/>
					</td>
				</tr>
			</xsl:if>
			<xsl:if test="normalize-space(gen:EthnicOrigin[not('')])">
				<tr>
					<td>Ethnic Origin:</td>
					<td>
						<xsl:value-of select="gen:EthnicOrigin"/>
					</td>
				</tr>
			</xsl:if>
			<xsl:if test="normalize-space(gen:Language[not('')])">
				<tr>
					<td>Language:</td>
					<td>
						<xsl:value-of select="gen:Language"/>
					</td>
				</tr>
			</xsl:if>
		</table>
	</xsl:template>
	<xsl:template mode="alerts_section" match="ref:ClinicalDataRef/ref:Alerts">
		<tr>
			<td width="60%">
				<xsl:if test="normalize-space(gen:LifestyleRisk[not('')])">
					<xsl:apply-templates select="gen:LifestyleRisk"/>
				</xsl:if>
				<xsl:if test="normalize-space(gen:Allergy[not('')])">
					<p>
						<b>Allergies</b>
					</p>
					<table border="0">
						<tr>
							<td>
								<u>Code</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Code Scheme</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Code Scheme Version</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Description</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Comment</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Modifier</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Start Date</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Recorded Date</u>
							</td>
						</tr>
						<xsl:apply-templates select="gen:Allergy"/>
					</table>
				</xsl:if>
				<xsl:if test="normalize-space(gen:Intolerance[not('')])">
					<p>
						<b>Intolerances</b>
					</p>
					<table border="0">
						<tr>
							<td>
								<u>Code</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Code Scheme</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Code Scheme Version</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Description</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Comment</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Modifier</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Start Date</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Recorded Date</u>
							</td>
						</tr>
						<xsl:apply-templates select="gen:Intolerance"/>
					</table>
				</xsl:if>
				<xsl:if test="normalize-space(gen:Lifestyle[not('')])">
					<p>
						<b>Life style factors</b>
					</p>
					<table border="0">
						<xsl:apply-templates select="gen:Lifestyle"/>
					</table>
				</xsl:if>
				<xsl:if test="normalize-space(gen:RiskToOthers[not('')])">
					<p>
						<b>Risks to others</b>
					</p>
					<table border="0">
						<tr>
							<td>
								<u>Code</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Code Scheme</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Code Scheme Version</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Description</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Comment</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Modifier</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Start Date</u>
							</td>
							<td>&#160;&#160;</td>
							<td>
								<u>Recorded Date</u>
							</td>
						</tr>
						<xsl:apply-templates select="gen:RiskToOthers"/>
					</table>
				</xsl:if>
			</td>
			<td width="20%" valign="top">
				<p style="border: 1 solid black;padding:2px;">
					Number per day
					<br/>
					<xsl:apply-templates select="gen:LifestyleRisk/gen:SmokingConsumption"/>
				</p>
			</td>
			<td width="20%" valign="top">
				<p style="border: 1 solid black;padding:2px;">
				Units per day
				<br/>
					<xsl:apply-templates select="gen:LifestyleRisk/gen:AlcoholConsumption"/>
				</p>
			</td>
		</tr>
	</xsl:template>
	<xsl:template match="gen:LifestyleRisk">
		<p>
			<b>Lifestyle risks</b>
		</p>
		<table border="0">
			<xsl:if test="normalize-space(gen:NonTherapeuticDrug[not('')])">
				<tr>
					<td>Non-therapeutic drugs:</td>
					<td>
						<xsl:value-of select="gen:NonTherapeuticDrug"/>
					</td>
				</tr>
			</xsl:if>
			<xsl:if test="normalize-space(gen:ReligiousObservance[not('')])">
				<tr>
					<td>Religious observance:</td>
					<td>
						<xsl:value-of select="gen:ReligiousObservance"/>
					</td>
				</tr>
			</xsl:if>
			<xsl:choose>
				<xsl:when test="normalize-space(gen:ExerciseStatus[text() = 'N/A'])"/>
				<xsl:when test="normalize-space(gen:ExerciseStatus[not('')])">
					<tr>
						<td>Exercise status:</td>
						<td>
							<xsl:value-of select="gen:ExerciseStatus"/>
						</td>
					</tr>
				</xsl:when>
				<xsl:otherwise/>
			</xsl:choose>
			<xsl:if test="count(//gen:AlcoholConsumptionRecord) > 0">
				<tr>
					<th>Alcohol Consumption History</th>
				</tr>
				<tr>
					<td>
						<u>Code</u>
					</td>
					<td>
						<u>Code Scheme</u>
					</td>
					<td>
						<u>Code Scheme Version</u>
					</td>
					<td>
						<u>Description</u>
					</td>
					<td>
						<u>Comment</u>
					</td>
					<td>
						<u>Date Recorded</u>
					</td>
				</tr>
				<xsl:for-each select="/ref:ReferralDocument/ref:MessageDataRef/ref:ClinicalDataRef/ref:Alerts/gen:LifestyleRisk/gen:AlcoholConsumptionHistory/gen:AlcoholConsumptionRecord">
					<tr>
						<td>
							<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeValue"/>
						</td>
						<td>
							<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeId"/>
						</td>
						<td>
							<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeVersion"/>
						</td>
						<td>
							<xsl:choose>
								<xsl:when test="./gen:ClinicalWarning/gen:ClinicalInformation">
									<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCodeDescription"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalCircumstanceDescription"/>
								</xsl:otherwise>
							</xsl:choose>
						</td>
						<td>
							<xsl:value-of select="./gen:Comment"/>
						</td>
						<td>
							<xsl:call-template name="format_text">
								<xsl:with-param name="date">
									<xsl:value-of select="./gen:DateRecorded"/>
								</xsl:with-param>
							</xsl:call-template>
						</td>
					</tr>
				</xsl:for-each>
			</xsl:if>
			<xsl:if test="count(//gen:SmokingConsumptionRecord) > 0">
				<tr>
					<th>Smoking Consumption History</th>
				</tr>
				<tr>
					<td>
						<u>Code</u>
					</td>
					<td>
						<u>Code Scheme</u>
					</td>
					<td>
						<u>Code Scheme Version</u>
					</td>
					<td>
						<u>Description</u>
					</td>
					<td>
						<u>Comment</u>
					</td>
					<td>
						<u>Date Recorded</u>
					</td>
				</tr>
				<xsl:for-each select="/ref:ReferralDocument/ref:MessageDataRef/ref:ClinicalDataRef/ref:Alerts/gen:LifestyleRisk/gen:SmokingConsumptionHistory/gen:SmokingConsumptionRecord">
					<tr>
						<td>
							<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeValue"/>
						</td>
						<td>
							<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeId"/>
						</td>
						<td>
							<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeVersion"/>
						</td>
						<td>
							<xsl:choose>
								<xsl:when test="./gen:ClinicalWarning/gen:ClinicalInformation">
									<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCodeDescription"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalCircumstanceDescription"/>
								</xsl:otherwise>
							</xsl:choose>
						</td>
						<td>
							<xsl:value-of select="./gen:Comment"/>
						</td>
						<td>
							<xsl:call-template name="format_text">
								<xsl:with-param name="date">
									<xsl:value-of select="./gen:DateRecorded"/>
								</xsl:with-param>
							</xsl:call-template>
						</td>
					</tr>
				</xsl:for-each>
			</xsl:if>
			<xsl:if test="count(//gen:ExerciseStatusRecord) > 0">
				<tr>
					<th>Exercise Status History</th>
				</tr>
				<tr>
					<td>
						<u>Code</u>
					</td>
					<td>
						<u>Code Scheme</u>
					</td>
					<td>
						<u>Code Scheme Version</u>
					</td>
					<td>
						<u>Description</u>
					</td>
					<td>
						<u>Comment</u>
					</td>
					<td>
						<u>Date Recorded</u>
					</td>
				</tr>
				<xsl:for-each select="/ref:ReferralDocument/ref:MessageDataRef/ref:ClinicalDataRef/ref:Alerts/gen:LifestyleRisk/gen:ExerciseStatusHistory/gen:ExerciseStatusRecord">
					<tr>
						<td>
							<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeValue"/>
						</td>
						<td>
							<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeId"/>
						</td>
						<td>
							<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeVersion"/>
						</td>
						<td>
							<xsl:choose>
								<xsl:when test="./gen:ClinicalWarning/gen:ClinicalInformation">
									<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCodeDescription"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="./gen:ClinicalWarning/gen:ClinicalCircumstanceDescription"/>
								</xsl:otherwise>
							</xsl:choose>
						</td>
						<td>
							<xsl:value-of select="./gen:Comment"/>
						</td>
						<td>
							<xsl:call-template name="format_text">
								<xsl:with-param name="date">
									<xsl:value-of select="./gen:DateRecorded"/>
								</xsl:with-param>
							</xsl:call-template>
						</td>
					</tr>
				</xsl:for-each>
			</xsl:if>
		</table>
	</xsl:template>
	<xsl:template match="gen:SmokingConsumption">
		<xsl:variable name="description" select="normalize-space(translate(., 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz'))"/>
		<xsl:choose>
			<xsl:when test="$description='trivial smoker'">
				1
			</xsl:when>
			<xsl:when test="$description='light smoker'">
				1-9
			</xsl:when>
			<xsl:when test="$description='moderate smoker'">
				10-19
			</xsl:when>
			<xsl:when test="$description='heavy smoker'">
				20-39
			</xsl:when>
			<xsl:when test="$description='very heavy smoker'">
				40+
			</xsl:when>
			<xsl:when test="$description='not known'">
				?
			</xsl:when>
			<xsl:otherwise>
				0
			</xsl:otherwise>
		</xsl:choose>
        &#160;(<xsl:value-of select="$description"/>)
	</xsl:template>
	<xsl:template match="gen:AlcoholConsumption">
		<xsl:variable name="description" select="normalize-space(translate(., 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz'))"/>
		<xsl:choose>
			<xsl:when test="$description='teetotaller'">
				0
			</xsl:when>
			<xsl:when test="$description='trivial drinker'">
				1
			</xsl:when>
			<xsl:when test="$description='light drinker'">
				1-2
			</xsl:when>
			<xsl:when test="$description='moderate drinker'">
				3-6
			</xsl:when>
			<xsl:when test="$description='heavy drinker'">
				7-9
			</xsl:when>
			<xsl:when test="$description='very heavy drinker'">
				9+
			</xsl:when>
			<xsl:when test="$description='not known'">
				?
			</xsl:when>
			<xsl:otherwise>
				0
			</xsl:otherwise>
		</xsl:choose>
        &#160;(<xsl:value-of select="$description"/>)
	</xsl:template>
	<xsl:template match="gen:Allergy | gen:Intolerance | gen:RiskToOthers ">
		<tr>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeValue"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>&#160;&#160;</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeId"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>&#160;&#160;</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeVersion"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>&#160;&#160;</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:choose>
							<xsl:when test="gen:ClinicalWarning/gen:ClinicalInformation">
								<xsl:value-of select="gen:ClinicalWarning/gen:ClinicalInformation/gen:ClinicalCodeDescription"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="gen:ClinicalWarning/gen:ClinicalCircumstanceDescription"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>&#160;&#160;</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:Comment"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>&#160;&#160;</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:Modifier"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>&#160;&#160;</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="date">
						<xsl:value-of select="gen:StartDate"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>&#160;&#160;</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="date">
						<xsl:value-of select="gen:DateRecorded"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
		</tr>
	</xsl:template>
	<xsl:template match="ref:CurrentMedication | gen:MedicationOnRecord">
		<tr>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:DrugName/gen:DrugCode/gen:DrugIdentifier"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>&#160;&#160;</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:DrugName/gen:DrugCode/gen:DrugCodeValue"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>&#160;&#160;</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:DrugName/gen:DrugCode/gen:DrugDictionary/gen:ClinicalCodeSchemeId"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>&#160;&#160;</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:DrugName/gen:DrugCode/gen:DrugDictionary/gen:ClinicalCodeSchemeVersion"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>&#160;&#160;</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:DrugName/gen:DrugCode/gen:Formulation"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>&#160;&#160;</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:apply-templates mode="dosagetext" select="."/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>&#160;&#160;</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:StructuredDosage/gen:Frequency"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>&#160;&#160;</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="date">
						<xsl:value-of select="gen:StructuredDosage/gen:MedicationStartDate"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>&#160;&#160;</td>
			<td>
				<xsl:choose>
					<xsl:when test="normalize-space(gen:StructuredDosage/gen:DrugDuration/gen:DrugDays/gen:TimeValue)">
						<xsl:value-of select="gen:StructuredDosage/gen:DrugDuration/gen:DrugDays/gen:TimeValue"/>&#160;<xsl:value-of select="gen:StructuredDosage/gen:DrugDuration/gen:DrugDays/gen:TimeUnit"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="format_text">
							<xsl:with-param name="date">
								<xsl:value-of select="gen:StructuredDosage/gen:DrugDuration/gen:MedicationStopDate"/>
							</xsl:with-param>
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</td>
		</tr>
	</xsl:template>
	<xsl:template mode="dosagetext" match="ref:CurrentMedication | gen:MedicationOnRecord">
		<xsl:choose>
			<xsl:when test="gen:UnstructuredDosage">
				<xsl:value-of select="gen:UnstructuredDosage"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="gen:StructuredDosage/gen:DoseDescription"/>
				<xsl:if test="gen:StructuredDosage/gen:TimeOfAdministration">
					 at 
					<xsl:value-of select="gen:StructuredDosage/gen:TimeOfAdministration"/>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template match="pbr:AdditionalInfo">
		<tr>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="."/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
		</tr>
	</xsl:template>
	<xsl:template match="ref:MedicalHistory">
		<xsl:if test="normalize-space(gen:PastCondition/gen:ConditionDisclosed)">
			<p>
				<b>Pre-existing conditions</b>
			</p>
			<table border="0" cellspacing="2px" valign="top" style="padding-top:0;paddingbottom:0;padding-left:0;padding-right:4px">
				<tr align="left">
					<td>
						<u>Code</u>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<u>Code Scheme</u>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<u>Code Scheme Version</u>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<u>Description</u>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<u>Laterality</u>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<u>Modifier</u>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<u>Extension</u>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<u>Date of onset</u>
					</td>
				</tr>
				<xsl:apply-templates select="gen:PastCondition/gen:ConditionDisclosed"/>
			</table>
		</xsl:if>
		<xsl:if test="normalize-space(gen:PastProcedure)">
			<p>
				<b>Past procedures</b>
			</p>
			<table border="0" cellspacing="2px" valign="top" style="padding-top:0;paddingbottom:0;padding-left:0;padding-right:4px">
				<tr align="left">
					<td>
						<u>Code</u>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<u>Code Scheme</u>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<u>Code Scheme Version</u>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<u>Description</u>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<u>Laterality</u>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<u>Modifier</u>
					</td>
					<td>&#160;&#160;</td>
					<td>
						<u>Date performed</u>
					</td>
				</tr>
				<xsl:apply-templates select="gen:PastProcedure/gen:ProcedureDisclosed"/>
			</table>
		</xsl:if>
	</xsl:template>
	<xsl:template match="gen:ConditionDisclosed">
		<xsl:if test="normalize-space(gen:ConditionName/gen:ClinicalCircumstanceDescription) or normalize-space(gen:ConditionName/gen:ClinicalInformation)">
			<tr>
				<td>
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:value-of select="gen:ConditionName/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeValue"/>
						</xsl:with-param>
					</xsl:call-template>
				</td>
				<td>&#160;&#160;</td>
				<td>
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:value-of select="gen:ConditionName/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeId"/>
						</xsl:with-param>
					</xsl:call-template>
				</td>
				<td>&#160;&#160;</td>
				<td>
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:value-of select="gen:ConditionName/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeVersion"/>
						</xsl:with-param>
					</xsl:call-template>
				</td>
				<td>&#160;&#160;</td>
				<td>
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:choose>
								<xsl:when test="gen:ConditionName/gen:ClinicalInformation">
									<xsl:value-of select="gen:ConditionName/gen:ClinicalInformation/gen:ClinicalCodeDescription"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="gen:ConditionName/gen:ClinicalCircumstanceDescription"/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:with-param>
					</xsl:call-template>
				</td>
				<td>&#160;&#160;</td>
				<td>
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:value-of select="gen:Laterality"/>
						</xsl:with-param>
					</xsl:call-template>
				</td>
				<td>&#160;&#160;</td>
				<td>
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:value-of select="gen:Modifier"/>
						</xsl:with-param>
					</xsl:call-template>
				</td>
				<td>&#160;&#160;</td>
				<td>
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:value-of select="gen:Comment"/>
						</xsl:with-param>
					</xsl:call-template>
				</td>
				<td>&#160;&#160;</td>
				<td>
					<xsl:call-template name="format_text">
						<xsl:with-param name="date">
							<xsl:value-of select="gen:DateOfOnset"/>
						</xsl:with-param>
					</xsl:call-template>
				</td>
			</tr>
		</xsl:if>
	</xsl:template>
	<xsl:template match="gen:ProcedureDisclosed">
		<xsl:if test="normalize-space(gen:Procedure/gen:ProcedureName/gen:ClinicalCircumstanceDescription) or normalize-space(gen:Procedure/gen:ProcedureName/gen:ClinicalInformation)">
			<tr>
				<td>
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:value-of select="gen:Procedure/gen:ProcedureName/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeValue"/>
						</xsl:with-param>
					</xsl:call-template>
				</td>
				<td>&#160;&#160;</td>
				<td>
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:value-of select="gen:Procedure/gen:ProcedureName/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeId"/>
						</xsl:with-param>
					</xsl:call-template>
				</td>
				<td>&#160;&#160;</td>
				<td>
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:value-of select="gen:Procedure/gen:ProcedureName/gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeScheme/gen:ClinicalCodeSchemeVersion"/>
						</xsl:with-param>
					</xsl:call-template>
				</td>
				<td>&#160;&#160;</td>
				<td>
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:choose>
								<xsl:when test="gen:Procedure/gen:ProcedureName/gen:ClinicalInformation">
									<xsl:value-of select="gen:Procedure/gen:ProcedureName/gen:ClinicalInformation/gen:ClinicalCodeDescription"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="gen:Procedure/gen:ProcedureName/gen:ClinicalCircumstanceDescription"/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:with-param>
					</xsl:call-template>
				</td>
				<td>&#160;&#160;</td>
				<td>
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:value-of select="gen:Procedure/gen:Laterality"/>
						</xsl:with-param>
					</xsl:call-template>
				</td>
				<td>&#160;&#160;</td>
				<td>
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:value-of select="gen:Procedure/gen:Modifier"/>
						</xsl:with-param>
					</xsl:call-template>
				</td>
				<td>&#160;&#160;</td>
				<td>
					<xsl:call-template name="format_text">
						<xsl:with-param name="date">
							<xsl:value-of select="gen:DatePerformed"/>
						</xsl:with-param>
					</xsl:call-template>
				</td>
			</tr>
		</xsl:if>
	</xsl:template>
	<xsl:template mode="top_section" match="ref:CurrentClinicalDataRef">
		<p class="essential"> History of presenting complaint / examination findings / investigation results</p>
		<xsl:apply-templates select="ref:PresentingComplaint"/>
		<xsl:if test="normalize-space(ref:Examinations[not('')])">
			<p>
				<b>Examinations and Investigations</b>
			</p>
			<table>
				<xsl:apply-templates select="ref:Examinations"/>
			</table>
		</xsl:if>
		<xsl:if test="normalize-space(ref:Investigations[not('')])">
			<p>
				<b>Investigations</b>
			</p>
			<table>
				<xsl:apply-templates select="ref:Investigations"/>
			</table>
		</xsl:if>
		<xsl:if test="ref:GenericCurrentClinicalInformation">
			<p class="essential">Other Relevant Clinical Information</p>
			<xsl:apply-templates select="ref:GenericCurrentClinicalInformation"/>
		</xsl:if>
	</xsl:template>
	<xsl:template match="ref:Examinations | ref:Investigations">
		<xsl:for-each select="gen:TestPerformed">
			<tr>
				<td valign="top">
					<xsl:value-of select="gen:TestName/gen:ClinicalCircumstanceDescription"/>:</td>
				<td>
					<xsl:choose>
						<xsl:when test="../gen:TestMeasurement/gen:MeasurementDescription">
							<xsl:call-template name="format_text">
								<xsl:with-param name="text">
									<xsl:value-of select="../gen:TestMeasurement/gen:MeasurementDescription"/>
								</xsl:with-param>
							</xsl:call-template>
						</xsl:when>
						<xsl:when test="./gen:TestMeasurement/gen:MeasurementNumeric">
							<xsl:value-of select="../gen:TestMeasurement/gen:MeasurementNumeric/gen:Result/gen:QuantityValue"/>
							<xsl:text/>
							<xsl:value-of select="../gen:TestMeasurement/gen:MeasurementNumeric/gen:Result/gen:QuantityUnit"/>
						</xsl:when>
					</xsl:choose>
				</td>
				<td>
					<xsl:call-template name="format_text">
						<xsl:with-param name="datetime">
							<xsl:value-of select="../gen:DateTimeReported "/>
						</xsl:with-param>
					</xsl:call-template>
				</td>
				<xsl:for-each select="../gen:Comment">
					<td>
						<xsl:value-of select="substring-after(text(), ':')"/>
					</td>
				</xsl:for-each>
			</tr>
		</xsl:for-each>
	</xsl:template>
	<xsl:template match="ref:PresentingComplaint">
		<p>
			<b>Presenting complaint</b>
		</p>
		<table border="0">
			<xsl:apply-templates select="gen:Diagnosis/gen:ConditionName"/>
			<xsl:apply-templates select="gen:Diagnosis/gen:DateOfOnset"/>
			<xsl:apply-templates select="gen:Comment"/>
		</table>
	</xsl:template>
	<xsl:template match="gen:ConditionName">
		<xsl:choose>
			<xsl:when test="normalize-space(gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeValue)=''">
				<tr>
					<td>Description:</td>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="gen:ClinicalCircumstanceDescription"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
				</tr>
			</xsl:when>
			<xsl:otherwise>
				<tr>
					<td>Read code:</td>
					<td>
						<xsl:value-of select="gen:ClinicalInformation/gen:ClinicalCode/gen:ClinicalCodeValue"/>
					</td>
				</tr>
				<tr>
					<td>Description:</td>
					<td>
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="gen:ClinicalInformation/gen:ClinicalCodeDescription"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
				</tr>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template match="gen:DateOfOnset">
		<tr>
			<td>Date of onset:</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="date">
						<xsl:value-of select="."/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
		</tr>
	</xsl:template>
	<xsl:template match="gen:Comment">
		<tr>
			<td valign="top">Comment:</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="."/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
		</tr>
	</xsl:template>
	<xsl:template match="ref:PatientMeasurements">
		<xsl:apply-templates select="./ref:BloodPressures"/>
		<xsl:apply-templates select="./ref:BodyMeasurements"/>
		<xsl:apply-templates select="./ref:PregnancyHistory"/>
	</xsl:template>
	<xsl:template match="ref:BloodPressures">
		<xsl:if test="./ref:BloodPressure">
			<table>
				<tbody>
					<tr>
						<td colspan="4"><b>Blood Pressure History</b></td>
					</tr>
					<tr>
						<td><u>Diastolic</u></td>
						<td><u>Systolic</u></td>
						<td><u>Date Recorded</u></td>
						<td><u>Time Recorded</u></td>
					</tr>
					<xsl:for-each select="./ref:BloodPressure">
						<tr>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="./ref:Diastolic"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="./ref:Systolic"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="date">
										<xsl:value-of select="./ref:RecordedDate"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="./ref:RecordedTime"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
						</tr>
					</xsl:for-each>
				</tbody>
			</table>
		</xsl:if>
	</xsl:template>
	<xsl:template match="ref:BodyMeasurements">
		<xsl:if test="./ref:BodyMeasurement">
			<table>
				<tbody>
					<tr>
						<td colspan="5"><b>Body Measurement History</b></td>
					</tr>
					<tr>
						<td><u>Body Mass Index</u></td>
						<td><u>Height</u></td>
						<td><u>Weight</u></td>
						<td><u>Date Recorded</u></td>
						<td><u>Time Recorded</u></td>
					</tr>
					<xsl:for-each select="./ref:BodyMeasurement">
						<tr>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="./ref:BodyMassIndex"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="./ref:Height"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="./ref:Weight"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="date">
										<xsl:value-of select="./ref:RecordedDate"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="./ref:RecordedTime"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
						</tr>
					</xsl:for-each>
				</tbody>
			</table>
		</xsl:if>
	</xsl:template>
	<xsl:template match="ref:PregnancyHistory">
		<xsl:if test="./ref:Pregnancies">
			<table>
				<tbody>
					<tr>
						<td colspan="4"><b>Pregnancy History</b></td>
					</tr>
					<tr>
						<td><u>Diastolic</u></td>
						<td><u>Systolic</u></td>
						<td><u>Date Recorded</u></td>
						<td><u>Time Recorded</u></td>
					</tr>
					<xsl:for-each select="./ref:Pregnancies">
						<tr>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="./ref:Gravida"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="./ref:Parity"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="date">
										<xsl:value-of select="./ref:RecordedDate"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="./ref:RecordedTime"/>
									</xsl:with-param>
								</xsl:call-template>
							</td>
						</tr>
					</xsl:for-each>
				</tbody>
			</table>
		</xsl:if>
	</xsl:template>

	<!--************************** END OF CLINICAL DATA *********************************************************************************************-->
	<xsl:template match="ref:TransportDetails" mode="flag">
		<xsl:variable name="description" select="normalize-space(translate(gen:TransportRequired, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz'))"/>
		<xsl:choose>
			<xsl:when test="$description='true'">
				<p>
					<center>Yes</center>
				</p>
			</xsl:when>
			<xsl:otherwise>
				<p>
					<center>No</center>
				</p>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template match="ref:TransportDetails">
		<xsl:variable name="description" select="normalize-space(translate(gen:TransportRequired, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz'))"/>
		<xsl:if test="$description='true'">
			<tr>
				<td width="100%" bordercolor="black" colspan="3">
					<table width="100%" border="0" cellpadding="0" cellspacing="0">
						<tr>
							<td colspan="2" width="55%">
								<b>Transportation requirements</b>
							</td>
							<td/>
						</tr>
						<tr>
							<td width="20%">Date and time required: </td>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="datetime">
										<xsl:value-of select="gen:TransportDateTime"/>
									</xsl:with-param>
									<xsl:with-param name="default">Not specified</xsl:with-param>
								</xsl:call-template>
							</td>
							<td width="20%">&#160;&#160;Transportation type: </td>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="gen:TransportType"/>
									</xsl:with-param>
									<xsl:with-param name="default">Not specified</xsl:with-param>
								</xsl:call-template>
							</td>
						</tr>
						<tr>
							<td>Pick-up point: </td>
							<td>
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="gen:TransportPickup"/>
									</xsl:with-param>
									<xsl:with-param name="default">Not specified</xsl:with-param>
								</xsl:call-template>
							</td>
							<td valign="top" rowspan="2">&#160;&#160;Special Instructions: </td>
							<td valign="top" rowspan="2">
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="gen:TransportInstructions"/>
									</xsl:with-param>
									<xsl:with-param name="default">None</xsl:with-param>
								</xsl:call-template>
							</td>
						</tr>
						<tr>
							<td valign="top">Destination: </td>
							<td valign="top">
								<xsl:call-template name="format_text">
									<xsl:with-param name="text">
										<xsl:value-of select="gen:TransportDestination"/>
									</xsl:with-param>
									<xsl:with-param name="default">Not specified</xsl:with-param>
								</xsl:call-template>
							</td>
						</tr>
					</table>
				</td>
			</tr>
		</xsl:if>
	</xsl:template>
	<xsl:template match="ref:GenericAdministrativeInformation">
		<tr>
			<td width="100%" bordercolor="black" colspan="3">
				<b>Administrative Information</b>
				<br/>
				<table>
					<xsl:for-each select="./ref:GenericAdministrativeInformationInstance[@FrontPageInformation='true']">
						<xsl:apply-templates select="."/>
					</xsl:for-each>
				</table>
			</td>
		</tr>
	</xsl:template>
	<xsl:template match="ref:GenericAdministrativeInformationInstance">
		<xsl:for-each select="./ref:GenericTableInformation">
			<tr>
				<td align="left" style="border-style:none;">
					<b>
						<xsl:value-of select="./gen:Title"/>
					</b>
				</td>
			</tr>
			<tr>
				<xsl:for-each select="./gen:Columns/gen:Column">
					<td align="left" style="border-style:none;">
						<u>
							<xsl:value-of select="./gen:ColumnTitle"/>
						</u>
					</td>
				</xsl:for-each>
			</tr>
			<xsl:for-each select="./gen:Rows/gen:Row">
				<tr>
					<xsl:for-each select="./gen:Cells/gen:Cell">
						<td align="left" style="border-style:none;">
							<xsl:if test="./gen:CellValue/gen:GenericStringValue">
								<xsl:value-of select="./gen:CellValue/gen:GenericStringValue"/>
							</xsl:if>
							<xsl:if test="./gen:CellValue/gen:GenericDateValue">
								<xsl:call-template name="format_text">
									<xsl:with-param name="date">
										<xsl:value-of select="./gen:CellValue/gen:GenericDateValue"/>
									</xsl:with-param>
								</xsl:call-template>
							</xsl:if>
						</td>
					</xsl:for-each>
				</tr>
			</xsl:for-each>
		</xsl:for-each>
		<xsl:for-each select="./ref:NameValuePair">
			<tr>
				<td align="left" style="border-style:none;">
					<xsl:value-of select="./gen:NameValueName/gen:NameId"/>
				</td>
				<td align="left" style="border-style:none;">
					<xsl:if test="./gen:NameValueValue/gen:GenericStringValue">
						<xsl:value-of select="./gen:NameValueValue/gen:GenericStringValue"/>
					</xsl:if>
					<xsl:if test="./gen:NameValueValue/gen:GenericDateValue">
						<xsl:call-template name="format_text">
							<xsl:with-param name="date">
								<xsl:value-of select="./gen:NameValueValue/gen:GenericDateValue"/>
							</xsl:with-param>
						</xsl:call-template>
					</xsl:if>
				</td>
			</tr>
		</xsl:for-each>
	</xsl:template>
	<xsl:template match="ref:ClinicalDataRef/ref:CurrentClinicalDataRef/ref:GenericCurrentClinicalInformation">
		<table>
			<xsl:for-each select="./gen:GenericInformationInstance">
				<tr>
					<xsl:for-each select="./gen:GenericTableInformation">
						<tr>
							<td align="left" style="border-style:none;">
								<b>
									<xsl:value-of select="./gen:Title"/>
								</b>
							</td>
						</tr>
						<tr>
							<xsl:for-each select="./gen:Columns/gen:Column">
								<td align="left" style="border-style:none;">
									<u>
										<xsl:value-of select="./gen:ColumnTitle"/>
									</u>
								</td>
							</xsl:for-each>
						</tr>
						<xsl:for-each select="./gen:Rows/gen:Row">
							<tr>
								<xsl:for-each select="./gen:Cells/gen:Cell">
									<td align="left" style="border-style:none;">
										<xsl:if test="./gen:CellValue/gen:GenericStringValue">
											<xsl:value-of select="./gen:CellValue/gen:GenericStringValue"/>
										</xsl:if>
										<xsl:if test="./gen:CellValue/gen:GenericDateValue">
											<xsl:call-template name="format_text">
												<xsl:with-param name="date">
													<xsl:value-of select="./gen:CellValue/gen:GenericDateValue"/>
												</xsl:with-param>
											</xsl:call-template>
										</xsl:if>
									</td>
								</xsl:for-each>
							</tr>
						</xsl:for-each>
					</xsl:for-each>
					<tr/>
					<xsl:for-each select="./gen:NameValuePair">
						<tr>
							<td align="left" style="border-style:none;">
								<xsl:value-of select="./gen:NameValueName/gen:NameId"/>
							</td>
							<td align="left" style="border-style:none;">
								<xsl:if test="./gen:NameValueValue/gen:GenericStringValue">
									<xsl:value-of select="./gen:NameValueValue/gen:GenericStringValue"/>
								</xsl:if>
								<xsl:if test="./gen:NameValueValue/gen:GenericDateValue">
									<xsl:call-template name="format_text">
										<xsl:with-param name="date">
											<xsl:value-of select="./gen:NameValueValue/gen:GenericDateValue"/>
										</xsl:with-param>
									</xsl:call-template>
								</xsl:if>
							</td>
						</tr>
					</xsl:for-each>
				</tr>
			</xsl:for-each>
		</table>
	</xsl:template>
	<xsl:template match="ref:ReferralTo">
		<tr>
			<td width="100%" colspan="3" style="border-style:none;" valign="top">
				<h3>REFERRAL TO</h3>
			</td>
		</tr>
		<tr>
			<td width="40%" bordercolor="black" style="padding-bottom: 2px;" align="left" valign="top">
				<xsl:apply-templates select="ref:HcpReferredTo"/>
				<p>
					<xsl:value-of select="ref:ReferredToSpecialty/gen:SpecialtyName"/>&#32;
					<xsl:value-of select="ref:ReferredToSpecialty/gen:SpecialtyCode"/>
				</p>
				<p>
					<xsl:value-of select="ref:Clinic"/>
				</p>
			</td>
			<td valign="top" width="6%" style="border-style:none;">&#160;_____</td>
			<td valign="top" width="33%" style="border-style:none; padding-top: 5px;" align="left">
				<p>
					<span class="essential">Consultant / receiving practitioner</span>
                    and/or 
                    <span class="essential">specialty clinic</span>
				</p>
			</td>
		</tr>
		<tr>
			<td width="60%" bordercolor="black" align="left" valign="top">
				<xsl:apply-templates select="ref:Hospital"/>
			</td>
			<td width="6%" style="border-style:none;" valign="top">&#160;_____</td>
			<td width="33%" style="border-style:none; padding-top: 5px;" align="left" valign="top">
				<p>
					<span class="essential">Hospital</span>
				and <span class="essential">hospital address</span>
				</p>
				<p align="right">Hospital unit no.</p>
				<p align="right" style="border: 1 solid black; padding-right: 2px;">
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:value-of select="ref:Hospital/gen:OrganisationId/gen:IdValue"/>
						</xsl:with-param>
					</xsl:call-template>
				</p>
				<p align="right" valign="top">Email address</p>
				<p align="right" style="border: 1 solid black; padding-right: 2px;">
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:apply-templates select="gen:OrganisationTelecom[gen:TelecomType='Email']" mode="specType"/>
						</xsl:with-param>
					</xsl:call-template>
				</p>
			</td>
		</tr>
	</xsl:template>
	<xsl:template match="ref:HcpReferredTo">
		<p>
			<xsl:apply-templates select="gen:HcpName"/>
			<xsl:for-each select="gen:Position">
			(<xsl:value-of select="."/>)
		</xsl:for-each>
		</p>
	</xsl:template>
	<xsl:template match="ref:Hospital">
		<xsl:value-of select="gen:OrganisationName"/>
		<xsl:apply-templates select="gen:OrganisationAddress"/>
		<xsl:choose>
			<xsl:when test="normalize-space(gen:OrganisationTelecom)">
				<p>
					<xsl:text>Telephone: </xsl:text>
					<xsl:apply-templates select="gen:OrganisationTelecom[gen:TelecomType='Telephone']" mode="specType"/>
				</p>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template match="gen:PatientAddress | gen:OrganisationAddress">
		<xsl:choose>
			<xsl:when test="gen:UnstructuredAddress">
				<p>
					<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:value-of select="gen:UnstructuredAddress"/>
						</xsl:with-param>
					</xsl:call-template>
				</p>
			</xsl:when>
			<xsl:otherwise>
				<p>
					<xsl:value-of select="gen:StructuredAddress/gen:PropertyNumber"/>
				</p>
				<xsl:for-each select="gen:StructuredAddress/gen:AddressLine">
					<p>
						<xsl:value-of select="."/>
					</p>
				</xsl:for-each>
			</xsl:otherwise>
		</xsl:choose>
		<p>
			<xsl:value-of select="gen:PostCode"/>
		</p>
	</xsl:template>
	<xsl:template match="ref:PatientDemographics">
		<tr>
			<td width="50%" colspan="3" style="border-style:none;" valign="top">
				<h3>PATIENT DETAILS</h3>
			</td>
			<td width="45%" height="25" class="essential" valign="bottom" style="padding-bottom:0;border-style:none;">
				Patient's address
			</td>
		</tr>
		<tr>
			<td class="essential" width="15%" style="border-style:none;">Surname</td>
			<td width="35%">
				<xsl:choose>
					<xsl:when test="gen:PatientName[gen:NameType='Current Name']/gen:UnstructuredName">
						<xsl:value-of select="gen:UnstructuredName"/>
					</xsl:when>
					<xsl:when test="gen:PatientName[gen:NameType='Current Name']/gen:StructuredName/gen:FamilyName">
						<xsl:value-of select="gen:PatientName[gen:NameType='Current Name']/gen:StructuredName/gen:FamilyName"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$default_blank"/>
					</xsl:otherwise>
				</xsl:choose>
			</td>
			<td width="5%" style="border-style:none;" rowspan="7"/>
			<td width="45%" rowspan="4" valign="top">
				<xsl:apply-templates select="gen:PatientAddress"/>
			</td>
		</tr>
		<tr>
			<td class="essential" style="border-style:none;">Forename(s)</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:PatientName[gen:NameType='Current Name']/gen:StructuredName/gen:GivenName"/>
						<xsl:for-each select="gen:PatientName[gen:NameType='Current Name']/gen:StructuredName/gen:MiddleName">
							<xsl:text/>
							<xsl:value-of select="."/>
						</xsl:for-each>
					</xsl:with-param>
				</xsl:call-template>
			</td>
		</tr>
		<tr>
			<td style="border-style:none;">Title</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:PatientName[gen:NameType='Current Name']/gen:StructuredName/gen:Title"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
		</tr>
		<tr>
			<td style="border-style:none;">Sex</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:apply-templates select="gen:Sex"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
		</tr>
		<tr>
			<td class="essential" style="border-style:none;">Date of birth</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="date">
						<xsl:value-of select="gen:DateOfBirth"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<TD ALIGN="right" valign="bottom" style="padding-bottom:0;border-style:none;">
				<DIV ALIGN="right">Contact number(s)</DIV>
			</TD>
		</tr>
		<tr>
			<td valign="top" style="border-style:none;">CHI no.</td>
			<td valign="top">
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:PatientId[gen:IdScheme='CHI']/gen:IdValue"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td align="left">
				<xsl:choose>
					<xsl:when test="normalize-space(gen:PatientTelecom)">
						<xsl:apply-templates select="gen:PatientTelecom" mode="all"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$default_blank"/>
					</xsl:otherwise>
				</xsl:choose>
			</td>
		</tr>
	</xsl:template>
	<xsl:template match="gen:Sex">
		<xsl:choose>
			<xsl:when test=".='F'">Female</xsl:when>
			<xsl:when test=".='M'">Male</xsl:when>
			<xsl:otherwise>Not specified</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template match="gen:PatientTelecom | gen:HcpTelecom | gen:OrganisationTelecom | gen:Telecom" mode="all">
		<p>
			<xsl:value-of select="gen:TelecomType"/>:
        <xsl:choose>
				<xsl:when test="gen:UnstructuredTelecom[not('')]">
					<xsl:value-of select="gen:UnstructuredTelecom"/>
				</xsl:when>
				<xsl:when test="gen:StructuredTelecom[not('')]">
					<xsl:value-of select="gen:StructuredTelecom/gen:TelecomCountry"/>
				(<xsl:value-of select="gen:StructuredTelecom/gen:TelecomArea"/>)
				<xsl:value-of select="gen:StructuredTelecom/gen:TelecomNo"/>
					<xsl:value-of select="gen:StructuredTelecom/gen:TelecomExt"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>Not Known</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</p>
	</xsl:template>
	<xsl:template match="gen:PatientTelecom | gen:HcpTelecom | gen:OrganisationTelecom | gen:Telecom" mode="specType">
		<xsl:choose>
			<xsl:when test="gen:UnstructuredTelecom[not('')]">
				<xsl:value-of select="gen:UnstructuredTelecom"/>
			</xsl:when>
			<xsl:when test="gen:StructuredTelecom[not('')]">
				<xsl:value-of select="gen:StructuredTelecom/gen:TelecomCountry"/>
				(<xsl:value-of select="gen:StructuredTelecom/gen:TelecomArea"/>)
				<xsl:value-of select="gen:StructuredTelecom/gen:TelecomNo"/>
				<xsl:value-of select="gen:StructuredTelecom/gen:TelecomExt"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>Not Known</xsl:text>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template match="gen:RegisteredGp | ref:ReferringGP">
		<tr>
			<td class="essential" width="15%" style="border-style:none;">Name</td>
			<td width="35%" colspan="3">
				<xsl:apply-templates select="gen:HcpName"/>
			</td>
			<td width="45%" rowspan="3" valign="top">
				<xsl:apply-templates select="gen:EmployingOrganisation/gen:OrganisationAddress"/>
			</td>
		</tr>
		<tr>
			<td style="border-style:none;">GMC code</td>
			<td width="10%">
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:HcpId[gen:IdScheme='GmcCode' or 'GMC']/gen:IdValue"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td style="border-style:none;" align="center">GP code</td>
			<td width="10%">
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:HcpId[gen:IdScheme='GpCode']/gen:IdValue"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
		</tr>
		<tr>
			<td style="border-style:none;">Practice name</td>
			<td colspan="3">
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:EmployingOrganisation/gen:OrganisationName"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
		</tr>
		<tr>
			<td style="border-style:none;">Practice code</td>
			<td colspan="3">
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="gen:EmployingOrganisation/gen:OrganisationId[gen:IdScheme='PracticeID']/gen:IdValue"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td style="border-style:none;" align="right">
				<DIV ALIGN="right">Contact number(s)</DIV>
			</td>
		</tr>
		<tr>
			<td colspan="4" style="border-style:none;"/>
			<td>
				<xsl:choose>
					<xsl:when test="normalize-space(gen:EmployingOrganisation/gen:OrganisationTelecom)">
						<xsl:apply-templates select="gen:EmployingOrganisation/gen:OrganisationTelecom" mode="all"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$default_blank"/>
					</xsl:otherwise>
				</xsl:choose>
			</td>
		</tr>
	</xsl:template>
	<xsl:template match="ref:ReferringParty">
		<tr>
			<td class="essential" width="15%" style="border-style:none;">Name</td>
			<td width="35%" colspan="3">
				<xsl:value-of select="concat(ref:ReferringHcp/gen:HcpName/gen:StructuredName/gen:GivenName, ' ',ref:ReferringHcp/gen:HcpName/gen:StructuredName/gen:FamilyName)"/>
			</td>
			<td width="45%" rowspan="3" valign="top">
				<xsl:apply-templates select="ref:ReferringOrg/gen:OrganisationAddress"/>
			</td>
		</tr>
		<tr>
			<td style="border-style:none;">HCP identification</td>
			<td colspan="3">
				<xsl:for-each select="ref:ReferringHcp/gen:HcpId">
					<xsl:value-of select="./gen:IdValue"/>
					(<xsl:call-template name="format_text">
						<xsl:with-param name="text">
							<xsl:value-of select="./gen:IdScheme"/>
						</xsl:with-param>
					</xsl:call-template>)<br/>
				</xsl:for-each>
			</td>
		</tr>		
		<tr>
			<td style="border-style:none;">Position</td>
			<td colspan="3">
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="ref:ReferringHcp/gen:Position"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
		</tr>
		<tr>
			<td style="border-style:none;">Organisation Name</td>
			<td colspan="3">
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="ref:ReferringOrg/gen:OrganisationName"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td style="text-align: right;border-style: none;">Contact number(s)</td>
		</tr>
		<tr>
			<td style="border-style:none;">Location Code</td>
			<td colspan="3">
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="ref:ReferringOrg/gen:OrganisationId[gen:IdScheme='LocationCode']/gen:IdValue"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>
				<xsl:choose>
					<xsl:when test="normalize-space(ref:ReferringOrg/gen:OrganisationTelecom)">
						<xsl:apply-templates select="ref:ReferringOrg/gen:OrganisationTelecom" mode="all"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$default_blank"/>
					</xsl:otherwise>
				</xsl:choose>
			</td>			
		</tr>
		<tr>
			<td style="border-style:none;">Specialty Code &amp; Name</td>
			<td>
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="ref:ReferringHcp/gen:HcpSpecialty/gen:SpecialtyCode"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td colspan="2">
				<xsl:call-template name="format_text">
					<xsl:with-param name="text">
						<xsl:value-of select="ref:ReferringHcp/gen:HcpSpecialty/gen:SpecialtyName"/>
					</xsl:with-param>
				</xsl:call-template>
			</td>
		</tr>
	</xsl:template>
	<xsl:template match="gen:PatientName | gen:HcpName">
		<xsl:choose>
			<xsl:when test="gen:UnstructuredName">
				<xsl:value-of select="gen:UnstructuredName"/>
			</xsl:when>
			<xsl:when test="gen:StructuredName">
				<xsl:value-of select="gen:StructuredName/gen:Title"/><![CDATA[ ]]><xsl:value-of select="gen:StructuredName/gen:GivenName"/><![CDATA[ ]]><xsl:for-each select="gen:StructuredName/gen:MiddleName">
					<xsl:value-of select="."/><![CDATA[ ]]></xsl:for-each>
				<xsl:value-of select="gen:StructuredName/gen:FamilyName"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$default_blank"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!-- *********************** START OF 18 WEEKS RTT  ************************ -->
	<xsl:template match="ref:ReferralToTreatmentPeriod">
		<table width="100%" cellpadding="2" cellspacing="2">
			<tbody>
				<tr>
					<td class="essential" width="20%">RTT verifier name</td>
					<td class="boxedArea">
						<xsl:choose>
							<xsl:when test="ref:VerifierName[gen:NameType='Current Name']/gen:UnstructuredName">
								<xsl:value-of select="ref:VerifierName[gen:NameType='Current Name']/gen:UnstructuredName"/>
							</xsl:when>
							<xsl:when test="ref:VerifierName[gen:NameType='Current Name']/gen:StructuredName/gen:FamilyName">
								<xsl:value-of select="ref:VerifierName[gen:NameType='Current Name']/gen:StructuredName/gen:FamilyName"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="$default_blank"/>
							</xsl:otherwise>
						</xsl:choose>
					</td>
				</tr>
			</tbody>
		</table>
		<table width="100%" cellpadding="2" cellspacing="2">
			<colgroup>
				<col width="20%"/>
				<col/>
			</colgroup>
			<tbody>
				<tr>
					<td colspan="2">
						<b>Additional Patient Details:</b>
					</td>
				</tr>
				<tr>
					<td>Local Patient Identifier</td>
					<td class="boxedArea">
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="ref:LocalPatientIdentifier/gen:IdValue"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
				</tr>
				<xsl:if test="ref:LeadContact">
					<tr>
						<td>Lead contact name</td>
						<td class="boxedArea">
							<xsl:choose>
								<xsl:when test="ref:LeadContact/gen:ContactDetails/gen:Name[gen:NameType='Healthcare Person']/gen:UnstructuredName">
									<xsl:value-of select="ref:LeadContact/gen:ContactDetails/gen:Name[gen:NameType='Healthcare Person']/gen:UnstructuredName"/>
								</xsl:when>
								<xsl:when test="ref:LeadContact/gen:ContactDetails/gen:Name[gen:NameType='Healthcare Person']/gen:StructuredName/gen:FamilyName">
									<xsl:value-of select="ref:LeadContact/gen:ContactDetails/gen:Name[gen:NameType='Healthcare Person']/gen:StructuredName/gen:FamilyName"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="$default_blank"/>
								</xsl:otherwise>
							</xsl:choose>
						</td>
					</tr>
					<tr>
						<td>Lead contact numbers</td>
						<td class="boxedArea">
							<xsl:choose>
								<xsl:when test="normalize-space(ref:LeadContact/gen:ContactDetails/gen:Telecom)">
									<xsl:apply-templates select="ref:LeadContact/gen:ContactDetails/gen:Telecom" mode="all"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="$default_blank"/>
								</xsl:otherwise>
							</xsl:choose>
						</td>
					</tr>
				</xsl:if>
			</tbody>
		</table>
		<table width="100%" cellpadding="2" cellspacing="2">
			<colgroup>
				<col width="20%"/>
				<col/>
			</colgroup>
			<tbody>
				<tr>
					<td colspan="2">
						<b>Referral to Treatment Information:</b>
					</td>
				</tr>
				<tr>
					<td>Pathway allocated by</td>
					<td class="boxedArea">
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="ref:UniqueCarePathwayNumberAllocatingOrganisation/gen:OrganisationId/gen:IdValue"/>
								<xsl:if test="ref:UniqueCarePathwayNumberAllocatingOrganisation/gen:OrganisationId/gen:IdValue and ref:UniqueCarePathwayNumberAllocatingOrganisation/gen:OrganisationName"> - </xsl:if>
								<xsl:value-of select="ref:UniqueCarePathwayNumberAllocatingOrganisation/gen:OrganisationName"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
				</tr>
				<tr>
					<td>Other organisations involved in RTT Pathway</td>
					<td class="boxedArea">
						<xsl:choose>
							<xsl:when test="ref:OtherInvolvedOrganisation">
								<xsl:for-each select="ref:OtherInvolvedOrganisation">
									<xsl:call-template name="format_text">
										<xsl:with-param name="text">
											<xsl:value-of select="./gen:OrganisationId/gen:IdValue"/>
											<xsl:if test="./gen:OrganisationId/gen:IdValue and ./gen:OrganisationName"> - </xsl:if>
											<xsl:value-of select="./gen:OrganisationName"/>
										</xsl:with-param>
									</xsl:call-template>
									<br/>
								</xsl:for-each>
							</xsl:when>
							<xsl:otherwise><xsl:value-of select="$default_blank"/></xsl:otherwise>
						</xsl:choose>
					</td>
				</tr>
			</tbody>
		</table>
		<table width="100%" cellpadding="2" cellspacing="2">
			<colgroup>
				<col width="20%"/>
				<col/>
			</colgroup>
			<tbody>
				<tr>
					<td colspan="2">
						<b>Pathway Referral Status:</b>
					</td>
				</tr>
				<tr>
					<td>Is the patient on an RTT Pathway</td>
					<td class="boxedArea">
						<xsl:call-template name="boolean_to_yes_no">
							<xsl:with-param name="text">
								<xsl:value-of select="ref:PathwayStatus/ref:PatientIsOnPathway"/>
							</xsl:with-param>
						</xsl:call-template>
						<br/>
						<p>
							<xsl:if test="ref:PathwayStatus/ref:IsOnPathwayStatus">
								- <xsl:value-of select="ref:PathwayStatus/ref:IsOnPathwayStatus"/>
								<br/>
							</xsl:if>
							<xsl:if test="ref:PathwayStatus/ref:IsNotOnPathwayStatus">
								- <xsl:value-of select="ref:PathwayStatus/ref:IsNotOnPathwayStatus"/>
								<br/>
							</xsl:if>
						</p>
					</td>
				</tr>
				<tr>
					<td>Is there a transfer of Patient Care</td>
					<td class="boxedArea">
						<xsl:call-template name="boolean_to_yes_no">
							<xsl:with-param name="text">
								<xsl:value-of select="ref:PathwayStatus/ref:TransferOfPatientCare"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
				</tr>
				<tr>
					<td>New Ways Days Waiting</td>
					<td class="boxedArea">
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="ref:NewWaysDates/ref:DaysWaiting"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
				</tr>
				<tr>
					<td>RTT Days Remaining</td>
					<td class="boxedArea">
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="ref:NewWaysDates/ref:DaysRemaining"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
				</tr>
				<tr>
					<td>Effective Clock Start date*</td>
					<td class="boxedArea">
						<xsl:call-template name="format_text">
							<xsl:with-param name="date">
								<xsl:value-of select="ref:NewWaysDates/ref:EffectiveClockStartDate"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
					<tr>
						<td colspan="2">
							<p>*Latest of:<br/>
								<ul style="list-style-type:lower-alpha;margin-top:0px;">
									<li>date referral received (OP) or date on list (IP/DC)</li>
									<li>change of date due to multiple resonable offers or</li>
									<li>change of date due to DNA/CNA</li>
								</ul>
							</p>
						</td>
					</tr>
				</tr>
				<tr>
					<td>Date of Decision to Refer to receiving organisation</td>
					<td class="boxedArea">
						<xsl:call-template name="format_text">
							<xsl:with-param name="date">
								<xsl:value-of select="ref:NewWaysDates/ref:ReferralDecisionDate"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
				</tr>
				<tr>
						<td>Future Unavailability</td>
						<td class="boxedArea">
							<xsl:call-template name="format_text">
								<xsl:with-param name="text">
									<xsl:value-of select="ref:NewWaysDates/ref:FutureUnavailability"/>
								</xsl:with-param>
							</xsl:call-template>
						</td>
					</tr>
			</tbody>
		</table>
		<table width="100%" cellpadding="2" cellspacing="2">
			<colgroup>
				<col width="20%"/>
				<col/>
			</colgroup>
			<tbody>
				<tr>
					<td colspan="2">
						<b>Receiving Clinician or Organisation Additional Details:</b>
					</td>
				</tr>
				<tr>
					<td>Date Onward Referral Data sent</td>
					<td class="boxedArea">
						<xsl:call-template name="format_text">
							<xsl:with-param name="date">
								<xsl:choose>
									<xsl:when test="ref:IptMdsSentDate"><xsl:value-of select="ref:IptMdsSentDate"/></xsl:when>
									<xsl:otherwise><xsl:value-of select="/ref:ReferralDocument/ref:DocumentData/gen:DocumentAttestationDate"/></xsl:otherwise>
								</xsl:choose>
							</xsl:with-param>
						</xsl:call-template>
					</td>
				</tr>
			</tbody>
		</table>
		<table width="100%" cellpadding="2" cellspacing="2">
			<colgroup>
				<col width="20%"/>
				<col/>
			</colgroup>
			<tbody>
				<tr>
					<td colspan="2">
						<b>For Receiving Clinician or Organisation:</b>
					</td>
				</tr>
				<tr>
					<td>Date received</td>
					<td class="boxedArea">
						<xsl:call-template name="format_text">
							<xsl:with-param name="date">
									<xsl:value-of select="/ref:ReferralDocument/ref:DocumentData/gen:DocumentAttestationDate"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
				</tr>
			</tbody>
		</table>
	</xsl:template>
	<xsl:template match="ref:ReferralToTreatmentData">
			<table width="100%" cellpadding="2" cellspacing="2">
			<tbody>
				<tr>
					<td class="essential" width="20%">RTT status</td>
					<td class="boxedArea">
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="ref:RTTStatus"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
				</tr>
				<tr>
					<td class="essential" width="20%">RTT date of original referral</td>
					<td class="boxedArea">
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="ref:DateOfOriginalReferral"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
				</tr>
				<tr>
					<td class="essential" width="20%">RTT days elapsed</td>
					<td class="boxedArea">
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="ref:DaysElapsed"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
				</tr>
				<tr>
					<td width="20%">Periods of Future Unavilability</td>
					<td class="boxedArea">
						<xsl:choose>
							<xsl:when test="ref:PeriodsOfFutureUnavailability">
								<table width="100%" cellpadding="2" cellspacing="2">
									<td><u>From (Inclusive)</u></td>
									<td><u>To (Inclusive)</u></td>
									<td><u>Reason</u></td>
									<xsl:for-each select="ref:PeriodsOfFutureUnavailability">
										<tr>
											<td>
												<xsl:call-template name="format_text">
													<xsl:with-param name="date">
														<xsl:value-of select="ref:UnavailableFrom"/>
													</xsl:with-param>
												</xsl:call-template>
											</td>
											<td>
												<xsl:call-template name="format_text">
													<xsl:with-param name="date">
														<xsl:value-of select="ref:UnavailableTo"/>
													</xsl:with-param>
												</xsl:call-template>
											</td>
											<td>
												<xsl:call-template name="format_text">
													<xsl:with-param name="text">
														<xsl:value-of select="ref:Reason"/>
													</xsl:with-param>
												</xsl:call-template>
											</td>
										</tr>
									</xsl:for-each>
								</table>
							</xsl:when>
							<xsl:otherwise>-</xsl:otherwise>
						</xsl:choose>
					</td>
				</tr>
				<tr>
					<td width="20%">RTT additional information</td>
					<td class="boxedArea">
						<xsl:call-template name="format_text">
							<xsl:with-param name="text">
								<xsl:value-of select="ref:AdditionalInformation"/>
							</xsl:with-param>
						</xsl:call-template>
					</td>
				</tr>

			</tbody>
		</table>
	</xsl:template>
	<!-- *********************** END OF 18 WEEKS RTT  ************************ -->
	<!-- *********************** FUNCTIONS  ************************ -->
	<xsl:template name="format_text">
		<xsl:param name="text"/>
		<xsl:param name="date"/>
		<xsl:param name="datetime"/>
		<xsl:param name="default" select="$default_blank"/>
		<xsl:choose>
			<xsl:when test="normalize-space($date)">
				<xsl:value-of select="user:UnambiguousDate(string($date))"/>
			</xsl:when>
			<xsl:when test="normalize-space($datetime)">
				<xsl:value-of select="$datetime"/>
			</xsl:when>
			<xsl:when test="normalize-space($text)">
				<xsl:value-of disable-output-escaping="yes" select="user:FormatLineBreaks(string($text))"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$default"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="boolean_to_text">
		<xsl:param name="text"/>
		<xsl:param name="textIfFalse"/>
		<xsl:param name="textIfTrue"/>
		<xsl:variable name="textToLower" select="normalize-space(translate($text, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz'))"/>
		<xsl:choose>
			<xsl:when test="$textToLower='false'">
				<xsl:value-of select="$textIfFalse"/>
			</xsl:when>
			<xsl:when test="$textToLower='true'">
				<xsl:value-of select="$textIfTrue"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$default_blank"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="boolean_to_yes_no">
		<xsl:param name="text"/>
		<xsl:call-template name="boolean_to_text">
			<xsl:with-param name="text" select="$text"/>
			<xsl:with-param name="textIfFalse">No</xsl:with-param>
			<xsl:with-param name="textIfTrue">Yes</xsl:with-param>
		</xsl:call-template>
	</xsl:template>
</xsl:stylesheet>
