'============================================================================================
' File name:        viewmessage.vbs
' Description:      This is supporting script for the viewmessage.asp page
'============================================================================================

Option Explicit

Dim   FORM_ID
      FORM_ID               = "formRef"         'The main form's HTML tag name
Const GPASS_REPLACE_ELEMENT = "protocolPage"    'The DHTML element that will be repopulated by activeGPASS.ProtocolWriter
Const MSG_SIZE_LIMIT        = 100000
Const QUEST_ID              = 0
Const QUEST_TXT             = 1
Const ROW_IDX               = 2
Const COL_ID                = 3
Const COL_TXT               = 4
Const TAB_IDX               = 5
Const MSG_TXT               = 6
Const TYPE_FLAG             = 7

'validation types
Const CHI_FORMAT_ONLY       = 1
Const CHI_DOB               = 2
Const CHI_SEX               = 3
Const CHI_DOB_SEX           = 4

Dim g_objGpassApp           'As NewGpass.Application
Dim g_objPreviewWin         'HTML.Window
Dim m_lngMessageID          'As Long
Dim m_strStatusText         'As String
Dim m_objPrePopWin, m_objPrePopMsg
Dim m_objClinEventProgMain, m_objClinEventProgDetail, m_objClinEventProgNumbers
Dim m_strPrePopWindowName
Dim aRadioItems()
Dim objXML
Dim blnWindowCloseMsg
Dim blnNoChiAccepted
Dim m_blnPrinted
Dim m_strRefHcpName
Dim m_lngTempMessageID

Set g_objPreviewWin = Nothing
blnWindowCloseMsg = True
m_blnPrinted = False

Sub FormOpen(blnDisplayingErrors)
'
' Description:  Initialises form fields on an opened message.
' Parameters:   None
'
    
    Dim chiNumber
    Dim sex, dateOfBirth, severity, message, validationType
    Dim instruction
    Dim response
    Dim lngMsgTypeID
    
    If Not document.forms("GatewayForm") Is Nothing Then
        FORM_ID = "GatewayForm"
        Call removeDuplicateInputs(document.forms("GatewayForm"))
    End If
    
    document.all("divLoading").style.display = "none"
    'document.all("divScreen").style.display = "block"
    
    If document.forms("protocolInfo") Is Nothing Then
        Call SetExpandoProperty(document, "protocolInfo", document.forms(0))
    End If
    If document.forms("formRef") Is Nothing Then
        Call SetExpandoProperty(document, "formRef", document.forms(0))
    End If
   
    Call ResizeWindow(800, 720)

    document.body.style.cursor = "wait"

    lngMsgTypeID = document.all("msgtypeid").value

    If Not document.all("messageID") Is Nothing Then
        m_lngMessageID = CLng(document.all("messageID").value)
    Else
        m_lngMessageID = 0
    End If
    
    If Not document.all("tempMessageId") Is Nothing Then
		m_lngTempMessageID = CLng(document.all("tempMessageId").value)
	Else
		m_lngTempMessageID = 0
	End If
    'Get the status
    If Not document.all("statusText") Is Nothing Then
        m_strStatusText = document.all("statusText").value
    Else
        m_strStatusText = "new"
    End If

    document.body.style.cursor = "auto"

    'Initialise tabs & details if this is a new message and we are not
    'displaying schema validation errors    
    If m_lngMessageID = 0 and Not blnDisplayingErrors Then
        Call InitialiseNewMessage()
    Else
        'just show the form
        document.all("divScreen").style.display = "block"
    End If
    
    ' Validate CHI number and warn if it is invalid.
    If Not document.formRef("chi") Is Nothing Then

        ' Pull CHI number out of the form
        chiNumber = document.formRef("chi").value
        
        validationType = setValidationType()

        ' Validate only if a CHI number has been specified, i.e. pulled out of GP system.
        If chiNumber <> "" and LCase(chiNumber) <> "none" Then
            If validationType = CHI_DOB Or validationType = CHI_DOB_SEX Then
                dateOfBirth = document.all("patient_dob").value
            End If
            
            If validationType = CHI_SEX Or validationType = CHI_DOB_SEX Then
                ' Determine the patient's sex; we know that exactly one of male or female
                ' has been selected.
                Dim patientSexControl
                Set patientSexControl = document.getElementById("patient_sex")
                Select Case UCase(patientSexControl.tagName)
                    Case "SELECT"
                        If UCase(patientSexControl.type) = "SELECT-ONE" Then
                            'The patient_sex field is a drop down list control
                            If document.all("patient_sex_1").selected Then
                                sex = MALE
                            Else
                                sex = FEMALE
                            End If
                        End If
                    Case "INPUT"
                        Select Case UCase(patientSexControl.type)
                            Case "RADIO"
                                'The patient_sex field is a radio control
                                If (Not document.all("patient_sex_1") Is Nothing) And (Not document.all("patient_sex_2") Is Nothing) Then
                                    'The sex is a radio box
                                    If document.all("patient_sex_1").checked Then
                                        sex = MALE
                                    Else
                                        sex = FEMALE
                                    End If
                                End If
                        End Select
                End Select
            End If
            
            If Not isValidChiNumber(chiNumber, dateOfBirth, sex, validationType, severity, message) Then
                If severity = CHI_ERROR Then
                    If document.forms(FORM_ID)("chi").readonly Then ' Populated from GP system
                        instruction = "Please correct the CHI number in GP system. If a correct CHI number is not available please blank the field until it can be determined. You will then have to start a new message."
                    Else
                        instruction = "If a correct CHI number is not available, please leave the field blank, unless it is mandatory."
                    End If
                    MsgBox "Warning: The patient's CHI number is invalid:" & vbNewLine & vbNewLine & _
                        message & vbNewLine & vbNewLine & instruction, _
                        vbExclamation + vbOKOnly, LOCALISED_APP_NAME
                Else
                    instruction = "Please verify the CHI number."
                    If document.formRef("chi").readonly Then ' Populated from GP system
                        instruction = instruction & " If you believe it is incorrect, please correct it in GP system. You will then have to start a new message."
                    Else
                        instruction = instruction & " If a correct CHI number is not available, please blank the CHI number field, unless it is mandatory."
                    End If

                    response = MsgBox("Warning: The patient's CHI number does not match patient data: " & vbNewLine & vbNewline & _
                        message & vbNewLine & vbNewline & instruction, _
                        vbExclamation + vbOKOnly, LOCALISED_APP_NAME)
                    ' Allow the user to continue if they're sure
                End If
            End If
        End If
    End If

    'TT52566
    'check if there are any controls, if so, initialise the control's fields    
    If Not document.all("controls") Is Nothing Then
        call initialiseControls()
    End If

    'Some elements must always be read-only.  Do this last to make sure.
    'Test Track 51520 and 50922
    call MakeFieldsReadOnly()
            
    ' Want to call this here so that the patients details are displayed in the title bar when the referral is opened
    setTimeout "UpdateTitle()", 0 
    
End Sub

Function initialiseControls()

    Dim objControls, objControl
    Dim strControls, strControl, strXmlDataIsland, strControlField, strControlValue
    Dim arrControls, arrControl
    Dim intCount, intSubCount

    Const MAIN_SEPARATOR = "+"
    Const SEPARATOR = ";"

    Set objControls = document.all("controls")

    If Not objControls Is Nothing Then
        'example: referrer+registrar
        strControls = objControls.value
        arrControls = Split(strcontrols, MAIN_SEPARATOR)

        If IsArray(arrControls) Then
            For intCount=LBound(arrControls) to UBound(arrControls)
                strControl = arrControls(intCount)

                Set objControl = document.all(strControl & "controls")

                If Not objControl Is Nothing Then
                    strControlValue = objControl.value

                    arrControl = Split(strControlValue, SEPARATOR)

                    If IsArray(arrControl) Then
                        strXmlDataIsland = arrControl(0)
                        'If we are using user maintained sender details then get out
                        If StrComp(strXmlDataIsland, "xmlsenderdetailsreferrer") <> 0 Then
                            strControlField = arrControl(1)

                            If ((Len(strXmlDataIsland) > 0) And (Len(strControl) > 0)) Then
                                call setFieldValuesFromControl(strControl, strControlField, True)
                            End If
                        End If
                    End If
                End If
            Next
        End If
    End If

End Function



Sub FormPreview(strPreviewLetterURL)
'
' Description:  Submits the protocol form
' Parameters:   
'

    Dim i
    Dim strScreenInstanceName
    Dim strMsgScreenName
    Dim strSpecialtyName
    Dim strHTML

    strMsgScreenName = "RefLetter_" & GetUniqueId()

    'Transfer the message form over to a new window
    On Error Resume Next
    strScreenInstanceName = g_objPreviewWin.name    
    On Error GoTo 0    

    'check if the window is still there
    If (strMsgScreenName <> strScreenInstanceName) Then
        Set g_objPreviewWin = Nothing
    End If

    'Close the previous preview window and open a new one
    If Not g_objPreviewWin Is Nothing Then
        Call g_objPreviewWin.close()
    End If
    Set g_objPreviewWin = window.open("about:blank", strMsgScreenName, "scrollbars, resizable, height=600, width=800, top=20, left=20")

    'Wait until the window is open
    Do
        i = 1                
    Loop Until g_objPreviewWin.document.readyState = "complete"

    ' The grave special character (`) is causing problems when setting the innerHTML, but encoding it with &#96; seems to
    ' work. Note there is the potential for other special characters to screw this up but for time being only encode the
    ' graves
    g_objPreviewWin.document.body.innerHTML = "<div style='display: none'>" & replace(document.forms(FORM_ID).outerHTML, "`", "&#96;") & "</div>"
    RemoveTPIpatientDetailXML(g_objPreviewWin)
    g_objPreviewWin.document.forms(FORM_ID).action = strPreviewLetterURL

    strHTML = IAForms.buildStateInputs()
    If strHTML <> "" Then
        g_objPreviewWin.document.forms(FORM_ID).insertAdjacentHTML "beforeEnd", strHTML
    End If
    
    Call postToURL(g_objPreviewWin.document.forms(FORM_ID).action, FORM_ID,"previewLetter;referredtospecialty;parkSpecialtyName","true" & ";" & document.all("SpecialtyName").value & ";" & document.all("SpecialtyName").value , g_objPreviewWin)

End Sub

Sub RemoveTPIpatientDetailXML(newWindow)
    ' This method removes any elements in newWindow begining with "TPIpatientDetailXML_" as they are not needed in the Preview letter window and on occasion cause Cross Site Scripting errors
    Dim node
    Dim nodesForRemoval()
    ReDim nodesForRemoval(0)
    For Each node in newWindow.document.all
        If IsNumeric(Replace(node.id, "TPIpatientDetailXML_", "")) Then
            ReDim Preserve nodesForRemoval(UBound(nodesForRemoval) + 1)
            Set nodesForRemoval(UBound(nodesForRemoval)) = node
        End If
    Next

    For Each node in nodesForRemoval
        If Not IsEmpty(node) Then
            node.parentNode.removeChild(node)
        End If
    Next
End Sub

Sub FormPark(strParkMsgURL)
'
' Description:  Grabs relevant HTML, and posts
' Parameters:   
'
    Dim strHTML
    Dim strPatientName
    Dim strSex
    Dim strPatientKey
    Dim blnContinue
    Dim blnHasAttachments

    Call disableButtons(True)

    blnWindowCloseMsg = False
    blnContinue = True
    
    If Not document.all("HasAttachments") Is Nothing Then
		blnHasAttachments = CBool(document.all("HasAttachments").value)
	Else
		blnHasAttachments = false
	End If

    'Remove any previously existing park information
    If Not document.all("parkInfo") Is Nothing Then
        If document.all("parkInfo").removeNode(True) Is Nothing Then
            MsgBox("An error occurred parking the message.")
            Call disableButtons(False)
            Exit Sub
        End If
    End If

    Call setPatientInformation(strPatientName, strPatientKey, strSex)

    strHTML = buildPostInfo(m_lngMessageID, document.all("providerId").value, _
                            document.all("specialtyRef").value, document.all("protocolId").value, _
                            strPatientName, strPatientKey, strSex, m_strRefHcpName, document.all("statusText").value, _
                            document.all("allowAppts").value, document.all("msgtypeid").value, _
                            "park", blnContinue, blnHasAttachments, m_lngTempMessageID)

    If(blnContinue) Then

        'Close of the DIV
        strHTML = strHTML & "</div>"

        'Dynamically build form to post
        If document.forms(FORM_ID) is Nothing Then
            'We are using the asp.net form
            FORM_ID = document.forms(0).name
        End If
        document.forms(FORM_ID).insertAdjacentHTML "beforeEnd", strHTML

        strHTML = IAForms.buildStateInputs()
        If strHTML <> "" Then
            document.forms(FORM_ID).insertAdjacentHTML "beforeEnd", strHTML
        End If

        'Submit form
        Call postToURL(strParkMsgURL, FORM_ID, "", "", null)
    Else
        Call disableButtons(False)
    End if

End Sub


Sub FormSubmit(strPostUrl)
'
' Description:  Submits the protocol form
' Parameters:   
'

    Dim blnApptBooked       'As Boolean
    Dim blnContinue         'As Boolean
    Dim sMsgType        'As String
    Dim strHTML         'As String
    Dim strPatientName      'As String
    Dim strPatientKey       'As String
    Dim strSession      'As String
    Dim strMsg          'As String
    Dim strSex              'As String
    Dim strFrameValidation
    Dim objDlgWindow
    Dim objDoc
    Dim objBody    
    Dim objForm
    Dim objFrameValidation
    Dim lngCount
    Dim strSubmitFunction
    Dim blnHasAttachments

    Call disableButtons(True)

    'get the msgtypeid
    sMsgType = document.all("msgtypeid").value

    blnWindowCloseMsg = False
    blnContinue = True

    If document.forms(FORM_ID) is Nothing Then
        'We are using the asp.net form
        FORM_ID = document.forms(0).name
    End If
    
    'Match GMC codes
    If Not UpdateGPFields(document.forms(FORM_ID), True) Then
        Call disableButtons(False)
        Exit Sub
    End If
    'Validate fields
    If Not ValidateFields() Then
        Call disableButtons(False)
        blnWindowCloseMsg = True
        Exit Sub
    End If

    'Determine whether this is an in progress referral with an appointment booked
    Select Case sMsgType
        Case MSG_REFERRAL
            blnApptBooked = (InStr(LCase(m_strStatusText), "app") > 0) And (InStr(LCase(m_strStatusText), "book") > 0)

            'Display confirm message if this will be the final chance to send    
            If blnApptBooked Then
                strMsg = ""
                strMsg = strMsg & "Are you sure that you want to send the referral now?" & vbCrLf
                strMsg = strMsg & "Referral information will be sent to the hospital," & vbCrLf
                strMsg = strMsg & "and no further changes may be made."
                If MsgBox(strMsg, vbYesNo, "Send referral with appointment") <> vbYes Then
                    Call disableButtons(False)
                    Exit Sub
                End If
            End If
    End Select

    'Process the form submission (Remove any previously existing park information)
    If Not document.all("parkInfo") Is Nothing Then
        Call document.all("parkInfo").removeNode(True)
    End If

    If(blnContinue) Then
        document.all("clientValidationPage").style.overflow = "visible"
        'Dynamically add park information into formRef
        strFrameValidation = "frameValidation"
        Set objFrameValidation = Nothing
        On Error Resume Next
        Set objFrameValidation = document.frames(strFrameValidation).document

        On Error GoTo 0

        If objFrameValidation Is Nothing Then
            Call createValidationFrame( document.all("botButt"), _
                document.all("clientValidationPage"), _
                strFrameValidation, _
                document.all("fldGatewayMessageFolder").value, _
                "760", _
                "110")
        End If

        strSubmitFunction = "submitIFrame(1, '" + strPostUrl + "')" 
        document.all("iframeLoadMsg").innerHTML = "Submitting information "
        Call setTimeout(strSubmitFunction, 250)
    Else
        Call disableButtons(False)
    End If

End Sub

Function submitIFrame(intCount, strPostUrl)

    Dim objDoc
    Dim objForm
    Dim strSession
    Dim strFrameValidation
    Dim strHTML
    Dim strPatientName
    Dim strPatientKey
    Dim strSex
    Dim blnContinue
    Dim strFrameMsg
    Dim intCounter
    Dim blnIsLowRes
    Dim strLowRes
    Dim blnHasAttachments

    blnIsLowRes = CBool(document.all("isLowRes").value)
    strLowRes = "<input id='isLowRes' name='isLowRes' value='" & blnIsLowRes & "'>"

    blnContinue = True
    
    If Not document.all("HasAttachments") Is Nothing Then
		blnHasAttachments = CBool(document.all("HasAttachments").value)
	Else
		blnHasAttachments = false
	End If

    'get the session out to post up retaining the session
    strSession = "<input type=""hidden"" id=""fldClientSession"" name=""fldClientSession"" value=""" & document.all("fldSession").value & """/>"
    strFrameValidation = "frameValidation"

    Set objDoc = document.frames(strFrameValidation).document
    	        
    If objDoc.body Is Nothing Then
        intCount = intCount + 1
        If intCount <= 10 Then
            For intCounter=1 to intCount
                strFrameMsg = strFrameMsg & "."
            Next
            document.all("iframeLoadMsg").innerHTML = "Submitting information " & strFrameMsg
            call setTimeout("submitIFrame(" & intCount & ", '" & strPostUrl & "')", 500)
            Exit Function
        Else			
            document.all("iframeLoadMsg").innerHTML = ""
            call removeValidationFrame()			
            Call disableButtons(False)
            msgbox "Web server not responding. Please park the message and try again later."
            Exit Function
        End If
    End If

    If FORM_ID = "GatewayForm" Then
        Set objForm = document.all(FORM_ID)
    Else
        Set objForm = objDoc.createElement("FORM")

        objForm.id      =   "frmParkMsg"
        objForm.name    =   "frmParkMsg"
        objForm.action  =   strPostUrl
        objForm.method  =   "post"
        	        
        Call objDoc.body.appendChild(objForm)

        ' The grave special character (`) is causing problems when setting the objForm.innerHTML as below. Encoding
        ' it with &#96; seems to work though. Note that there is the potential for other special characters to cause
        ' a problem here but for time being just replace the grave
        objForm.innerHTML = replace(document.all("formRef").innerHTML, "`", "&#96;")
    End If

    Call setPatientInformation(strPatientName, strPatientKey, strSex)

    strHTML = buildPostInfo(m_lngMessageID, document.all("providerId").value, document.all("specialtyRef").value, document.all("protocolId").value, _
                            strPatientName, strPatientKey, strSex, m_strRefHcpName, m_strStatusText, document.all("allowAppts").value, _
                            document.all("msgtypeid").value, "commit", blnContinue, blnHasAttachments, m_lngTempMessageID)

    'Close of the DIV
    strHTML = strHTML & "</div>"

    objForm.insertAdjacentHTML "beforeEnd", strHTML
    objForm.insertAdjacentHTML "beforeEnd", strSession
    objForm.insertAdjacentHTML "beforeEnd", strLowRes


    strHTML = IAForms.buildStateInputs()
    If strHTML <> "" Then
        document.forms(FORM_ID).insertAdjacentHTML "beforeEnd", strHTML
    End If
            
    Call removeDuplicateInputs(objForm)
    Call objForm.submit()   

End Function

Function setPatientInformation(strPatientName, strPatientKey, strSex)

    Const DOUBLEQUOTE =34
    Const SINGLEQUOTE = 39   

    'build the patient name    
    strPatientName = ""
    If (Not document.all("patient_forename") Is Nothing) And (Not document.all("patient_surname") Is Nothing) Then
        strPatientName = document.all("patient_forename").value & " " & document.all("patient_surname").value
    End If

    ' handle any special characters
    strPatientName = encodeHTML(strPatientName)
    	    
    strPatientKey = ""
    If Not document.all("patientkey") Is Nothing Then
        strPatientKey = document.all("patientkey").value
    End If

    'Escape any doublequotes
    strPatientKey = replace(strPatientKey, chr(DOUBLEQUOTE), "&quot;")

    'Get the sex. The collection of this information depends on the protocol control type

    strSex = ""
    If Not document.all("patient_sex") Is Nothing Then
        Dim patientSexControl
        Set patientSexControl = document.getElementById("patient_sex")
        Select Case UCase(patientSexControl.tagName)
            Case "SELECT"
                If UCase(patientSexControl.type) = "SELECT-ONE" Then
                    'The patient_sex field is a drop down list control
                    strSex = patientSexControl.value
                    
                    'Check we have just M or F
                    If LCase(strSex) = "male" Then 
                        strSex = "M"
                    ElseIf LCase(strSex) = "female" Then
                        strSex = "F"
                    End If
                End If
            Case "INPUT"
                Select Case UCase(patientSexControl.type)
                    Case "RADIO"
                        'The patient_sex field is a radio control
                        If (Not document.all("patient_sex_1") Is Nothing) And (Not document.all("patient_sex_2") Is Nothing) Then
                            'The sex is a radio box
                            If document.all("patient_sex_1").checked Then 
                                strSex = "M" 
                            ElseIf document.all("patient_sex_2").checked Then
                                strSex = "F"
                            End If
                        End If
                    Case "HIDDEN"
                        'The patient_sex field is a hidden field control
                        strSex = patientSexControl.value
                End Select
            Case Else
                strSex = ""
        End Select
    End If

    strPatientName = escape(strPatientName)

End Function

Function createValidationFrame(objButtonBar, objValDivObject, strValidationFrameID, strValidationFrameSRC, strValidationFrameWidth, strValidationFrameHeight)

    Dim objBR
    Dim objDoc
    Dim objBody
    Dim objDlgWindow
    Dim lngCount             

    'create validation frame
    Set objDlgWindow = document.createElement("IFRAME")
    	        
    'create the break tag to position the validation bar underneath the button bar
    Set objBR = document.createElement("BR")                
    	                            
    objDlgWindow.id     =   strValidationFrameID
    objDlgWindow.name   =   strValidationFrameID
    objDlgWindow.src    =   strValidationFrameSRC
    objDlgWindow.width  =   strValidationFrameWidth
    objDlgWindow.height =   strValidationFrameHeight
    objDlgWindow.style.display = "none"
    objDlgWindow.scrolling = "yes"

    objValDivObject.appendChild(objBR)
    objValDivObject.appendChild(objDlgWindow)   
    
   
    call ResizeWindow(document.body.offsetWidth+8,600)
    
End Function

Function removeValidationFrame()

    Dim strFrameValidation
    Dim objValDivObject
    Dim objDlgWindow
    Dim blnIsLowRes

    blnIsLowRes = CBool(document.all("isLowRes").value)

    strFrameValidation = "frameValidation"

    'get the validation bar placeholder
    Set objValDivObject = document.all("clientValidationPage")

    'get the iframe
    Set objDlgWindow = document.all(strFrameValidation)

    If (Not objValDivObject Is Nothing)	And (Not objDlgWindow Is Nothing) Then
        call objValDivObject.removeChild(objDlgWindow)
    End If

End Function

Function buildPostInfo2(lngProviderID, strSpecialtyRef, lngProtocolID, strPatientName, strPatientKey, strSex, strRefHcpName, strStatusText, strAllowAppts, lngMsgTypeID, lngAction)
    
    Dim strHTML
    Dim strTempSurname,strTempForename
    Dim intReturnValue
    Dim strHospitalName
    Dim strSpecialtyName
    Dim strProtocolName
    Dim strChiNumber
    Dim strSurName
    Dim strForeName
    Dim strDob
    Dim strRefToHcpIdScheme, strRefToHcpIdType
    Dim strConsultantID
    Dim strThirdPartyAppName, strThirdPartyProgId

    Const SINGLEQUOTE = 39   
    Const DOUBLEQUOTE = 34 

    strRefHcpName = ""
    If not document.all("refGp_Name") is nothing then
        strRefHcpName = document.all("refGp_Name").value
    ElseIf not document.all("refhcp_surname") is nothing then
        strRefHcpName = document.all("refhcp_surname").value

        If not document.all("refhcp_forename") is nothing then
            strRefHcpName = document.all("refhcp_forename").value & " " & strRefHcpName
        End If
    End if

    strHospitalName = ""
    If Not document.all("HospitalName") Is Nothing Then
        strHospitalName = document.all("HospitalName").value
    End If

    strSpecialtyName = ""
    If Not document.all("SpecialtyName") Is Nothing Then
        strSpecialtyName = document.all("SpecialtyName").value
    End If
    	
    strProtocolName = ""
    If Not document.all("Protocol") Is Nothing Then
        strProtocolName = document.all("Protocol").value
    End If

    strCHINumber = ""
    If Not document.all("chi") Is Nothing Then
    	strCHINumber = document.all("chi").value
    ElseIf Not document.all("hcn") Is Nothing Then
	    strCHINumber = document.all("hcn").value
    ElseIf Not document.all("patient_nhs_number") Is Nothing Then
        strCHINumber = document.all("patient_nhs_number").value
    End If

    strSurName = ""
    If Not document.all("patient_surname") Is Nothing Then
        strSurName = document.all("patient_surname").value
    End If

    strForeName = ""
    If Not document.all("patient_forename") Is Nothing Then
        strForeName = document.all("patient_forename").value
    End If  

    strDob = ""
    If Not document.all("patient_dob") Is Nothing Then
        strDob = document.all("patient_dob").value
    End If

    ' handle any special characters
    strSurname = encodeHTML(strSurname)      
    strForename = encodeHTML(strForename)

    strRefToHcpIdScheme = ""
    If Not document.all("reftohcpidscheme") Is Nothing Then
        strRefToHcpIdScheme = document.all("reftohcpidscheme").value
    End If

    strRefToHcpIdType = ""
    If Not document.all("reftohcpidtype") Is Nothing Then
        strRefToHcpIdType = document.all("reftohcpidtype").value
    End If

    strConsultantID = ""
    If Not document.all("consultantid") Is Nothing Then
        strConsultantID = document.protocolinfo("consultantid").value
    End If

    strThirdPartyAppName = ""
    If Not document.all("ThirdPartyAppName") Is Nothing Then
        strThirdPartyAppName = document.protocolinfo("ThirdPartyAppName").value
    End If

    strThirdPartyProgId = ""
    If Not document.all("ThirdPartyProgId") Is Nothing Then
        strThirdPartyProgId = document.protocolinfo("ThirdPartyProgId").value
    End If        

    strHTML = ""
    strHTML = strHTML & "<div class=hiddenDiv id=parkInfo name=parkInfo>"
    'strHTML = strHTML & "<input type=hidden name='parkMessageId'   id='parkMessageId' value='" & lngMessageID & "'/>"
    strHTML = strHTML & "<input type=hidden name='parkProviderId'  id='parkProviderId' value='" & lngProviderID & "'/>"
    strHTML = strHTML & "<input type=hidden name='specialtyref'  id='specialtyref' value='" & strSpecialtyRef & "'/>"
    strHTML = strHTML & "<input type=hidden name='referredtospecialty'  id='referredtospecialty' value='" & strSpecialtyName & "'/>"
    strHTML = strHTML & "<input type=hidden name='parkProtocolId'  id='parkProtocolId' value='" & lngProtocolID & "'/>"
    strHTML = strHTML & "<input type=hidden name='parkPatientName'		id='parkPatientName' value='" & strPatientName & "'/>"
    strHTML = strHTML & "<input type=hidden name='patientkey'			id='patientkey' value='" & strPatientKey & "'/>"
    strHTML = strHTML & "<input type=hidden name='ThirdPartyAppName'    id='ThirdPartyAppName'	value='" & strThirdPartyAppName & "'/>"
    strHTML = strHTML & "<input type=hidden name='ThirdPartyProgId'		id='ThirdPartyProgId'	value='" & strThirdPartyProgId & "'/>"
    strHTML = strHTML & "<input type=hidden name='reftohcpidscheme'      id='reftohcpidscheme' value='" & strRefToHcpIdScheme & "'/>"
    strHTML = strHTML & "<input type=hidden name='reftohcpidtype'      id='reftohcpidtype' value='" & strRefToHcpIdType & "'/>"
    strHTML = strHTML & "<input type=hidden name='consultantid'    id='consultantid' value='" & strConsultantID & "'/>"
    strHTML = strHTML & "<input type=hidden name=parkHospitalName id=parkHospitalName value='" & strHospitalName & "'/>"
    strHTML = strHTML & "<input type=hidden name=parkSpecialtyName id=parkSpecialtyName value='" & strSpecialtyName & "'/>"
    strHTML = strHTML & "<input type=hidden name=parkProtocolName id=parkProtocolName value='" & strProtocolName & "'/>"
    'strHTML = strHTML & "<input type=hidden name='parkTempMessageId'   id='parkTempMessageId' value='" & lngTempMessageID & "'/>"
   

    ' *** TODO: parkStatusText required to propagate "new" - need explicit mechanism for new status
    '           e.g. new = true/false
    strHTML = strHTML & "<input type=hidden name='parkStatusText'  id='parkStatusText' value='" & strStatusText & "'/>"
    strHTML = strHTML & "<input type=hidden name='parkAllowAppts'  id='parkAllowAppts' value='" & strAllowAppts & "'/>"
    	
   
    strHTML = strHTML & "<input type=hidden name='parkMsgTypeId'   id='parkMsgTypeId' value='" & lngMsgTypeID & "'/>"
    strHTML = strHTML & "<input type=hidden name='parkPatChi'   id='parkPatChi' value='" & strChiNumber & "'/>"
    strHTML = strHTML & "<input type=hidden name='parkPatSurname'   id='parkPatSurname' value='" & strSurname & "'/>"
    strHTML = strHTML & "<input type=hidden name='parkPatForename'   id='parkPatForename' value='" & strForename & "'/>"
    strHTML = strHTML & "<input type=hidden name='parkPatDob'   id='parkPatDob' value='" & strDob & "'/>"
    strHTML = strHTML & "<input type=hidden name='parkPatSex'   id='parkPatSex' value='" & strSex & "'/>"   
    'TT54405 - need to encode strRefHcpName or will loose anything after apostrophe, can't encode earlier as that would cause probs with filters
    strHTML = strHTML & "<input type=hidden name='parkRefHcpName'   id='parkRefHcpName' value='" & encodeHTML(strRefHcpName) & "'/>"   

    If strStatusText = "new" Then
        strHTML = strHTML & "<input type=hidden name='parkPrinted'   id='parkPrinted' value='" & m_blnPrinted & "'/>"
    End If
    
    'strHTML = strHTML & "<input type=hidden name='HasAttachments' id='HasAttachments' value='" & CStr(blnHasAttachments) & "'/>"

    buildPostInfo2 = strHTML

End Function
    
Function buildPostInfo(lngMessageID, lngProviderID, strSpecialtyRef, lngProtocolID, strPatientName, strPatientKey, strSex, strRefHcpName, strStatusText, strAllowAppts, lngMsgTypeID, lngAction, blnContinue, blnHasAttachments, lngTempMessageID)
    
    Dim strHTML
    Dim strTempSurname,strTempForename
    Dim intReturnValue
    Dim strHospitalName
    Dim strSpecialtyName
    Dim strProtocolName
    Dim strIdScheme
    Dim strChiNumber
    Dim strSurName
    Dim strForeName
    Dim strDob
    Dim strRefToHcpIdScheme, strRefToHcpIdType
    Dim strConsultantID
    Dim strThirdPartyAppName, strThirdPartyProgId

    Const SINGLEQUOTE = 39   
    Const DOUBLEQUOTE = 34 

    strRefHcpName = ""
    If not document.all("refGp_Name") is nothing then
        strRefHcpName = document.all("refGp_Name").value
    ElseIf not document.all("refhcp_surname") is nothing then
        strRefHcpName = document.all("refhcp_surname").value

        If not document.all("refhcp_forename") is nothing then
            strRefHcpName = document.all("refhcp_forename").value & " " & strRefHcpName
        End If
    End if

    strHospitalName = ""
    If Not document.all("HospitalName") Is Nothing Then
        strHospitalName = document.all("HospitalName").value
    End If

    strSpecialtyName = ""
    If Not document.all("SpecialtyName") Is Nothing Then
        strSpecialtyName = document.all("SpecialtyName").value
    End If
    	
    strProtocolName = ""
    If Not document.all("Protocol") Is Nothing Then
        strProtocolName = document.all("Protocol").value
    End If

    strIdScheme = ""
    If Not document.all("idscheme") Is Nothing Then
        strIdScheme = document.all("idscheme").value
    End If

    strCHINumber = ""
    If Not document.all("chi") Is Nothing Then
    	strCHINumber = document.all("chi").value
    ElseIf Not document.all("hcn") Is Nothing Then
	    strCHINumber = document.all("hcn").value
    ElseIf Not document.all("patient_nhs_number") Is Nothing Then
        strCHINumber = document.all("patient_nhs_number").value
    End If

    strSurName = ""
    If Not document.all("patient_surname") Is Nothing Then
        strSurName = document.all("patient_surname").value
    End If

    strForeName = ""
    If Not document.all("patient_forename") Is Nothing Then
        strForeName = document.all("patient_forename").value
    End If  

    strDob = ""
    If Not document.all("patient_dob") Is Nothing Then
        strDob = document.all("patient_dob").value
    End If

    ' handle any special characters
    strSurname = encodeHTML(strSurname)      
    strForename = encodeHTML(strForename)

    strRefToHcpIdScheme = ""
    If Not document.all("reftohcpidscheme") Is Nothing Then
        strRefToHcpIdScheme = document.all("reftohcpidscheme").value
    End If

    strRefToHcpIdType = ""
    If Not document.all("reftohcpidtype") Is Nothing Then
        strRefToHcpIdType = document.all("reftohcpidtype").value
    End If

    strConsultantID = ""
    If Not document.all("consultantid") Is Nothing Then
        strConsultantID = document.protocolinfo("consultantid").value
    End If

    strThirdPartyAppName = ""
    If Not document.all("ThirdPartyAppName") Is Nothing Then
        strThirdPartyAppName = document.protocolinfo("ThirdPartyAppName").value
    End If

    strThirdPartyProgId = ""
    If Not document.all("ThirdPartyProgId") Is Nothing Then
        strThirdPartyProgId = document.protocolinfo("ThirdPartyProgId").value
    End If        

    strHTML = ""
    strHTML = strHTML & "<div class=hiddenDiv id=parkInfo name=parkInfo>"
    strHTML = strHTML & "<input type=hidden name='parkMessageId'   id='parkMessageId' value='" & lngMessageID & "'/>"
    strHTML = strHTML & "<input type=hidden name='parkProviderId'  id='parkProviderId' value='" & lngProviderID & "'/>"
    strHTML = strHTML & "<input type=hidden name='specialtyref'  id='specialtyref' value='" & strSpecialtyRef & "'/>"
    strHTML = strHTML & "<input type=hidden name='referredtospecialty'  id='referredtospecialty' value='" & strSpecialtyName & "'/>"
    strHTML = strHTML & "<input type=hidden name='parkProtocolId'  id='parkProtocolId' value='" & lngProtocolID & "'/>"
    strHTML = strHTML & "<input type=hidden name='parkPatientName'		id='parkPatientName' value='" & strPatientName & "'/>"
    strHTML = strHTML & "<input type=hidden name='patientkey'			id='patientkey' value='" & strPatientKey & "'/>"
    strHTML = strHTML & "<input type=hidden name='ThirdPartyAppName'    id='ThirdPartyAppName'	value='" & strThirdPartyAppName & "'/>"
    strHTML = strHTML & "<input type=hidden name='ThirdPartyProgId'		id='ThirdPartyProgId'	value='" & strThirdPartyProgId & "'/>"
    strHTML = strHTML & "<input type=hidden name='reftohcpidscheme'      id='reftohcpidscheme' value='" & strRefToHcpIdScheme & "'/>"
    strHTML = strHTML & "<input type=hidden name='reftohcpidtype'      id='reftohcpidtype' value='" & strRefToHcpIdType & "'/>"
    strHTML = strHTML & "<input type=hidden name='consultantid'    id='consultantid' value='" & strConsultantID & "'/>"
    strHTML = strHTML & "<input type=hidden name=parkHospitalName id=parkHospitalName value='" & strHospitalName & "'/>"
    strHTML = strHTML & "<input type=hidden name=parkSpecialtyName id=parkSpecialtyName value='" & strSpecialtyName & "'/>"
    strHTML = strHTML & "<input type=hidden name=parkProtocolName id=parkProtocolName value='" & strProtocolName & "'/>"
    strHTML = strHTML & "<input type=hidden name=idscheme id=idscheme value='" & strIdScheme & "'/>"
    strHTML = strHTML & "<input type=hidden name='parkTempMessageId'   id='parkTempMessageId' value='" & lngTempMessageID & "'/>"
   

    ' *** TODO: parkStatusText required to propagate "new" - need explicit mechanism for new status
    '           e.g. new = true/false
    strHTML = strHTML & "<input type=hidden name='parkStatusText'  id='parkStatusText' value='" & strStatusText & "'/>"
    strHTML = strHTML & "<input type=hidden name='parkAllowAppts'  id='parkAllowAppts' value='" & strAllowAppts & "'/>"
    	
    Select Case lngAction
        Case "park"
            strHTML = strHTML & "<input type=hidden name='parkCommitFlag'  id='parkCommitFlag' value='False'/>"
        Case "commit"
            strHTML = strHTML & "<input type=hidden name='parkCommitFlag'  id='parkCommitFlag' value='True'/>"
    End Select

    strHTML = strHTML & "<input type=hidden name='parkMsgTypeId'   id='parkMsgTypeId' value='" & lngMsgTypeID & "'/>"
    strHTML = strHTML & "<input type=hidden name='parkPatChi'   id='parkPatChi' value='" & strChiNumber & "'/>"
    strHTML = strHTML & "<input type=hidden name='parkPatSurname'   id='parkPatSurname' value='" & strSurname & "'/>"
    strHTML = strHTML & "<input type=hidden name='parkPatForename'   id='parkPatForename' value='" & strForename & "'/>"
    strHTML = strHTML & "<input type=hidden name='parkPatDob'   id='parkPatDob' value='" & strDob & "'/>"
    strHTML = strHTML & "<input type=hidden name='parkPatSex'   id='parkPatSex' value='" & strSex & "'/>"   
    'TT54405 - need to encode strRefHcpName or will loose anything after apostrophe, can't encode earlier as that would cause probs with filters
    strHTML = strHTML & "<input type=hidden name='parkRefHcpName'   id='parkRefHcpName' value='" & encodeHTML(strRefHcpName) & "'/>"   

    If strStatusText = "new" Then
        strHTML = strHTML & "<input type=hidden name='parkPrinted'   id='parkPrinted' value='" & m_blnPrinted & "'/>"
    End If
    
    strHTML = strHTML & "<input type=hidden name='HasAttachments' id='HasAttachments' value='" & CStr(blnHasAttachments) & "'/>"

    buildPostInfo = strHTML

End Function

Function CheckIfObjectExists(object)
'
' Description:  Check if an object exists
' Parameters:   
'

    CheckIfObjectExists = false 

    If jsCheckIfExists(object) = "undefined" Then
        CheckIfObjectExists = false 
    Else
        If Not (object Is Nothing) Then
            CheckIfObjectExists = true
        End If
    End If

End Function

Sub InitialiseNewMessage()
'
' Description:  Initialises form fields on a new message.
' Parameters:   None
'

    Dim strPatientKey               'As String
    Dim strProtocolXML              'As String
    Dim objForm						'As Object
    Dim formName
    Dim strHcpId

    Set g_objGpassApp = GetGpassInstance()
    
    If document.forms("GatewayForm") Is Nothing Then
        Set formName = document.all("protocolInfo")
    Else
        Set formName = document.all("GatewayForm")
    End If

    strHcpId = formName("ConsultantID").value
    
    If strHcpId = "" Then
        If Not formName("gpid") Is Nothing Then
            strHcpId = formName("gpid").value
        End If
    End If
    
    ' Pre-populate miscellaneous form information
    Call PopulateMiscInfo(formName("SpecialtyName").value, _
                                formName("ProtocolName").value, _
                                formName("ConsultantSurname").value, _
                                formName("ConsultantForename").value, _
                                strHcpId, _
                                formName("HospitalID").value, _
                                formName("HospitalName").value, _
                                formName("HospitalAddress").value, _
                                Date())           'default date is today

    If Not g_objGpassApp Is Nothing And In_Gpass() Then
        If CheckIfObjectExists(document.all("protocolXML")) Then
            If Len(CStr(document.all("protocolXML").xml)) > 0 Then
                document.all("divRetrieval").style.display = "block"
                'Pre-populate form information from GPASS
                setTimeout "startGpassRetrieval()", 0
            End If
        End If
    ElseIf CBool(document.all("isThirdParty").value) Then
        'Prepopulation from third party GP system will already have taken place and we
        'still need to ensure that form elements are not enabled
        document.all("divScreen").style.display = "block"
    ElseIf CBool(document.all("isPrePopulatedFromOriginalMessage").value) Then
        ' The details were prepopulated at the server from another message, so the readonly fields should be left readonly
        document.all("divScreen").style.display = "block"
    Else
        'We can't collect information from the GP system, so all fields must be made writable
        Call EnableFormElements()
        document.all("divScreen").style.display = "block"
    End If

    ' If there is no hcp_id question then clear the reftohcpidscheme & reftohcpidtype hidden fields
    ' so that the HcpId complex type element of the ReferredToHcp complex type gets cleared and deleted.
    ' This is all because we don't want to make the hcp_id question mandatory.
    Set objForm = document.Forms("formref")
    If Not objForm Is Nothing Then
        If objForm("hcp_id") Is Nothing Then
            document.all("reftohcpidscheme").value = ""
            document.all("reftohcpidtype").value = ""
        End If
    End If

    Set g_objGpassApp = Nothing

End Sub

Sub StartGPassRetrieval()

    Dim strPatientKey

    Set g_objGpassApp = GetGpassInstance()

    strPatientKey = ""

    'Get the patient key where provided
    If Not document.all("patientKey") Is Nothing Then
        strPatientKey = CStr(document.all("patientKey").value)
        'Check for NULL
        If InStr(strPatientKey, "NULL") > 0 Then
            strPatientKey = ""
        End If
    End If

    If Len(strPatientKey) > 0 Then      
        Call InitialisePrePopMsgWindow()	            
        Call PopulateGpassReferral(strPatientKey, "protocolInfo", "frmCurrentEncounter")
    End If          

    document.all("divRetrieval").style.display = "none"
    document.all("divScreen").style.display = "block"

    Call ClosePrePopMsgWindow()

    If (Not document.forms(FORM_ID).elements.item("chi") Is Nothing) Then
        Call correctCHINumber()
    End If

End Sub

Sub InitialisePrePopMsgWindow()

    Dim i

    m_strPrePopWindowName = "RetrievingInformation"
    Set m_objPrePopWin = window.open("about:blank", m_strPrePopWindowName, "scrollbars=no, resizable=no, titlebar=no,height=100, width=400, top=250, left=250")        

    Do
        i = 1
    Loop Until m_objPrePopWin.document.readyState = "complete"
    	
    m_objPrePopWin.document.title = "Retrieving information from GPASS"
    Set m_objPrePopMsg = m_objPrePopWin.document.createElement("div")
    Set m_objClinEventProgMain = m_objPrePopWin.document.createElement("div")
    Set m_objClinEventProgDetail = m_objPrePopWin.document.createElement("div")
    Set m_objClinEventProgNumbers = m_objPrePopWin.document.createElement("div")
    	    
    m_objPrePopWin.document.body.appendChild(m_objPrePopMsg)
    m_objPrePopWin.document.body.appendChild(m_objClinEventProgMain)
    m_objPrePopWin.document.body.appendChild(m_objClinEventProgNumbers)     
    m_objClinEventProgMain.appendChild(m_objClinEventProgDetail)    
    	    
    m_objPrePopMsg.innerHTML = "Retrieving information..."     
    	    
End Sub

Sub ClosePrePopMsgWindow()

    On Error Resume Next
    If Not m_objPrePopWin Is Nothing Then
        m_objPrePopWin.close()
    End If
    On Error GoTo 0 

End Sub

Sub PopulateMiscInfo(strSpecialtyName, strProtocolName, strConsultantSurname, strConsultantForename, _
					strRefToID, strHospitalID, strHospitalName, strHospitalAddress, strDate)
'
' Description:  Temporary function to populate miscellaneous fields.
'
' Parameters:   strSpecialtyName        - the specialty being referred to
'               strProtocolName         - the protocol used
'               strConsultantForename   - the given name of the consultant being referred to
'               strConsultantSurname    - the consultant's last name
'               strRefToID              - the consultant/hcp's ID (GMC/HCP Code not HCEID)
'               strHospitalName         - the hospital being referred to
'               strDate                 - the message date
'

    Dim objForm         'As Object

    If document.forms(FORM_ID) is Nothing Then
        'We are using the asp.net form
        FORM_ID = document.forms(0).name
    End If
    
    Set objForm = document.forms(FORM_ID)
    
    If Not objForm("specialty") Is Nothing Then
        If not VBMatchElementType("Specialty", "HTMLSelectElement") Then
            objForm("specialty").value = strSpecialtyName
        End If 
    End If 

    If Not objForm("protocol") Is Nothing Then
        objForm("protocol").value = strProtocolName
    end if 

    If not objForm("HCP_surname") is nothing then
        objForm("HCP_surname").value = strConsultantSurname
    end if 

    If not objForm("HCP_forename") Is Nothing Then
        objForm("HCP_forename").value = strConsultantForename
    End If 

    If Not objForm("HCP_ID") Is Nothing Then
        objForm("HCP_ID").value = strRefToID
    End If

    If Not objForm("Hospital_ID") Is Nothing Then
        If not VBMatchElementType("Hospital_ID", "HTMLSelectElement") Then
            objForm("Hospital_ID").value = strHospitalID
        End If
    End If

    If Not objForm("Hospital_Name") Is Nothing Then
        If not VBMatchElementType("Hospital_Name", "HTMLSelectElement") Then
            objForm("Hospital_Name").value = strHospitalName
        End If 
    End If

    If Not objForm("Hospital_Address") Is Nothing Then
        objForm("Hospital_Address").value = strHospitalAddress
    End If 

    If Not objForm("referral_date") Is Nothing Then
        objForm("referral_date").value = UnambiguousDate(strDate)
    End If

End Sub

Sub addUniqueObject(strElementName)

    Dim strArrayName
    Dim iNewIndex
    Dim iCounter
    Dim bFound 

    bFound = False 

    ' Search for existing name
    For iCounter = 0 to UBound(aRadioItems)   
        strArrayName = aRadioItems(ICounter)
        If strElementName = strArrayName Then
            bFound = True
        End if
    Next

    ' Add to list if not found
    if(bFound = False) then
        iNewIndex = Ubound(aRadioItems)
        ReDim Preserve aRadioItems(iNewIndex)       
        aRadioItems(iNewindex) = strElementName         
    End if

End Sub

Function ValidateFields()
'
' Description:  Checks that mandatory form fields have been filled, and that valid 
'               information has been entered.
' Parameters:   None
' Returns:      True if fields are valid
'

    Dim blnValidationErr            'As Boolean
    Dim objForm                     'As DHTML form
    Dim iCounter                    'As Int
    Dim bChecked                    'As Bool
    Dim strProtocolXML              'As String
    Dim objProtocolXML              'As DOMDocument
    Dim objQuestionNodeList         'As IXMLDOMSelection
    Dim objQuestionNode             'As IXMLDOMElement
    Dim strQuestionType             'As String
    Dim blnQuestionMandatory        'As Bool
    Dim strQuestionValidation       'As String
    Dim strQuestionID               'As String
    Dim strQuestionText             'As String
    Dim strParentQuestionText
    Dim lngQuestionMaxlength        'As Long
    Dim objField                    'As HTMLInputElement
    Dim objTbl                      'As HTMLTable
    Dim objRows                     'As HTMLElementCollection
    Dim objRow
    Dim objCell                     'As HTMLTableCell
    Dim objCells                    'As HTMLElementCollection
    Dim objInput                    'As HTMLInputElement
    Dim blnTblFldMandatory          'As Bool
    Dim lngTblFldMaxlength          'As Long
    Dim objQuestionColumns          'As IXMLDOMSelection
    Dim objQuestionRows             'As IXMLDOMSelection
    Dim intColCount                 'As Int
    Dim intRowCount                 'As Int
    Dim strTblRowName               'As String
    Dim strTblColumnName            'As String
    Dim intTabIndex                 'As Int
    Dim arrErrors   ()              'As Array
    Dim lngArrRow                   'As long
    Dim lngArrCol                   'As long
    Dim lngColCount                 'As long
    Dim strErrors                   'As String
    Dim arrErrMsgs                  'As Array
    Dim strHTML                     'As String
    Dim lngCount                    'As Long
    Dim intTabIdx                   'As Int
    Dim lngRowIdx                   'As Long
    Dim intColIdx                   'As Int
    Dim strColTxt                   'As String
    Dim strColId                    'As String
    Dim intRenderVersion            'As Int
    Dim blnIsAccessible             'As Boolean
    Dim blnCanGetFocus              'As Boolean
    Dim blnEmptyRow
    Dim blnDeletedRow                     
    Dim strRowId
    Dim intRowNumber
    Dim strInstruction
    Dim strMsgOverflow
    Dim blnSizeLimitOverFlow
    Dim strColumnType               'As String (Added: S.Craig - 30-Apr-04 - Defect#52004)
    Dim blnIsLowRes
    Dim objTableValidationNode
    Dim objTableValidationNodes
    Dim strObjectX
    Dim strObjectY
    Dim strOperator    
    Dim strTableValidationType
    Dim strObjectXValue
    Dim strObjectYValue    
    Dim strMessage	

    Const MSG_INVALID_DOB        = "Date of Birth cannot lie in future"
    Const MSG_INVALID_DATE       = "Invalid Date - Required format dd-mmm-yyyy"
    Const MSG_INVALID_REF_DATE   = "Referral Date cannot lie in future"

    Const MSG_MAND_MISSING       = "Value missing from mandatory field"
    Const MSG_OVERFLOW           = "Too many characters"
    Const MSG_INVALID            = "Incorrect Format"
    Const SEPARATOR              = "~"
    Const ARR_ERR_ROWS           = "9"
    Const ARR_ERR_COLS           = "7"
    Const ARR_ERR_ROWS_INCREMENT = "5"

    'Default to invalid
    ValidateFields = True
    blnValidationErr = False
    intTabIndex = Empty

    If document.all("isLowRes") Is Nothing Then
        blnIsLowRes = false
    Else
        blnIsLowRes = CBool(document.all("isLowRes").value)
    End If


    'Initialise error array
    ReDim arrErrors(ARR_ERR_COLS, ARR_ERR_ROWS)

    'Grab the form & bail out if we can't find it    
    Set objForm = document.forms(FORM_ID)
    If objForm Is Nothing Then
        MsgBox "Unable to process message form. Please contact SCI support.", 48, "Validating message"
        Exit Function
    End If

    strProtocolXML = Document.GetElementById("protocolXML").xml

    Set objProtocolXML = CreateObject("MSXML.DOMDocument")
    objProtocolXML.async = false

    If Not objProtocolXML.LoadXML(strProtocolXML) Then
        'there is a problem
        Msgbox("Problem loading Protocol XML for validation purposes")
    Else
        'Get list of questions 
        Set objQuestionNodeList = objProtocolXML.documentElement.selectNodes("//question")
        'Loop through questions and validate form input if necessary 
        If Not objQuestionNodeList Is Nothing Then
            'initialise error array row count
            lngArrRow = 0

            For Each objQuestionNode In objQuestionNodeList
                ' Protocols can contain referring GP and referring HCP questions but only one set is included in the form
                ' so if we cannot find the question then don't bother validating it
                strQuestionID         = objQuestionNode.getAttribute("id")
                Set objField = document.all(strQuestionID)

                ' If we're using interactive forms then the question may have been hidden, disabled or made invisible
                ' in which case it is inAccessible and we should not validate it as it is not being posted.
                intRenderVersion      = CInt(objQuestionNode.getAttribute("renderVersion"))
                If intRenderVersion = 2 And (Not objField Is Nothing) Then
                    blnIsAccessible = IAForms.isAccessible(strQuestionId)
                Else
                    blnIsAccessible = true
                End If

                If (blnIsAccessible) And (Not objField Is Nothing) Then
                    'initialise error array col count and error string
                    lngArrCol = 0
                    strErrors = ""

                    strQuestionValidation = LCase(objQuestionNode.getAttribute("validate"))
                    strQuestionText       = objQuestionNode.getAttribute("text")
                    strParentQuestionText = objQuestionNode.ParentNode.getAttribute("text")
                    strQuestionType       = LCase(objQuestionNode.getAttribute("type"))
                    If IsNull(strQuestionType) Then
                        strQuestionType = "text"
                    End If

                    If Not IsNull(objQuestionNode.getAttribute("maxlength")) And objQuestionNode.getAttribute("maxlength") <> "*" Then
                        lngQuestionMaxlength = CLng(objQuestionNode.getAttribute("maxlength"))
                    Else
                        lngQuestionMaxlength = Empty
                    End If

                    blnQuestionMandatory = False
                    If Not IsNull(objQuestionNode.getAttribute("mandatory")) Then
                        blnQuestionMandatory = CBool(objQuestionNode.getAttribute("mandatory"))
                    End If

                    If intRenderVersion = 2 Then
                        blnQuestionMandatory = IAForms.isRequired(strQuestionID)
                    End If

                    Select Case strQuestionType
                        Case "text", "textarea", "date", "check", "radio", "select"
                            strErrors = PerformStdInputValidation(strQuestionId, strQuestionType, objQuestionNode, objField, blnQuestionMandatory, lngQuestionMaxLength)

                            If Len(strErrors) <> 0 Then
                                blnValidationErr = True
                                arrErrMsgs = Split(strErrors, SEPARATOR)
                                intTabIdx = GetTabIndex(objQuestionNode)
                                For iCounter = 0 to (UBound(arrErrMsgs) - 1)
                                    Call PopulateErrorArray(arrErrors, lngArrRow, strQuestionID, strParentQuestionText & ": " & strQuestionText, intTabIdx, strQuestionType,,,,arrErrMsgs(iCounter))
                                    'Increment error array rows
                                    lngArrRow = lngArrRow + 1
                                    If lngArrRow = Ubound(arrErrors, 2) Then
                                        ReDim Preserve arrErrors(ARR_ERR_COLS, Ubound(arrErrors, 2) + ARR_ERR_ROWS_INCREMENT)
                                    End If
                                Next
                            End If
                        Case "dynatable", "gidynatable"
                            'We need to find out what we have to check here i.e. mandatory, maxlength etc
                            Set objTbl = Document.GetElementById(strQuestionID)
                            Set objRows = objTbl.Rows
                            intRowCount = objRows.Length - 1
                            Set objQuestionColumns = objQuestionNode.GetElementsByTagName("column")
                            intColCount = objQuestionColumns.Length - 1
                            intTabIdx = GetTabIndex(objQuestionNode)

                            'Not interested in the first row as this has header information in it
                            'Start index count from 1 to skip the first row
                            For lngRowIdx = 1 To intRowCount
                                strRowId = objRows(lngRowIdx).getAttribute("id")
                                blnDeletedRow = Right(objRows(lngRowIdx).getAttribute("id"), 7) = "DELETED" Or Right(strRowId, 15) = "DELETEDUNDELETE"

                                Set objCells = objRows(lngRowIdx).Cells
                                blnEmptyRow = checkForEmptyRow(objCells)
                                If Not (blnEmptyRow Or blnDeletedRow) Then
                                    ' Get the row number (which is different to the row index as deleted rows do not count in row number but are in the index).
                                    intRowNumber = CInt(Mid(strRowId, Len(strQuestionId) + 2))
                                    ' First column/cell is the delete/undelete button so ignore and start at column 1
                                    For intColIdx = 1 to intColCount + 1 ' There is the additional column for the Delete/Undelete button
                                        Set objCell = objCells(intColIdx)
                                        strErrors = PerformDynaTableColumnValidation(strQuestionId, objQuestionNode, objQuestionColumns(intColIdx - 1), intRowNumber, intColIdx, objCell)

                                        If Len(strErrors) > 0 Then
                                            blnValidationErr = True

                                            strColId = objQuestionColumns(intColIdx - 1).getAttribute("id")
                                            strColTxt = objQuestionColumns(intColIdx - 1).getAttribute("text")

                                            arrErrMsgs = Split(strErrors, SEPARATOR)
                                            For iCounter = 0 to (UBound(arrErrMsgs) - 1)
                                                Call PopulateErrorArray(arrErrors, lngArrRow, strQuestionID, strParentQuestionText & ": " & strQuestionText, intTabIdx, strQuestionType, intRowNumber, strColId, strColTxt, arrErrMsgs(iCounter))
                                                lngArrRow = lngArrRow + 1
                                                If lngArrRow = Ubound(arrErrors, 2) Then
                                                    ReDim Preserve arrErrors(ARR_ERR_COLS, Ubound(arrErrors, 2) + ARR_ERR_ROWS_INCREMENT)
                                                End If
                                            Next
                                        End If
                                    Next
                                End If
                            Next


                        Case "table"
                            Set objTbl = Document.GetElementById(strQuestionID)
                            Set objRows = objTbl.Rows

                            'Find out if the protocol has 'mandatory' and/or 'maxlength' attributes for this input field
                            Set objQuestionColumns = objQuestionNode.GetElementsByTagName("column")
                            Set objQuestionRows = objQuestionNode.GetElementsByTagName("row")
                            'Not interested in the first row as this has header information in it
                            'Start index count from 1 to skip the first row
                            For intRowCount = 1 To (objRows.Length - 1)
                                strTblRowName = objQuestionRows(intRowCount-1).getAttribute("text")
                                Set objCells = objRows(intRowCount).GetElementsByTagName("Input")
                                blnEmptyRow = True
                                blnEmptyRow = checkForEmptyRow(objRows(intRowCount).Cells)

                                If Not blnEmptyRow Then
                                    'Skip first input tag as it is of type hidden
                                    For iCounter = 1 to (objCells.Length-1)
                                        'Obtain the following attributes associated with the current
                                        'XML column entry:
                                        '   - text;
                                        '   - maxlength;
                                        '   - mandatory;
                                        '   - type.
                                        strTblColumnName = objQuestionColumns(iCounter-1).getAttribute("text")

                                        If Not IsNull(objQuestionColumns(iCounter-1).getAttribute("maxlength")) AND objQuestionColumns(iCounter-1).getAttribute("maxlength") <> "*" Then
                                            lngTblFldMaxlength = CLng(objQuestionColumns(iCounter-1).getAttribute("maxlength"))
                                        Else
                                            lngTblFldMaxlength = Empty
                                        End If
                                            	    
                                        If Not IsNull(objQuestionColumns(iCounter-1).getAttribute("mandatory")) Then
                                            blnTblFldMandatory = CBool(objQuestionColumns(iCounter-1).getAttribute("mandatory"))
                                        Else
                                            blnTblFldMandatory = False
                                        End If

                                        'Need attribute type value to determine whether the the field is a date, in
                                        'order to carry out date type validation.
                                        If Not IsNull(objQuestionColumns(iCounter-1).getAttribute("type")) Then
                                            strColumnType = LCase(objQuestionColumns(iCounter-1).getAttribute("type"))
                                        Else
                                            strColumnType = Empty
                                        End If

                                        'Validate the current cell based on its XML attributes.
                                        If blnTblFldMandatory Then
                                            If Len(Trim(objCells(iCounter).value)) = 0 Then
                                                intTabIdx = GetTabIndex(objQuestionNode)
                                                strColId = objQuestionColumns(iCounter-1).getAttribute("id")
                                                strColTxt = strTblColumnName
                                                lngRowIdx = intRowCount

                                                Call PopulateErrorArray(arrErrors, lngArrRow, strQuestionID, strParentQuestionText & ": " & strQuestionText, intTabIdx, strQuestionType,lngRowIdx,strColId,strColTxt,MSG_MAND_MISSING)

                                                blnValidationErr = True
                                                'Increment error array rows
                                                lngArrRow = lngArrRow + 1
                                                'Check the size of the error array and redim if necessary
                                                If lngArrRow = Ubound(arrErrors, 2) Then
                                                    ReDim Preserve arrErrors(ARR_ERR_COLS, Ubound(arrErrors, 2) + ARR_ERR_ROWS_INCREMENT)
                                                End If
                                            	        
                                            End If
                                        End If

                                        If Not IsEmpty(lngTblFldMaxlength) Then
                                            blnSizeLimitOverFlow = (Len(objCells(iCounter).value) > MSG_SIZE_LIMIT)                         
                                            If (Len(objCells(iCounter).value) > lngTblFldMaxlength) Or (blnSizeLimitOverFlow) Then 'Its too big
                                                intTabIdx = GetTabIndex(objQuestionNode)
                                                strColId = objQuestionColumns(iCounter-1).getAttribute("id")
                                                strColTxt = strTblColumnName
                                                lngRowIdx = intRowCount

                                                If blnSizeLimitOverFlow Then
                                                    lngTblFldMaxlength = MSG_SIZE_LIMIT
                                                End If

                                                strMsgOverflow = ""
                                                strMsgOverflow = strMsgOverflow & "Number of characters entered " & " (" & Len(objCells(iCounter).value) & ") " 
                                                strMsgOverflow = strMsgOverflow & "exceeds maximum allowed (" & lngTblFldMaxlength & ")"

                                                Call PopulateErrorArray(arrErrors, lngArrRow, strQuestionID, strParentQuestionText & ": " & strQuestionText, intTabIdx, strQuestionType,lngRowIdx,strColId,strColTxt,strMsgOverflow)
                                                        
                                                blnValidationErr = True
                                                'Increment error array rows
                                                lngArrRow = lngArrRow + 1
                                                'Check the size of the error array and redim if necessary
                                                If lngArrRow = Ubound(arrErrors, 2) Then
                                                    ReDim Preserve arrErrors(ARR_ERR_COLS, Ubound(arrErrors, 2) + ARR_ERR_ROWS_INCREMENT)
                                                End If
                                                	    
                                            End If
                                        End If

                                        'If the column type is specified and the element is populated and of
                                        'type date, then validate it
                                        If Not IsEmpty(strColumnType) Then
                                            If strColumnType = "date" And Len(Trim(objCells(iCounter).value)) > 0 Then
                                                'If the date is invalid
                                                If validateDate(objCells(iCounter)) = False Then
                                                    'Obtain the necessary question column details
                                                    intTabIdx = GetTabIndex(objQuestionNode)
                                                    strColId  = objQuestionColumns(iCounter-1).getAttribute("id")
                                                    strColTxt = objQuestionColumns(iCounter-1).getAttribute("text")
                                                    lngRowIdx = intRowCount

                                                    'Populate the error array and increment error array rows.  Check
                                                    'the size of the error array and redim if necessary
                                                    Call PopulateErrorArray(arrErrors, lngArrRow, strQuestionID, strParentQuestionText & ": " & strQuestionText, intTabIdx, strQuestionType,lngRowIdx,strColId,strColTxt,MSG_INVALID_DATE)
                                                    lngArrRow = lngArrRow + 1
                                                    If lngArrRow = Ubound(arrErrors, 2) Then
                                                        ReDim Preserve arrErrors(ARR_ERR_COLS, Ubound(arrErrors, 2) + ARR_ERR_ROWS_INCREMENT)
                                                    End If

                                                    'Set the validation error flag to indicate that an error has
                                                    'occurred.
                                                    blnValidationErr = True
                                                End If
                                            End If
                                        End If
                                    Next
                                End If          
                            Next

                            Set objTbl = Nothing
                            Set objRows = Nothing
                            Set objQuestionColumns = Nothing
                            Set objQuestionRows = Nothing
                            Set objCells = Nothing

                        End Select

                    'Check the size of the error array and redim if necessary
                    If lngArrRow = Ubound(arrErrors, 2) Then
                        ReDim Preserve arrErrors(ARR_ERR_COLS, Ubound(arrErrors, 2) + ARR_ERR_ROWS_INCREMENT)
                    End If
                End If
            Next
        Else
            MsgBox("Could not obtain list of fields for validation.")
        End If
    End If

    If blnValidationErr Then
        document.all("protocolPage").style.height = document.all("resetHeight").value

            call ResizeWindow(document.body.offsetWidth+8,600)
           
                If Not blnIsLowRes Then
                    Call ResizeWindowBy(0, 150)
                End If
                document.all("clientValidationPage").style.overflow = "auto"
            

        strHTML = ""
        strHTML = strHTML & "<TABLE border=" & "1" & " width=" & chr(34) & "100%" & chr(34) & ">"
        'for each error in error array
        For lngCount=LBound(arrErrors,2) To UBound(arrErrors,2)

            'Find the type of field
            If LCase(Trim(arrErrors(TYPE_FLAG, lngCount))) =  "dynatable" OR LCase(Trim(arrErrors(TYPE_FLAG, lngCount))) = "table" OR LCase(Trim(arrErrors(TYPE_FLAG, lngCount))) = "gidynatable" Then  
                If (intRenderVersion = 2) Then
                    blnCanGetFocus = IAForms.canGetFocus(arrErrors(QUEST_ID, lngCount))
                Else
                    blnCanGetFocus = true
                End If

                If blnCanGetFocus Then
                    strHTML = strHTML & "<TR><TD><A onClick=" & chr(34) & "vbscript:call goToObject('" & arrErrors(QUEST_ID, lngCount) & _
                                                    "', '" & arrErrors(ROW_IDX, lngCount) & "','" & arrErrors(COL_ID, lngCount) & "')" & chr(34) & _
                                                    "class='errorLink' title=" & chr(34) & "Goto this field" & chr(34) & _
                                                    ">Column <B>" & arrErrors(COL_TXT, lngCount) & "</B> in row<B> " & arrErrors(ROW_IDX, lngCount)  & _
                                                    " </B>of table <B> " & arrErrors(QUEST_TXT, lngCount) & "</B></A></TD><TD class='errorValue'>" & _
                                                    arrErrors(MSG_TXT, lngCount) & "</TD></TR>"
                Else
                    strHTML = strHTML & "<TR><TD>Column <B>" & arrErrors(COL_TXT, lngCount) & "</B> in row<B> " & arrErrors(ROW_IDX, lngCount)  & _
                                                    " </B>of table <B> " & arrErrors(QUEST_TXT, lngCount) & "</B></TD><TD class='errorValue'>" & _
                                                    arrErrors(MSG_TXT, lngCount) & "</TD></TR>"
                End If
			Else
                If (intRenderVersion = 2) Then
                    blnCanGetFocus = IAForms.canGetFocus(arrErrors(QUEST_ID, lngCount))
                Else
                    blnCanGetFocus = true
                End If

                If blnCanGetFocus Then
                    strHTML = strHTML & "<TR><TD><A onClick=" & chr(34) & "vbscript:call goToObject('" & arrErrors(QUEST_ID, lngCount) & _
                                                "','','')" & chr(34) & " class='errorLink' title=" & chr(34) & "Goto this field" & chr(34) & _
                                                "><B>" & arrErrors(QUEST_TXT, lngCount) & "</B></A></TD><TD class='errorValue'>" & arrErrors(MSG_TXT, lngCount) & "</TD></TR>"
                Else
                    strHTML = strHTML & "<TR><TD><B>" & arrErrors(QUEST_TXT, lngCount) & "</B></TD><TD class='errorValue'>" & arrErrors(MSG_TXT, lngCount) & "</TD></TR>"
                End If
            End If
        Next
        strHTML = strHTML & "</TABLE>"

        document.all("errorTableHeader").innerHTML = "<P align=center><B>The following fields are missing or incorrect:</B></P>"
        ' The grave special character (`) is causing problems when setting the objForm.innerHTML as below. Encoding
        ' it with &#96; seems to work though. Note that there is the potential for other special characters to cause
        ' a problem here but for time being just replace the grave
        document.all("clientValidationPage").innerHTML =  replace(strHTML, "`", "&#96;")

        ValidateFields = False

        Exit Function
    Else
        document.all("protocolPage").style.height = document.all("originalHeight").value
        document.all("errorTableHeader").innerHTML = ""
        document.all("clientValidationPage").innerHTML = ""
        
        call ResizeWindow(document.body.offsetWidth+8,600)
        	      
        
        document.all("clientValidationPage").style.overflow = "visible"
    End If

End Function

Function PerformStdInputValidation(strQuestionId, strQuestionType, objQuestionNode, objField, blnQuestionMandatory, lngQuestionMaxLength)
'
' Description:  Validates date, text, textArea, select, check and radio inputs
'
' Parameters:   strQuestionId - The id of the question //question/@id
'               strQuestionType - The type of the question
'               objQuestionNode - The question node (of the protocol xml)
'               objField - The relevant field in the browser DOM
'               blnQuestionMandatory - Is the question mandatory / required?
'               lngQuestionMaxLength - What is the maximum length specified (Empty if no max length)
'
' Returns:      A tilde (~) separated string of validation error messages
'
    Const SEPARATOR              = "~"
    Const MSG_INVALID_DOB        = "Date of Birth cannot lie in future"
    Const MSG_INVALID_DATE       = "Invalid Date - Required format dd-mmm-yyyy"
    Const MSG_INVALID_REF_DATE   = "Referral Date cannot lie in future"

    Const MSG_MAND_MISSING       = "Value missing from mandatory field"
    Const MSG_OVERFLOW           = "Too many characters"
    Const MSG_INVALID            = "Incorrect Format"

    Dim strErrors                       'As String
    Dim strQuestionValidation           'As String
    Dim strInstruction                  'As String
    Dim blnChecked                      'As Boolean
    Dim intCounter                      'As Integer
    Dim intInputLength                  'As Integer
    Dim objValidationRules
    Dim objValidationRule

    strErrors = ""
    strQuestionValidation = LCase(objQuestionNode.getAttribute("validate"))

    Select Case LCase(strQuestionType)
        Case "date", "text", "textarea"
            If strQuestionType = "date" and Len(Trim(objField.Value)) > 0 Then
                If Not validateDate(objField) Then
                    strErrors = strErrors & MSG_INVALID_DATE & SEPARATOR
                Else If (Not IsNull(strQuestionValidation)) And (strQuestionValidation = "dob") Then
                    If Not PerformExplicitValidation(strQuestionValidation, objField, objQuestionNode, strInstruction) Then
                            strErrors = strErrors & MSG_INVALID & " (" & strInstruction & ")" & SEPARATOR
                        End If
                        'make sure the referral date is not a date greater than today
                        Else If (strQuestionID = "referral_date") Then
                            If Not PerformExplicitValidation(strQuestionID, objField, objQuestionNode, strInstruction) Then
                                strErrors = strErrors & MSG_INVALID_REF_DATE & SEPARATOR
                            End If
                        End If
                    End If
                End If
            End If    
                            
            'if the value is bigger than the size limit
            If Len(objField.Value) > MSG_SIZE_LIMIT Then
                strErrors = strErrors & "Number of characters entered " & " (" & Len(objField.Value) & ") " 
                strErrors = strErrors & "exceeds maximum allowed (" & CStr(MSG_SIZE_LIMIT) & ")" & SEPARATOR                        
            End If

            'If it is mandatory then check for input
            If blnQuestionMandatory Then
                If Len(Trim(objField.Value)) = 0 Then
		            strErrors = strErrors & MSG_MAND_MISSING & SEPARATOR
                End If
            End If

            'If we have a maxlength then check it if the field is populated
            intInputLength = Len(objField.Value)
            If Not IsEmpty(lngQuestionMaxlength) And intInputLength <> 0 Then
                If intInputLength > lngQuestionMaxlength Then
                    strErrors = strErrors & "Number of characters entered " & " (" & intInputLength & ") " 
                    strErrors = strErrors & "exceeds maximum allowed (" & lngQuestionMaxlength & ")" & SEPARATOR
                End If
            End If

            'If the field requires explicit validation and it isn't "date of birth" (which we
            'validated earlier) and a value exists, then validate
            If (Not IsNull(strQuestionValidation)) And (strQuestionValidation <> "dob") And (Len(Trim(objField.Value)) <> 0) Then
                If Not PerformExplicitValidation(strQuestionValidation, objField, objQuestionNode, strInstruction) Then
                    strErrors = strErrors & MSG_INVALID & " (" & strInstruction & ")" & SEPARATOR
                End If
            End If

            ' Perform any validations explicitly defined in validationRules in the protocol
            If Len(Trim(objField.Value)) > 0 Then
                strErrors = strErrors & performValidationRules(objQuestionNode, objField.Value)
            End If

        Case "radio"
            If blnQuestionMandatory Then
                'assume radio button is not checked
                blnChecked = False
                For intCounter = 0 to objField.Length - 1
                    'When a checked radio button is found there is no point in checking the rest
                    If objField.Item(intCounter).Checked Then
                        blnChecked = True
                            
                        'If we have a maxlength then check it if the field is populated
                        intInputLength = Len(objField.Item(intCounter).Value)
                        If Not IsEmpty(lngQuestionMaxlength) AND intInputLength <> 0 Then
                            If intInputLength > lngQuestionMaxlength Then
                                strErrors = strErrors & "Number of characters entered " & " (" & intInputLength & ") " 
                                strErrors = strErrors & "exceeds maximum allowed (" & lngQuestionMaxlength & ")" & SEPARATOR
                            End If
                        End If
                        Exit For
                    End If
                Next
                                    	
                If Not blnChecked Then
                    strErrors = strErrors & MSG_MAND_MISSING & SEPARATOR
                End If
            End If

        Case "check"
            If blnQuestionMandatory Then
                If Not CBool(objField.Checked) Then
                    strErrors = strErrors & MSG_MAND_MISSING & SEPARATOR
                End If
            End If

        Case "select"
            'If it is mandatory then check for input
            If blnQuestionMandatory Then
                If Len(Trim(objField.Value)) = 0 Then
                    strErrors = strErrors & MSG_MAND_MISSING & SEPARATOR
                End If
            End If
                            
            'If we have a maxlength then check it if the field is populated
            intInputLength = Len(objField.Value)
            If Not IsEmpty(lngQuestionMaxlength) AND intInputLength <> 0 Then
                If intInputLength > lngQuestionMaxlength Then
                    strErrors = strErrors & "Number of characters entered " & " (" & intInputLength & ") " 
                    strErrors = strErrors & "exceeds maximum allowed (" & lngQuestionMaxlength & ")" & SEPARATOR
                End If
            End If

        Case Else
            MsgBox "Unknown question type passed to PerformStdInputValidation (" & strQuestionType & ")" & vbCrLf &  "Please contact NISG Support", vbOK, "Unexpected client-side Error"
    End Select

    PerformStdInputValidation = strErrors
    Exit Function

End Function


Function PerformDynaTableColumnValidation(strQuestionId, objQuestionNode, objQuestionColumn, intRowIdx, intColIdx, objCell)
'
' Description:  Validates a column in a dynaTable (or giDynaTable) which may be a date, text, textArea, select, check or radio column
'
' Parameters:   strQuestionId - The id of the question (table) //question/@id
'               objQuestionNode - The question node (of the protocol xml)
'               objQuestionColumn - The column node of the protocol xml (a child of objQuestionNode)
'               intRowIdx - The row index on the dynaTable
'               intColIdx - The column index within the row
'               objCell - The DOM html td element for this cell
'
' Returns:      A tilde (~) separated string of validation error messages
'
    Const SEPARATOR              = "~"
    Const MSG_INVALID_DATE       = "Invalid Date - Required format dd-mmm-yyyy"
    Const MSG_MAND_MISSING       = "Value missing from mandatory field"
    Const MSG_OVERFLOW           = "Too many characters"
    Const MSG_INVALID            = "Incorrect Format"

    Dim strErrors               'As String
    Dim strColumnType           'As String
    Dim strColumnId             'As String
    Dim strAttributeValue       'As String
    Dim strValue                'As String
    Dim intMaxLength            'As Integer
    Dim blnMandatory            'As Boolean
    Dim objValidationRules
    Dim objInput

    
    strErrors = ""
    strColumnType = LCase(objQuestionColumn.getAttribute("type"))
    If IsNull(strColumnType) Then
        strColumnType = "text"
    End If

    strAttributeValue = objQuestionColumn.getAttribute("maxlength")
    If IsNull(strAttributeValue) Then
        intMaxLength = Empty
    Else
        intMaxLength = CInt(strAttributeValue)
    End If

    strAttributeValue = objQuestionColumn.getAttribute("mandatory")
    If IsNull(strAttributeValue) Then
        blnMandatory = False
    Else
        blnMandatory = LCase(strAttributeValue) = "true"
    End If

    Set objValidationRules = objQuestionColumn.selectNodes("validationRule")

    If (intMaxLength = Empty) And (blnMandatory = False) And (objValidationRules.Length = 0) And (strColumnType <> "date") Then
        PerformDynaTableColumnValidation = ""
        Exit Function
    End If

    strColumnId = objQuestionColumn.getAttribute("id")
    Set objInput = GetColumnDOMObject(objCell, strColumnType, strQuestionId, strColumnId, intRowIdx)
    If objInput Is Nothing Then ' GetColumnDOMObject returns nothing for a radio column with no selected option
        strValue = vbNullString
    Else
        strValue = objInput.Value
    End If

    If blnMandatory And Trim(strValue) = "" Then
        strErrors = strErrors & MSG_MAND_MISSING & SEPARATOR
    End If

    If intMaxLength <> Empty Then
        If Len(strValue) > intMaxLength Then
            strErrors = strErrors & "Number of characters entered " & " (" & Len(strValue) & ") " 
            strErrors = strErrors & "exceeds maximum allowed (" & intMaxLength & ")" & SEPARATOR
        End If
    End If

    If strColumnType = "date" Then
        If Not validateDate(objInput) Then
            strErrors = strErrors & MSG_INVALID_DATE & SEPARATOR
        End If        
    End If

    if Len(Trim(strValue)) > 0 Then
        strErrors = strErrors & performValidationRules(objQuestionColumn, strValue)
    End If

    PerformDynaTableColumnValidation = strErrors
    Exit Function

End Function

Function GetColumnDOMObject(objCell, strColumnType, strQuestionId, strColumnId, intRowIdx)
'
' Description:  Retrieve the correct DOM object (input, textArea, select, etc) for the passed column from the passed cell
'
' Parameters:   objCell - The DOM HTML (td) element for this cell
'               strColumnType - What type of column is this (text, textarea, date, select, radio, check)
'               strQuestionId - The id of the question (table) //question/@id
'               strColumnId - The id of the column //question/column/@id
'               intRowIdx - The row index
'
' Returns:      A tilde (~) separated string of validation error messages
'
    Dim objInputElements
    Dim objInput
    Dim strCellName

    Set GetColumnDOMObject = Nothing
    strCellName = strQuestionId & "___" & strColumnId & "_" & intRowIdx

    Select Case strColumnType
        Case "text", "date", "check", "radio"
            Set objInputElements = objCell.getElementsByTagName("input")
        Case "select"
            Set objInputElements = objCell.getElementsByTagName("select")
        Case "textarea"
            Set objInputElements = objCell.getElementsByTagName("textarea")
    End Select

    For Each objInput in objInputElements
        If objInput.GetAttribute("name") = strCellName Then
            If strColumnType <> "radio" Or objInput.GetAttribute("checked") Then
                Set GetColumnDOMObject = objInput
                Exit Function
            End If
        End If
    Next

    Exit Function

End Function

Function performValidationRules(objNode, value)
'
' Description:  Perform any validations explicitly defined in validationRules within the protocol
'
' Parameters:   objNode - The protocol node (element) which will have validationRules child elements, i.e. the question element or the column element
'               value - The value of the field to be validated
'
' Returns:      A tilde (~) separated string of validation error messages
'

    Const SEPARATOR = "~"
    Dim strMessages
    Dim objValidationRules, objValidationRule

    strMessages = ""

    'If the field has validationRules defined then action the rules
    Set objValidationRules = objNode.selectNodes("validationRule")
    For Each objValidationRule in objValidationRules
        If Not IAForms.testInputValue(objValidationRule.getAttribute("comparison"), objValidationRule.getAttribute("value"), value) Then
            strMessages = strMessages & objValidationRule.getAttribute("message") & SEPARATOR
        End If
    Next

    performValidationRules = strMessages
End Function

Function getInputValueByName(strObject, objCells)

    Dim objCell
    Dim objInput
    Dim strName, strValue
    Dim intStartPos, intEndPos, intLength

    strValue = ""

    'loop through all cells in row and get the value for the named object
    For Each objCell in objCells
		Set objInput = nothing

		If objCell.ChildNodes.Length > 0 then
	        Set objInput = objCell.ChildNodes(0)
	    End If

        'Moving the delete button to the left (TT54105) means we need to ignore the IMG element.
        If Not objInput Is Nothing AND TypeName(objInput) <> "HTMLImg" Then
            'get the name for the input field
            strName = objInput.name			

            strName = Mid(strName, (InStr(strName, "___") + Len("___")))

            intLength = InStr(strName, "_")-1

            strName = Mid(strName, 1, intLength) 

            If LCase(strName) = LCase(strObject) Then
                strValue = objInput.Value	
                Exit For
            End If
        End If
    Next

    getInputValueByName = strValue

End Function

Function checkForEmptyRow(objCells)

    Dim blnEmptyRow
    Dim objInputs
    Dim objInput
    Dim objCell

    blnEmptyRow = True
    'check that the row is empty
    For Each objCell in objCells
        Set objInputs = objCell.GetElementsByTagName("Input")

        If Not objInputs Is Nothing Then
            For Each objInput In objInputs
                If (typename(objInput) = "HTMLInputElement") Then
                    If (objInput.type <> "hidden") Then
                        If Len(Trim(objInput.value)) > 0 Then
                            blnEmptyRow = False
                            Exit For
                        End If
                    End If
                End If
            Next
        End If
    Next
    	                        
    checkForEmptyRow = blnEmptyRow

End Function

Function PopulateErrorArray(arrErrors, lngArrRow, strQuestionID, strQuestionText, intTabIdx, strQuestionType, lngRowIdx, strColId, strColTxt, strMessage)

    arrErrors(QUEST_ID, lngArrRow) = strQuestionID
    arrErrors(QUEST_TXT, lngArrRow) = strQuestionText
    arrErrors(ROW_IDX, lngArrRow) = lngRowIdx
    arrErrors(COL_ID, lngArrRow) = strColId
    arrErrors(COL_TXT, lngArrRow) = strColTxt
    arrErrors(TAB_IDX, lngArrRow) = intTabIdx
    arrErrors(MSG_TXT, lngArrRow) =     strMessage
    arrErrors(TYPE_FLAG, lngArrRow) = strQuestionType

End Function

                    
Function PerformExplicitValidation(strValidationType, objField, objQuestionNode, strInstruction)                  
'
' Description:  Validates values explicitly defined in the protocol xml.                                         
' Parameters:   strValidationType - postcode, chi, dob, unique_care_pathway_number, referral_date
'               objField - HTML Input element i.e. field containing value to be validated                
'               objQuestionNode - XML question node corresponing to objField    
'               strInstruction - message returned                 
' Returns:      True if valid, False otherwise
'

    Dim strPostCode, strMessage, strChiNumber, strDateOfBirth, strUniqueCarePathwayNumber, strNoChiValidation, strReferralDate, strHcn       
    Dim intSex, intSeverity, intValidationType
    Dim response        

    PerformExplicitValidation = True
    strInstruction = ""
    
    Select Case LCase(strValidationType)

        Case "postcode"
            'Must make postcodes uppercase to validate against schema
            objField.value = UCase(objField.value)
            strPostcode = objField.value
            If strPostcode <> "" Then
                If Not IsValidPostcode(strPostcode) Then                        
                    PerformExplicitValidation = False
                    Exit Function
                End If
            End If    
            
        case "hcn"
            strHcn = objField.value   
            If Not validateHCN(strHcn, intSeverity, strMessage) Then
                strInstruction = strMessage
                PerformExplicitValidation = False
                Exit Function
            End If
            
        Case "chi"
            'Pull CHI number out of the form
            strChiNumber = objField.value
            strNoChiValidation = LCase(objQuestionNode.getAttribute("no_chi"))
           
            If (LCase(strChiNumber) = "none") and (strNoChiValidation = "true") Then
                blnNoChiAccepted = true
            End If
            
            'Validate only if a CHI number has been specified
            If strChiNumber <> "" and Not blnNoChiAccepted Then
                'Determine the patient's sex; we know that exactly one of male or female
                'has been selected as it's a mandatory field.
                intValidationType = setValidationType()

                If intValidationType = CHI_DOB Or intValidationType = CHI_DOB_SEX Then
                    strDateOfBirth = document.all("patient_dob").value
                End If
                
                If intValidationType = CHI_SEX Or intValidationType = CHI_DOB_SEX Then
                    ' Determine the patient's sex; we know that exactly one of male or female
                    ' has been selected.
                    Dim patientSexControl
                    Set patientSexControl = document.getElementById("patient_sex")
                    Select Case UCase(patientSexControl.tagName)
                        Case "SELECT"
                            If UCase(patientSexControl.type) = "SELECT-ONE" Then
                                'The patient_sex field is a drop down list control
                                If document.all("patient_sex_1").selected Then
                                    intSex = MALE
                                Else
                                    intSex = FEMALE
                                End If
                            End If
                        Case "INPUT"
                            Select Case UCase(patientSexControl.type)
                                Case "RADIO"
                                    'The patient_sex field is a radio control
                                    If (Not document.all("patient_sex_1") Is Nothing) And (Not document.all("patient_sex_2") Is Nothing) Then
                                        'The sex is a radio box
                                        If document.all("patient_sex_1").checked Then
                                            intSex = MALE
                                        Else
                                            intSex = FEMALE
                                        End If
                                    End If
                            End Select
                    End Select
                End If
                
                If Not isValidChiNumber(strChiNumber, strDateOfBirth, intSex, intValidationType, intSeverity, strMessage) Then
                    If intSeverity = CHI_ERROR Then                            
                        If document.forms(FORM_ID)("chi").readonly Then ' Populated from GP system
                            strInstruction = "Please correct the CHI number in GP system. If a correct CHI number is not available please blank the field until it can be determined. You will then have to start a new message."
                        Else
                            strInstruction = "If a correct CHI number is not available, please leave the field blank, unless it is mandatory."
                        End If
                        PerformExplicitValidation = False
                        Exit Function
                    Else
                        strInstruction = "Please verify the CHI number and continue only if you believe it is correct."
                        If document.forms(FORM_ID)("chi").readonly Then ' Populated from GP system
                            strInstruction = strInstruction & " If you believe it is incorrect, please correct it in GP system. You will then have to start a new message."
                        Else
                            strInstruction = strInstruction & " If a correct CHI number is not available, please blank the CHI number field, unless it is mandatory."
                        End If
                        response = MsgBox("The entered CHI number does not match patient data: " & vbNewLine & vbNewline & _
                            strMessage & vbNewLine & vbNewline & strInstruction & vbNewline & vbNewline & "Do you wish to continue?", _
                            vbExclamation + vbYesNo, LOCALISED_APP_NAME)
                        'Allow the user to continue if they're sure
                        If response = vbNo Then PerformExplicitValidation = False
                        Exit Function
                    End If
                End If
            End If
            
        Case "dob"
            strDateOfBirth = objField.value
            If not IsValidDateOfBirth(strDateOfBirth, strMessage) Then
                strInstruction = strMessage
                PerformExplicitValidation = False
                Exit Function
            End If
            
	Case "referral_date"
            strReferralDate = objField.value
            If not IsValidReferralDate(strReferralDate) Then
                PerformExplicitValidation = False
                Exit Function
            End If            
            
        Case "unique_care_pathway_number"
            'Must make unique care pathway number uppercase to validate against schema
            objField.value = UCase(objField.value)
            strUniqueCarePathwayNumber = objField.value
            If strUniqueCarePathwayNumber <> "" Then
                If Not IsValidUniqueCarePathwayNumber(strUniqueCarePathwayNumber, strInstruction) Then                        
                    PerformExplicitValidation = False
                    Exit Function
                End If
            End If
    End Select

End Function

Function UpdateGPFields(objForm, blnCommit)     'As Boolean
'
' Description:  Checks the form for refGp and regGp fields, 
'               and uses the getGpIsdInfo service to fill non-populated fields
'
' Parameters:   objForm - the DHTML form object
'               blnCommit - are we commiting?
'
' Returns:      True is fields updated, False otherwise
'

    Dim sName           'As String
    Dim sSurname        'As String
    Dim sInitials       'As String
    Dim sGMCCode        'As String
    Dim sGPCode         'As String
    Dim sPracticeCode   'As String
    Dim intLastSpace    'As Integer
    Dim i               'As Integer
    Dim bMatch          'As Boolean
    Dim bReplace        'As Boolean
    Dim bPopulated      'As Boolean
    Dim bEmpty			'As Boolean
    Dim bContinue       'As Boolean
    Dim aPrefixes       'As Array
    Dim aUserText       'As Array
    Dim oName           'As DOM.Element
    Dim oGMCCode        'As DOM.Element
    Dim oGPCode         'As DOM.Element
    Dim oPracticeCode   'As DOM.Element
    Dim bGPDetails      'As Bool

    bGPDetails = True   'Assume there are GP Details to be updated

    'Message from a GP
    If (Not (document.all("regGP_gmc_code") Is Nothing)) and  (Not (document.all("refGP_gmc_code") Is Nothing)) Then
        aPrefixes = Array("regGp_", "refGp_")
        aUserText = Array("Registered GP details", "Referring GP details")
    'A Registered GP but no Referring GP on protocol
    ElseIf (Not (document.all("regGP_gmc_code") Is Nothing)) and (document.all("refGP_gmc_code") Is Nothing) Then
        aPrefixes = Array("regGp_")
        aUserText = Array("Registered GP details")
    'No Registered GP but a Referring GP on protocol
    ElseIf (document.all("regGP_gmc_code") Is Nothing) and (Not (document.all("refGP_gmc_code") Is Nothing)) Then
        aPrefixes = Array("refGp_")
        aUserText = Array("Referring GP details")
    Else
        'There is no Referring GP or Registered GP on protocol - will this ever be the case?
        bGPDetails = False
    End If

    bContinue = True

    If bGPDetails Then
        For i = 0 to UBound(aPrefixes)
            bMatch = False
            bReplace = False
            sInitials = ""
            sSurname = ""
            sGMCCode = ""
            sGPCode = ""
            sPracticeCode = ""

            'GP's surname    
            Set oName = objForm.elements.item(aPrefixes(i) & "name")

            If Not oName Is Nothing Then

                sSurname = oName.value
                If Len(sSurname) > 0 Then

                    'Get the surname by reversing the unstructured name & searching on the first space.
                    'NOTE: this assumes the surname will entirely comprise the last space-delimited field.
                    sSurname = Trim(StrReverse(sSurname))

                    intLastSpace = InStr(sSurname, " ")
                    If intLastSpace > 0 Then
                        sSurname = StrReverse(Left(sSurname, intLastSpace - 1))
                    Else
                        sSurname = oName.value
                    End If
                End If
            End If

            'GMC code
            Set oGMCCode = objForm.elements.item(aPrefixes(i) & "gmc_code")
            If Not oGMCCode Is Nothing Then
                sGMCCode = oGMCCode.value
            End If

            'GP code
            Set oGPCode = objForm.elements.item(aPrefixes(i) & "code")
            If Not oGPCode Is Nothing Then
                If Len(oGPCode.value) > 5 Then
                    sGPCode = Right(oGPCode.value, 5)
                    bReplace = True
                Else
                    sGPCode = oGPCode.value
                End If
            End If

            'GP practice code
            Set oPracticeCode = objForm.elements.item(aPrefixes(i) & "practice_code")
            If Not oPracticeCode Is Nothing Then
                sPracticeCode = oPracticeCode.value
            End If

            'Check whether all the fields were populated
            bPopulated = Len(sSurname) > 0 _
                            And Len(sGMCCode) > 0 _
                            And Len(sGPCode) > 0 _
                            And Len(sPracticeCode) > 0 
            	            
            bEmpty = Len(sSurname) <= 0 _
                            And Len(sGMCCode) <= 0 _
                            And Len(sGPCode) <= 0 _
                            And Len(sPracticeCode) <= 0 

            If Not bEmpty Then
                'Search ISD data
                bMatch = callGetISDInfo(sSurname, sGMCCode, sGPCode, sPracticeCode, sInitials)

                'If they haven't typed it all in themselves, or we've switched their GP code, request to replace.
                If Not bPopulated Then
                    If bMatch Then
                        'Build unstructured name.
                        sName = "Dr " & sInitials & " " & sSurname

                        bReplace = MsgBox( _
                                        "Matching " & aUserText(i) & " were found." & vbNewLine & _
                                        vbNewLine & _
                                        "  Name:         " & vbTab & sName & vbNewLine & _
                                        "  GMC Code:     " & vbTab & sGMCCode & vbNewLine & _
                                        "  GP Code:      " & vbTab & sGPCode & vbNewLine & _
                                        "  Practice Code:" & vbTab & sPracticeCode & vbNewLine & _
                                        vbNewLine & _
                                        "Update message with these values?" _
                                        , vbYesNo , aUserText(i) _
                                        ) = vbYes 

                        'Switch the values in.
                        If bReplace Then
                            If Not oName Is Nothing Then
                                oName.value = sName
                            End If
                            If Not oGMCCode Is Nothing Then
                                oGMCCode.value = sGMCCode
                            End If

                            If Not oGPCode Is Nothing Then
                                oGPCode.value = sGPCode
                            End If

                            If Not oPracticeCode Is Nothing Then
                                oPracticeCode.value = sPracticeCode
                            End If
                        ElseIf blnCommit Then
                            If MsgBox( "Unable to find a unique match for the provided " & aUserText(i) & "." & vbNewLine & _
                                        "Are you sure you wish to continue with these details?",  _
                                        vbYesNo , aUserText(i) ) = vbNo Then
                                bContinue = False
                                Exit For
                            End If
                        End If
                    ElseIf blnCommit Then

                        If MsgBox( "Unable to find a unique match for the provided " & aUserText(i) & "." & vbNewLine & _
                                    "Are you sure you wish to continue with these details?",  _
                                    vbYesNo , aUserText(i) ) = vbNo Then
                            bContinue = False
                            Exit For
                        End If

                    End If
                End If
            End If
        Next
    End If

    UpdateGPFields = bContinue
    
End Function

Function CallGetISDInfo(sSurname, sGMCCode, sGPCode, sPracticeCode, sInitials) 'As Boolean
'
' Description:  Performs the service request to search for GP details
' Parameters:   sSurname        - the GP surname to search on, also returned
'               sGMCCode        - the GMC code to search on, also returned
'               sGPCode         - the GP code to search on, also returned
'               sPracticeCode   - the practice code to search on, also returned
'               sInitials       - initials returned
' Return:       True if match found, False otherwise
'  

    Dim msgIn            'As String
    Dim msgOut           'As some sort of DOM object
    Dim sForename        'As String
    Dim bMatch           'As Boolean
    Dim oNodeList        
    Dim oNode
    Dim strSessionId        'As String
    Dim strGatewayServices  'As String

    'for backwards compatability
    strSessionId        =   document.all("fldSessionKey").value
    strGatewayServices  =   document.all("fldGatewayServices").value

    'Default is no match found
    bMatch = False

    'Send the XML request
    msgIn = "<getGpIsdInfo_request>" & _
            "<gmc_code>" & sGMCCode & "</gmc_code>" & _
            "<gp_code>" & sGPCode & "</gp_code>" & _
            "<surname>" & sSurname & "</surname>" & _
            "<forename></forename>" & _
            "<initials></initials>" & _
            "<practice_code>" & sPracticeCode & "</practice_code>" & _
            "<search_date></search_date>" & _
            "</getGpIsdInfo_request>"

    Set msgOut = runFallbackWithSession(msgIn, strGatewayServices, strSessionId) 'dispatch the request

    'Check the response for a unique match    
    If ( Not msgOut Is Nothing ) Then

        Set oNodeList = msgOut.selectNodes("//getGpIsdInfo_response/*")
        For Each oNode In oNodeList
            Select Case oNode.nodeName
                Case "gmc_code"
                    sGMCCode = oNode.text                       
                Case "gp_code"
                    sGPCode = oNode.text
                Case "surname"    'Replace surname with assumed capitalisation if it didn't previously exist.
                    If Len(sSurname) = 0 Then 
                        If Len(oNode.text) > 0 Then
                            sSurname = UCase(Left(oNode.text, 1)) & LCase(Mid(oNode.text, 2))
                        End If
                    End If
                Case "initials"
                    sInitials = oNode.text
                Case "practice_code"
                    sPracticeCode = oNode.text
                Case "forename"
                    sForename = oNode.text
                Case "match_made"
                    'Return match status
                    bMatch = CBool(oNode.text)
                    'If there is no match get out
                    If Not bMatch Then
                        Exit For
                    End If
                Case Else
            End Select
        Next
    End If

    'Cleanup
    Set oNodeList = Nothing
    Set oNode = Nothing
    Set msgOut = Nothing
    'Return match status
    CallGetISDInfo = bMatch

End Function

Sub EnableFormElements()
'
' Description:  Performs any last minute initialisation, and can set all message form 
'               elements to be writable.
' Parameters:   None
'

    Dim objElement      'As Object

    'Make read-only fields writable
    If Not document.forms(FORM_ID) Is Nothing Then
        'Loop through each form element
        For Each objElement In document.forms(FORM_ID)
			' Only <INPUT type="text" or type="password"> or <TEXTAREA> elements have a readOnly property
			If (UCase(objElement.TagName) = "INPUT") Or (UCase(objElement.TagName) = "TEXTAREA") Then
				If (UCase(objElement.type) = "TEXT") Or (UCase(objElement.type) = "TEXTAREA") Or (UCase(objElement.type) = "PASSWORD") Then
					' Don't make the consultant questions writable
					If Not (UCase(objElement.name) = "HCP_ID" OR UCase(objElement.name) = "HCP_SURNAME" OR UCase(objElement.name) = "HCP_FORENAME" OR UCase(objElement.name) = "HCP_FULLNAME") Then
						objElement.readOnly = False
					End If
				End If
			End If
        Next

    End If

    Set objElement = Nothing

End Sub

Function correctCHINumber()     

    Dim strCHI

    'Test Track 50141: Chi number can come through without leading 0. Add it here.
    strCHI = document.forms(FORM_ID).elements.item("chi").value
    If Len(strCHI) = 9 Then
        strCHI = "0" & document.forms(FORM_ID).elements.item("chi").value
        document.forms(FORM_ID).elements.item("chi").value = strCHI
    End If
    	
    'If CHI number is blank, it comes through as 0.  Make the field blank if 
    'this happens.
    If strCHI = "0" Then
        strCHI = ""
        document.forms(FORM_ID).elements.item("chi").value = strCHI
    End If

End Function

Function IsValidPostcode(patientPostcode)
'
' Description:  Validates a postcode against a pattern
' Parameters:   patientPostcode - Postcode
' Returns:      True if valid, False otherwise
'

    Dim objRegExpr
    Dim Match

    IsValidPostcode = True      'Assume postcode is valid

    Set objRegExpr = New regexp

    'Official formatting of postcodes may change over time. 
    'This pattern may need adjustment to bring it up to date.

    objRegExpr.Pattern =    "^[A-Z]{1,2}[0-9]([0-9]|[A-Z])?( [0-9][A-Z]{2}) ?$"
    objRegExpr.Global = True
    objRegExpr.IgnoreCase = False
    Set Match = objRegExpr.Execute(patientPostcode)

    If Match.Count = 0 Then 'we don't have a match 
        IsValidPostcode = False
    End If

    'Clean up
    Set Match = Nothing
    Set objRegExpr = Nothing

End Function

Function IsValidUniqueCarePathwayNumber(strUniqueCarePathwayNumber, strInstruction)
'
' Description:  Validates a unique care pathway number
' Parameters:   strUniqueCarePathwayNumber - unique care pathway number
'               strInstruction - description of problem
' Returns:      True if valid, False otherwise
'
    Dim i
    
    IsValidUniqueCarePathwayNumber = True
    
    if Len(strUniqueCarePathwayNumber) <> 13 Then
        IsValidUniqueCarePathwayNumber = False
        strInstruction = "Must be 13 characters in length."
        Exit Function
    End If
    
    if Mid(strUniqueCarePathwayNumber, 4, 9) = "000000000" Then
        IsValidUniqueCarePathwayNumber = False
        strInstruction = "Rolling number cannot be zero."
        Exit Function
    End If
    
    For i = 1 To Len(strUniqueCarePathwayNumber)
        Select Case i
            Case 1
                If InStr("123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ", Mid(strUniqueCarePathwayNumber, i, 1)) = 0 Then
                    IsValidUniqueCarePathwayNumber = False
                    strInstruction = "The first character must be 1-9 or A-Z."
                    Exit For
                End If
            case 2, 3
                If InStr("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ", Mid(strUniqueCarePathwayNumber, i, 1)) = 0 Then
                    IsValidUniqueCarePathwayNumber = False
                    strInstruction = "The second and third characters must be 1-9 or A-Z."
                    Exit For
                End If
            case 13
                If Not ValidateLuhnMod36CheckCharacter(strUniqueCarePathwayNumber) Then
                    IsValidUniqueCarePathwayNumber = False
                    strInstruction = "Check digit is invalid."
                    Exit For
                End If
            Case Else '4-12
                If InStr("0123456789", Mid(strUniqueCarePathwayNumber, i, 1)) = 0 Then
                    IsValidUniqueCarePathwayNumber = False
                    strInstruction = "Characters 4 to 12 must be numeric."
                    Exit For
                End If
        End Select     
    Next
End Function

Sub disableButtons(blnDisable)

    Dim objButton

    If Not document.all("trButtons").childNodes Is Nothing Then
        For Each objButton in document.all("trButtons").childNodes
            If objButton.nodeName <> "#text" Then
                objButton.disabled = blnDisable
            End If
        Next
    End If

End Sub

Sub MakeFieldsReadOnly()
'
' Description:  Makes specialty, hospital and protocol name fields read-only.
'               'Test Track 51520 and 50922
' Parameters:   None

    Dim blnConsultantSelected

    If not document.all("specialtyRef") is nothing then
        If not VBMatchElementType("specialtyRef", "HTMLSelectElement") Then
            If document.all("specialtyRef").value = "n.k." then
                document.all("specialtyRef").value = ""
            End if
        End If
    End if

    If not document.all("Specialty") is nothing then
        If not VBMatchElementType("Specialty", "HTMLSelectElement") Then
            If document.all("Specialty").value = "Specialty name not known" then
                document.all("Specialty").value = ""
            End if
            If not document.all("Specialty").value = "" then
                document.all("Specialty").readOnly = true
            End if
        End If
    End if
        
    If not document.all("Hospital_ID") is nothing then
        If not VBMatchElementType("Hospital_ID", "HTMLSelectElement") Then
            If not document.all("Hospital_ID").value = "" then
                document.all("Hospital_ID").readOnly = true
            End if
        End If
    End If
        
    If not document.all("Hospital_Name") is nothing then
        If not VBMatchElementType("Hospital_Name", "HTMLSelectElement") Then
            If not document.all("Hospital_Name").value = "" then
                document.all("Hospital_Name").readOnly = true
            End if
        End If
    End if    
    
    If not document.all("Protocol") is nothing then
        document.all("Protocol").readOnly = true
    end if

    ' Consultant questions should be marked readonly if a sepcific consultant was selected from the drop down but
    ' editable if Any Available was selected. In addition they can be marked as read only in the protocol xml in
    ' which case they are always read only regardless of what was selected.
    blnConsultantSelected= False
    If Not document.protocolInfo("ConsultantID") Is Nothing Then
        If Len(document.protocolInfo("ConsultantID").value) > 0 Then
            blnConsultantSelected = True
        End If
    End If

    If Not document.formref("hcp_id") Is Nothing Then
        If blnConsultantSelected Then
            document.formref("hcp_id").readonly = True
        End If
    End If

    If Not document.formref("hcp_forename") Is Nothing Then
        If blnConsultantSelected Then
            document.formref("hcp_forename").readonly = True
        End If
    End If

    If Not document.formref("hcp_surname") Is Nothing Then
        If blnConsultantSelected Then
            document.formref("hcp_surname").readonly = True
        End If
    End If

    If Not document.formref("hcp_fullname") Is Nothing Then
        If blnConsultantSelected Then
            document.formref("hcp_fullname").readonly = True
        End If
    End If

End Sub

Function setValidationType()

    Dim blnSex
    Dim blnDob
    Dim intValidationType

    blnSex = (Not document.all("patient_sex_1") Is Nothing)
    blnDob = (Not document.all("patient_dob") Is Nothing)

    If blnSex And blnDob Then
        intValidationType = CHI_DOB_SEX
    ElseIf blnSex And (Not blnDob) Then
        intValidationType = CHI_SEX
    ElseIf blnDob And (Not blnSex) Then
        intValidationType = CHI_DOB
    ElseIf (Not blnDob) And (Not blnSex) Then
        intValidationType = CHI_FORMAT_ONLY
    End If  

    setValidationType = intValidationType

End Function

Function WindowUnloadHandler()

    'close the preview letter window if it is open
    On Error Resume Next
    If g_objPreviewWin.name <> "RefLetter_" & GetUniqueId() Then
        Exit Function
    Else
        g_objPreviewWin.close
    End If
    On Error GoTo 0

End Function

Function MsgWindowClose()
    MsgWindowClose = msgbox("Do you want to close this window?" & vbNewLine & _
        "Any changes that have been made will be lost.", vbYesNo, "Close Window") 
End Function

Sub RunSpellCheck(objTextControl)
'
' Description:  Run spell check on a textarea or text box
' Parameters:   objTextControl - control to spell check
'
    Call onCheckSpellingBtnASP(objTextControl.name)     ' in SubmitSpelling.js
End Sub

Sub RunSpellCheckColumn(sTableId, sColumnId)
'
' Description:  Run spell check on a table or dynatable column
' Parameters:   sTableId - id of table to spell check
'               sColumnId - id of column to spell check
'
    Dim sRowCount
    Dim i
    Dim sTextBoxName
    Dim sTextBoxNames

    ' construct the text box names for the entire column
    sRowCount = Document.GetElementById(sTableId & "_rowCount").value
    For i = 1 To CInt(sRowCount)
        sTextBoxName = sTableId & "___" & sColumnId & "_" & i
        sTextBoxNames = sTextBoxNames & sTextBoxName
        If i < CInt(sRowCount) Then
            sTextBoxNames = sTextBoxNames & ","
        End If
    Next
    onCheckSpellingBtnASP(sTextBoxNames)            ' in SubmitSpelling.js

End Sub